<?php 
function WPTCAddonMenus(&$menus){
	//$menus[] = '<li><a class="navLinks optionSelect" page="malwareSecurity">Malware Scan</a></li>';
	$menus['protect']['subMenus'][] = array('page' => 'WPTC', 'displayName' => 'WP Time Capsule');
}

function WPTCMainPageHTML(){
	$WPTCAccessToken = getOption('WPTCAccessToken');
	$WPTCUserDetails = unserialize(getOption('WPTCUserDetails'));
	$URL = getOption('WPTCServiceURL')."iwp-service.php";
	$requestArray['email'] = $WPTCUserDetails['email'];
	$requestArray['action'] = 'iwp_service_action';
	list($results, $curlInfo) = WPTCDoCall($URL, $requestArray, $WPTCAccessToken);
	$cURLErrors = new cURLErrors($curlInfo);
	if (!$cURLErrors->isOk()) {
		addNotification($type='E', $title='CONNECTION ERROR', $message=$cURLErrors->getErrorMsg(), $state='U', $callbackOnClose='', $callbackReference='');
		return false;
	}
	WPTCRemoveResponseJunk($results);
	$results = json_decode($results, true);
	if (empty($results) && empty($results['success']) ) {
		addNotification($type='E', $title='RESPONSE ERROR', $message="Please try again...", $state='U', $callbackOnClose='', $callbackReference='');
		return false;
	}elseif(!empty($results['error'])){
		addNotification($type='E', $title='WPTC CONNECTION ERROR', $message=$results['error']['extra'], $state='U', $callbackOnClose='', $callbackReference='');
	}
	WPTCFormatResponseArray($results);
	uasort($results['success'], "WPTCSortByName");
	$HTML = TPL::get('/addons/WPTC/templates/WPTCView.tpl.php', $results);
	return $HTML;
}

function WPTCSortByName($a, $b) {
	if(is_array($a) && is_array($b)){
	 return strcmp($a['name'], $b['name']);
	}
	return false;
}

function WPTCGrantAccess($params){
	// $signUpDetails = $params['userDetails'];
	$URL = getOption('WPTCServiceURL')."iwp-service.php";
	$signUpDetails ['action']= 'iwp_service_action';
	$signUpDetails ['type']= 'signup';
	$signUpDetails ['email']= $params['userDetails']['email'];
	$signUpDetails ['pwd']= base64_encode(md5($params['userDetails']['password']));
	list($results, $curlInfo) = WPTCDoCall($URL,$signUpDetails);
	$cURLErrors = new cURLErrors($curlInfo);
	if (!$cURLErrors->isOk()) {
		addNotification($type='E', $title='WPTC CONNECTION ERROR', $message=$cURLErrors->getErrorMsg(), $state='U', $callbackOnClose='', $callbackReference='');
		return false;
	}
	WPTCRemoveResponseJunk($results);
	$results = json_decode($results, true);
	if (empty($results) && empty($results['success']) ) {
		addNotification($type='E', $title='WPTC RESPONSE ERROR', $message="Please try again...", $state='U', $callbackOnClose='', $callbackReference='');
		return false;
	}elseif(!empty($results['error'])){
		addNotification($type='E', $title='WPTC CONNECTION ERROR', $message=$results['error']['extra'], $state='U', $callbackOnClose='', $callbackReference='');
	}elseif(!empty($results['success']['iwp_token'])){
		addNotification($type='N', $title='WPTC GRANT ACCESS', $message='Successfully Granted', $state='U', $callbackOnClose='', $callbackReference='');
	}
	$WPTCIsGrant = false;
	if ($results['success']['iwp_token']) {
		updateOption('WPTCAccessToken', $results['success']['iwp_token']);
		$WPTCIsGrant = true;
	}
	updateOption('WPTCUserDetails', serialize($params['userDetails']));
	return array('WPTCIsGrant' => $WPTCIsGrant, 'WPTCUserDetails'=> $params['userDetails']);

}

function WPTCRevokeAccess($data){
	$WPTCAccessToken = getOption('WPTCAccessToken');
	$WPTCUserDetails = unserialize(getOption('WPTCUserDetails'));
	$URL = getOption('WPTCServiceURL')."iwp-service.php";
	$requestArray['email'] = $WPTCUserDetails['email'];
	$requestArray['action'] = 'iwp_service_action';
	$requestArray['type'] = 'revoke';
	list($results, $curlInfo) = WPTCDoCall($URL, $requestArray, $WPTCAccessToken);
	$cURLErrors = new cURLErrors($curlInfo);
	if (!$cURLErrors->isOk()) {
		addNotification($type='E', $title='CONNECTION ERROR', $message=$cURLErrors->getErrorMsg(), $state='U', $callbackOnClose='', $callbackReference='');
		return false;
	}
	WPTCRemoveResponseJunk($results);
	$results = json_decode($results, true);
	if (empty($results) && empty($results['success']) ) {
		addNotification($type='E', $title='RESPONSE ERROR', $message="Please try again...", $state='U', $callbackOnClose='', $callbackReference='');
		return false;
	}
	if (!empty($results) && !empty($results['error']) ) {
		addNotification($type='E', $title='RESPONSE ERROR', $message=$results['error']['extra'], $state='U', $callbackOnClose='', $callbackReference='');
	}elseif(!empty($results['success'])){
		addNotification($type='N', $title='WPTC REVOKE ACCESS', $message='Successfully Revoked', $state='U', $callbackOnClose='', $callbackReference='');
	}
	//if ($results['success']['msg'] == 'Sucessfully Revoked.') { This is no need right now some cases
		updateOption('WPTCAccessToken', '');
		return array('WPTCIsRevoke' => true);
	//}
	return false;
}

function WPTCSettingDetails(){
	$WPTCUserDetails = unserialize(getOption('WPTCUserDetails'));
	$WPTCAccessToken = getOption('WPTCAccessToken');
	$WPTCIsGrant = false;
	if (!empty($WPTCAccessToken)) {
		$WPTCIsGrant = true;
	}
	return array('WPTCIsGrant' => $WPTCIsGrant, 'WPTCUserDetails'=> $WPTCUserDetails);
}

function WPTCDoCall($URL, $data, $accessToken = ''){
	$HTTPCustomHeaders = array();
	$ch = curl_init($URL);
	curl_setopt($ch, CURLOPT_URL, $URL);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_MAXREDIRS, 2);
	curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
	curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36');
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  false );
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_TIMEOUT, 60);
	curl_setopt($ch, CURLOPT_HEADER, true);
	$contentType = 'application/x-www-form-urlencoded';
	$HTTPCustomHeaders[] = 'Content-Type: '.trim($contentType);//before array('Content-Type: text/plain') //multipart/form-data
	if (!empty($accessToken)) {
		$HTTPCustomHeaders[] = "Authorization: $accessToken";
	}
	curl_setopt($ch, CURLOPT_HTTPHEADER, $HTTPCustomHeaders);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS,  base64_encode(jsonEncoder($data)));
	$rawResponse = curl_exec($ch);
	$curlInfo = array();
	$curlInfo['info'] = curl_getinfo($ch);
	if(curl_errno($ch)){
		$curlInfo['errorNo'] = curl_errno($ch);
		$curlInfo['error'] = curl_error($ch);
	}
	       	
	curl_close($ch);
	list($responseHeader, $responseBody) = bifurcateResponse($rawResponse, $curlInfo);
	
	return array($responseBody, $curlInfo, $responseHeader);
}
function WPTCRemoveResponseJunk(&$response){
	$headerPos = stripos($response, '<WPTC_START');
	if($headerPos !== false){
		$response = substr($response, $headerPos);
		$response = substr($response, strlen('<WPTC_START>'), stripos($response, '<WPTC_END')-strlen('<WPTC_START>'));
	}
}

function WPTCFormatResponseArray(&$response){
	$sitesData = getSitesData();
	foreach ($response['success'] as $key => $data) {
		$isWPTCSite = false;
		if (empty($data['cron_url'])) {
			unset($response['success'][$key]);
			continue;
		}
		if (!empty($data['cloud_account']) && isset($data['cloud_account'])) {
			$response['success'][$key]['cloud_account'] = ($data['cloud_account'] == 's3')?'Amazon S3':(($data['cloud_account'] == 'g_drive')?'Google Drive':'Dropbox');
		}
		foreach ($sitesData as $siteID => $siteData) {
			if (trim(str_replace(array('www.','https://','http://'),'',$siteData['URL']),'/') == trim(str_replace(array('www.','https://','http://'),'',$data['cron_url']),'/')) {
				$response['success'][$key]['name'] = $siteData['name'];
				$response['success'][$key]['siteID'] = $siteData['siteID'];
				$isWPTCSite = true;
			}
		}
		if ($isWPTCSite == false) {
			unset($response['success'][$key]);
		}
	}
}
function WPTCHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('WPTC');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/WPTC/css/WPTC.css')),
		array('js' => array('href' => 'addons/WPTC/js/init.js')),
		array('js' => array('href' => 'addons/WPTC/js/load.js')),
	);
	$headFiles['WPTC'] = $addonDetails;
	$WPTCIsGrantAccess = WPTCSettingDetails();
	?>
	<script >
		var WPTCIsGrantAccess='<?php echo $WPTCIsGrantAccess["WPTCIsGrant"] ?>';
	</script>
	<?php
}

