<?php
	
function WPVulnsUdateWpVulnsDataInLocal($WPVulnsData){
	if (empty($WPVulnsData['plugins']) || empty($WPVulnsData['themes']) || empty($WPVulnsData['wp'])) {
		return false;
	}
	updateOption('newWPVulnsHash', $WPVulnsData['WPVulnsHash']);
	updateOption('oldWPVulnsHash', $WPVulnsData['WPVulnsHash']);
	if (!WPVulnsIsExitWpVulnsData()) {
		WPVulnsInsertWPVulnsData($WPVulnsData);
		return true;
	}
	DB::update("?:wpvulns_db", array('optionName' => 'wp', 'optionValue' => $WPVulnsData['wp']), "optionName = 'wp'");
	DB::update("?:wpvulns_db", array('optionName' => 'plugins', 'optionValue' => $WPVulnsData['plugins']), "optionName = 'plugins'");
	DB::update("?:wpvulns_db", array('optionName' => 'themes', 'optionValue' => $WPVulnsData['themes']), "optionName = 'themes'");
}

function WPVulnsInsertWPVulnsData($WPVulnsData){
	DB::insert("?:wpvulns_db", array('optionName' => 'wp', 'optionValue' => $WPVulnsData['wp']));
	DB::insert("?:wpvulns_db", array('optionName' => 'plugins', 'optionValue' => $WPVulnsData['plugins']));
	DB::insert("?:wpvulns_db", array('optionName' => 'themes', 'optionValue' => $WPVulnsData['themes']));
	updateOption('newWPVulnsHash', $WPVulnsData['WPVulnsHash']);
	updateOption('oldWPVulnsHash', $WPVulnsData['WPVulnsHash']);
}

function WPVulnsIsExitWpVulnsData(){
	return DB::getExists("?:wpvulns_db", "optionName", "optionName = 'plugins'");
}

function WPVulnsGetWpVulnsData(){
	$WPVulnsData = array();
	$WPVulnsData['plugins']     = DB::getField("?:wpvulns_db", "optionValue", "optionName = 'plugins'");
	$WPVulnsData['wp']          = DB::getField("?:wpvulns_db", "optionValue", "optionName = 'wp'");
	$WPVulnsData['themes']      = DB::getField("?:wpvulns_db", "optionValue", "optionName = 'themes'");
	$WPVulnsData = WPVulnsCheckCompressed($WPVulnsData);
	if (!$WPVulnsData) {
		return false;
	}
	return $WPVulnsData;
}

function WPVulnsGetAffectedVulnsData($pluginView, $themeView, $coreView){
	$WPVulnsData = WPVulnsGetWpVulnsData();
	$WPVulnsData['plugins'] = json_decode($WPVulnsData['plugins'], true);
	$WPVulnsData['themes'] = json_decode($WPVulnsData['themes'], true);
	$WPVulnsData['wp'] = json_decode($WPVulnsData['wp'], true);
	$affectedPluginVulnsData = array();
	$affectedThemeVulnsData = array();
	$affectedWPVulnsData = array();
	if (empty($WPVulnsData['plugins']) || empty($WPVulnsData['themes']) || empty($WPVulnsData['wp'])) {
		return false;
	}
	$affectedPluginVulnsData = WPVulnsFilterAffectedData($WPVulnsData['plugins'], $pluginView, 'slug');
	$affectedThemeVulnsData = WPVulnsFilterAffectedData($WPVulnsData['themes'], $themeView, 'theme');
	$affectedWPVulnsData = WPVulnsFilterAffectedData($WPVulnsData['wp'], $coreView, 'current_version');

	return $affectedVulnsData = array('plugins'=>$affectedPluginVulnsData, 'themes' => $affectedThemeVulnsData, 'wp' => $affectedWPVulnsData);
}

function WPVulnsFilterAffectedData($vulnsDB, $viewData, $keyElement){
	$affectedData = array();
	foreach ($vulnsDB as $vulnsSlug) {
		foreach ($viewData as $viewName) {
			foreach ($viewName as $view) {
				foreach ($view as $key) {
					if (key($vulnsSlug) == $key[$keyElement]) {
						array_push($affectedData, $vulnsSlug);
						break;
					}
				}
			}
		}
	}
	return $affectedData;
}

function WPVulnsUpdateCheck($result){
	if(!empty($result['WPVulnsHash'])){
		updateOption('newWPVulnsHash', $result['WPVulnsHash']);
		WPVulnsDownloadVulnsDB();
	}

}

function WPVulnsDownloadVulnsDB(){
	$newWPVulnsHash = getOption('newWPVulnsHash');
	$oldWPVulnsHash = getOption('oldWPVulnsHash');
	if (empty($newWPVulnsHash) || $newWPVulnsHash != $oldWPVulnsHash) {
		$URL = getOption('serviceURL').'WPVulnsUpdate.php';
		$URL .= '?appVersion='.APP_VERSION.'&appInstallHash='.APP_INSTALL_HASH.'&installedHash='.getInstalledHash();
		$gzUnZip = WPVulnsCheckZipSupport();
		if ($gzUnZip) {
			$gzUnZip = 0;
		} else{
			$gzUnZip = 1;
		}
		$URL .='&gzUnZip='.$gzUnZip;
		$temp = doCall($URL, '', $timeout=30);
		list($result, , , $curlInfo) = $temp;

		$result = getServiceResponseToArray($result);
		$curlErrors = new curlErrors($curlInfo);

		if(!$curlErrors->isOk()){
			return false;
		}

		if(empty($result)){
			//response error
			return false;
		}
		if (!empty($result['WPVulnsData'])) {
			WPVulnsUdateWpVulnsDataInLocal($result['WPVulnsData']);
		}

	}
}

function WPVulnsUpdateViews(&$updateViews){
	$getVulData =  WPVulnsGetAffectedVulnsData($updateViews['pluginsView'], $updateViews['themesView'], $updateViews['coreView']);
	if (!empty($getVulData)) {
		$updateViews['wpVulView'] =  $getVulData;
	}
}

function WPVulnsCheckCompressed($WPVulnsData){
	if (is_array(json_decode($WPVulnsData['plugins'])) && is_array(json_decode($WPVulnsData['themes'])) && is_array(json_decode($WPVulnsData['wp']))) {
		return $WPVulnsData;
	}
	$wpVulnsPluginTemp = explode('_|_coMpResSed_|_', base64_decode($WPVulnsData['plugins']));
	$wpVulnsWPTemp = explode('_|_coMpResSed_|_', base64_decode($WPVulnsData['wp']));
	$wpVulnsThemeTemp = explode('_|_coMpResSed_|_', base64_decode($WPVulnsData['themes']));
	if (!empty($wpVulnsPluginTemp[1]) && !empty($wpVulnsWPTemp[1]) && !empty($wpVulnsThemeTemp[1]) && function_exists('gzdecode')) {
		$WPVulnsData['plugins'] = @gzdecode($wpVulnsPluginTemp[1]);
		$WPVulnsData['themes'] = @gzdecode($wpVulnsThemeTemp[1]);
		$WPVulnsData['wp'] = @gzdecode($wpVulnsWPTemp[1]);
		return $WPVulnsData;
	}
	return false;
}

function WPVulnsHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('WPVulns');
	$addonDetails['files'] = array(
	    array('css' => array('href' => 'addons/WPVulns/css/WPVulns.css')),
	    array('js' => array('href' => 'addons/WPVulns/js/init.js')),
	    array('js' => array('href' => 'addons/WPVulns/js/load.js')),
	);
	$headFiles['WPVulns'] = $addonDetails;
}

function WPVulnsCheckZipSupport(){
	$gzZip = false;
	$gzUnZip = false;
	if (function_exists('gzencode')) {
		$gzZip = gzencode('Compress me');
	}
	if(function_exists('gzdecode') || function_exists('gzinflate')){
		$gzUnZip = true;
	}
	if ($gzZip && $gzUnZip) {
		return true;
	}
	return false;
}

function WPVulnsUpdateNotificationViews(&$updateNotifyView, $userID){
	if (!empty($updateNotifyView['siteView'])) {
		WPVulnsMergeVulnsUpdate($updateNotifyView);
	}else{
		$updateNotifyView = WPVulnsGetVulnsUpdate($userID, true);
	}
}

function WPVulnsMergeVulnsUpdate(&$updateViews, $onlyVulns = false, $notFilterHidden = false){
	$siteView = $updateViews['siteView'];
	$WPVulnsView = $updateViews['wpVulView'];
	if (empty($WPVulnsView)) {
		return 0;
	}
	$totalVulnsUpdate = 0;
	$vulnsPluginUpdateCount = 0;
	$vulnsCoreUpdateCount = 0;
	$vulnsThemeUpdateCount = 0;
	$tempCount = 0;
	foreach ($siteView as $siteID => $siteDetails) {
		$tempCount = 0;
		$tempCore =0;
		foreach ($siteDetails as $view => $name) {
			if ($view == 'core') {
				if (!empty($onlyVulns) && empty($WPVulnsView['wp'])) {
					unset($siteView[$siteID][$view]);
				}
				foreach ($WPVulnsView['wp'] as $WPValue) {
					foreach ($WPValue as $version => $veresionName) {
						foreach ($name as $versionKey => $versionDetails) {
							if (!empty($siteView[$siteID]) && version_compare($versionDetails['current_version'], $version) == 0) {
								$siteView[$siteID][$view][$versionKey]['vulnerability']=1;
								$siteView[$siteID][$view][$versionKey]['vulUrl']='https://wpvulndb.com/wordpresses/'.str_replace(".","",$version);
								$tempCount ++;
								$tempCore = 1;
								$vulnsCoreUpdateCount ++;
							}
						}
					}
				}
				if (!empty($onlyVulns) && $tempCore == 0) {
					unset($siteView[$siteID][$view]);
					$tempCore = 0;
				}
			} elseif ($view == 'plugins') {
				$tempPlugin = WPVulnsGetVulnsData($name, $WPVulnsView['plugins'], $siteView[$siteID][$view], 'slug', $tempCount, $onlyVulns, $view, $vulnsPluginUpdateCount);
				if (empty($siteView[$siteID][$view])) {
					unset($siteView[$siteID][$view]);
				}
			} elseif ($view == 'themes') {
				$tempTheme = WPVulnsGetVulnsData($name, $WPVulnsView['themes'], $siteView[$siteID][$view], 'theme', $tempCount, $onlyVulns, $view, $vulnsThemeUpdateCount);
				if (empty($siteView[$siteID][$view])) {
					unset($siteView[$siteID][$view]);
				}
			} 
			elseif (($tempCore == 0 && $tempPlugin == 0 && $tempTheme == 0 && !$notFilterHidden) || $view == 'translations') {
				unset($siteView[$siteID][$view]);
			}
		}
		if (($tempCore == 0 && $tempPlugin == 0 && $tempTheme == 0 && !empty($onlyVulns)) || empty($siteView[$siteID])) {
			unset($siteView[$siteID]);
		}

		$totalVulnsUpdate = $totalVulnsUpdate + $tempCount;
		$updateViews['siteViewCount'][$siteID]['vulnsCount'] = $tempCount;
	}
	$updateViews['siteView'] = $siteView;
	$updateViews['totalVulnsCount']= $totalVulnsUpdate;
	$updateViews['vulnsPluginUpdateCount']= $vulnsPluginUpdateCount;
	$updateViews['vulnsCoreUpdateCount']= $vulnsCoreUpdateCount;
	$updateViews['vulnsThemeUpdateCount']= $vulnsThemeUpdateCount;
}

function WPVulnsGetVulnsData($name, $vulnsView, &$newSiteView, $slug, &$tempCount, $onlyVulns, $view, &$updateCount){
	$tempFlag = 0; 
	foreach ($name as $element => $elementDetails) {
		$tempInnerFlag = 0;
		foreach ($vulnsView as $key => $value ) {
			foreach ($value as $vulnsElement => $vulnsElementDetails) {
				if ($elementDetails[$slug] == $vulnsElement) {
					foreach ($vulnsElementDetails['vulnerabilities'] as $vulnerableVersion) {
						if (version_compare($elementDetails['old_version'], $vulnerableVersion['fixed_in'], '<') && empty($newSiteView[$element]['vulnerability'])) {
							$newSiteView[$element]['vulnerability'] = 1;
							$newSiteView[$element]['vulUrl'] = 'https://wpvulndb.com/'.$view.'/'.$vulnsElement;
							$tempCount ++;$tempInnerFlag = 1;
							$tempFlag = 1;
							$updateCount++;
						}
					}
				}
			}
		}
		if ($tempInnerFlag == 0 && !empty($onlyVulns)) {
			unset($newSiteView[$element]);
		}

	}
	return $tempFlag;
}

function WPVulnsGetVulnsUpdate($UID, $onlyVulns = false, $siteIDs = array(), $notFilterHidden = false){
//getting updateInformation
	$sitesUpdates = panelRequestManager::getSitesUpdates($UID, false, $siteIDs);
	if (empty($sitesUpdates['wpVulView'])) {
		return false;
	}
	if (empty($notFilterHidden)) {
		$hiddenUpdates = panelRequestManager::getHide();
		foreach($hiddenUpdates as $siteID => $value){
			foreach($value as $d){
				unset($sitesUpdates['siteView'][$siteID][$d['type']][$d['URL']]);
				
				//this will fix the site name shows even all update items are hidden
				if(empty($sitesUpdates['siteView'][$siteID][$d['type']])){
					unset($sitesUpdates['siteView'][$siteID][$d['type']]);
				}
				if(empty($sitesUpdates['siteView'][$siteID])){
					unset($sitesUpdates['siteView'][$siteID]);
				}
			}
		}
	}
	WPVulnsMergeVulnsUpdate($sitesUpdates, $onlyVulns,$notFilterHidden);
	return $sitesUpdates;
}

function WPVulnsGetWPVulnsRowDetailedUpdates($data){
	$WPVulnsStats = WPVulnsGetVulnsUpdate($GLOBALS['userID'], true, array('0' => $data['siteID']));
	if ($WPVulnsStats['siteView'][$data['siteID']]['translations']) {
		unset($WPVulnsStats['siteView'][$data['siteID']]['translations']);
	}
	$siteViewHTML = TPL::get('/templates/updates/sitesView.tpl.php', array('siteDetailedData' => $WPVulnsStats['siteView'], 'view' => 'WPVulns', 'parentFlag' => $data['parentFlag'], 'data' => $data));
	$data = array('siteID' => $data['siteID'], 'HTML' => $siteViewHTML);
	return $data;
}

function WPVulnsGetWPVulnsViewUpdatesContent($args){
	$getKeyword = " ";
	$where2 = " ";
	$itemsPerPage = 20;
	$siteIDs = array();
	$searchEmpty = 0;
	$page = (isset($args['page']) && !empty($args['page'])) ? $args['page'] : 1;
	if (!empty($args['searchKey']) && $args['searchKey'] != 1 && $args != '1') {
		$keysSearch = "name LIKE '%".DB::esc($args['searchKey'])."%' ";
		$siteIDs = DB::getFields('?:sites', 'siteID', $keysSearch);
		if (empty($siteIDs)) {
			$searchEmpty = 1;
		}
	}
	if (!empty($args['groupID']) && $args['groupID'] !='null' && $args != '1') {
			$groupDetails = panelRequestManager::getSitesByGroupID($args);
			$siteIDs = $groupDetails['siteIDs'];
	}
	if ($searchEmpty == 0) {
		$sitesStats = WPVulnsGetVulnsUpdate($GLOBALS['userID'], true, $siteIDs);
		$siteIDs = array_keys($sitesStats['siteView']);
		$total = count($siteIDs);
		$limitSQL = paginate($page, $total, $itemsPerPage);
		$where = array(
				      		'query' =>  "siteID IN (:siteID) :limitSQL",
				      		'params' => array(
				               ':siteID'=>implode(',', $siteIDs),
				               ':limitSQL'=>$limitSQL
								)
						);

		$pagenatedSiteIDs = DB::getFields('?:sites', 'siteID', $where, 'siteID');
		$WPVulnsUpdates = WPVulnsPrepareWPVulnsView($pagenatedSiteIDs, $sitesStats['siteView']);
	}
	$WPVulnsViewHTML = TPL::get('/templates/updates/sitesView.tpl.php', array('siteSummaryData' => $WPVulnsUpdates, 'view' => 'WPVulns', 'data'=> $args));
	$result = array('HTML' => $WPVulnsViewHTML, 'data' => $args);
	return $result;
}

function WPVulnsPrepareWPVulnsView($siteIDs, $sitesStats){
	$WPVulnsUpdates = array();
	if (empty($siteIDs) || !is_array($siteIDs)) {
		return $WPVulnsUpdates;
	}
	foreach ($siteIDs as $siteID) {
		if (!empty($sitesStats[$siteID]['error'])) {
			continue;
		}
		$where = array(
			      		'query' =>  "siteID=':siteID'",
			      		'params' => array(
			               ':siteID'=>$siteID
							)
					);
		$siteName = DB::getField('?:sites', 'name', $where);
		$WPVulnsUpdates[$siteID]['siteID'] = $siteID;
		$WPVulnsUpdates[$siteID]['name'] = $siteName;
		$WPVulnsUpdates[$siteID]['vulnerability'] = 1;
		if (!empty($sitesStats[$siteID]['plugins'])) {
			$WPVulnsUpdates[$siteID]['updatePluginCounts'] = count($sitesStats[$siteID]['plugins']);
		} 
		if (!empty($sitesStats[$siteID]['themes'])) {
			$WPVulnsUpdates[$siteID]['updateThemeCounts'] = count($sitesStats[$siteID]['themes']);
		}
		if (!empty($sitesStats[$siteID]['core']) && !empty($sitesStats[$siteID]['core'][key($sitesStats[$siteID]['core'])]['vulnerability'])) {
			$WPVulnsUpdates[$siteID]['isCoreUpdateAvailable'] = count($sitesStats[$siteID]['core']);
		}

	}
	return $WPVulnsUpdates;
}

function WPVulnsGetPTCVulnsUpdate($view,$siteIDs = array(), $filterWPVulns = true){

	$sitesUpdates = panelRequestManager::getSitesUpdates($GLOBALS['userID'], false, $siteIDs);
	$viewUpdates = $sitesUpdates[$view];
	$WPVulnsUpdates = $sitesUpdates['wpVulView'];
	if ($view == 'coreView') {
		if (empty($WPVulnsUpdates['wp'])) {
			return false;
		}
		WPVulnsGetAffectedCoreVulnsUpdate($viewUpdates['core'], $WPVulnsUpdates['wp'], 'plugins', $filterWPVulns);
	} elseif ($view == 'pluginsView') {
		if (empty($WPVulnsUpdates['plugins'])) {
			return false;
		}
		WPVulnsGetAffectedPTVulnsUpdate($viewUpdates['plugins'], $WPVulnsUpdates['plugins'], 'plugins', $filterWPVulns);
	}elseif($view == 'themesView'){
		if (empty($WPVulnsUpdates['themes'])) {
			return false;
		}
		WPVulnsGetAffectedPTVulnsUpdate($viewUpdates['themes'], $WPVulnsUpdates['themes'], 'themes', $filterWPVulns);
	}
	return $viewUpdates;
}

function WPVulnsGetAffectedPTVulnsUpdate(&$viewUpdates, $WPVulnsUpdates, $key, $filterWPVulns){
	foreach ($viewUpdates as $items => $itemsValue) {
		$tempInnerFlag = 0;
		foreach ($itemsValue as $siteID => $data) {
			foreach ($WPVulnsUpdates as $VulnsItem => $VulnsItems) {
				foreach ($VulnsItems as $Vulskey => $VulsValue) {
					if ($data['slug'] == $Vulskey || $data['theme'] == $Vulskey) {
						foreach ($VulsValue as $Vulskey1 => $VulsKeyValue) {
							foreach ($VulsKeyValue as $key1 => $VulsData) {
								if (version_compare($VulsData['fixed_in'], $data['old_version'], ">")) {
									$viewUpdates[$items][$siteID]['vulnurable'] = 1;
									$viewUpdates[$items][$siteID]['vulUrl'] ='https://wpvulndb.com/'.$key.'/'.$Vulskey; 
									$tempInnerFlag = 1;
								}
							}
						}
					} 
				}
			}
		}
		if($tempInnerFlag == 0 && !empty($filterWPVulns)){
			unset($viewUpdates[$items]);
		}
	}
}

function WPVulnsGetAffectedCoreVulnsUpdate(&$viewUpdates, $WPVulnsUpdates, $key, $filterWPVulns){
	foreach ($viewUpdates as $items => $itemsValue) {
		foreach ($itemsValue as $siteID => $data) {
			foreach ($WPVulnsUpdates as $VulnsItem => $VulnsItems) {
				foreach ($VulnsItems as $version => $VulsValue) {
					if (version_compare($data['current_version'], $version, '==')) {
						$viewUpdates[$items][$siteID]['vulnurable'] = 1;
						$viewUpdates[$items][$siteID]['vulUrl']='https://wpvulndb.com/wordpresses/'.str_replace(".","",$version);
						$tempInnerFlag = 1;
					}
				}
			}
		}
	}
}

function getOnlyVulnsUpdateCounts(){
	$updateCounts = array();
	$WPVulnsStats = WPVulnsGetVulnsUpdate($GLOBALS['userID'], true,'');
	$updateCounts['WPVulnsPluginsCount'] = $WPVulnsStats['vulnsPluginUpdateCount'];
	$updateCounts['WPVulnsThemesCount'] = $WPVulnsStats['vulnsThemeUpdateCount'];
	$updateCounts['WPVulnsCore'] = $WPVulnsStats['vulnsCoreUpdateCount'];
	return $updateCounts;
}
