<?php

function backupRepositorySaveProfile($params){
	if(empty($params)){
		return false;
	}
	$accountInfo = serialize($params['accountInfo']);
	if(empty($params['repositoryID'])){
		$query = DB::insert("?:backup_repository", array('profileName' => $params['profileName'], 'type' => $params['type'], 'credentials' => $accountInfo, 'status' => $params['status']));
		if(!empty($query)){
			$data = array();
			$data['status'] = 'success';
			$data['repositoryID'] = $query;
			$where = array(
			      		'query' =>   "repositoryID=':repositoryID'",
			      		'params' => array(
			               ':repositoryID'=>$query
           				)
        			);

			$data['profileName'] = DB::getField("?:backup_repository","profileName", $where); 
			
			return $data;
		}
		else{
			return array('status' => 'error', 'errorMsg' => 'Oops! Try again.');
		}
	}
	else{
			$where = array(
			      		'query' =>   "repositoryID=':repositoryID'",
			      		'params' => array(
			               ':repositoryID'=>$params['repositoryID']
           				)
        			);
		$query = DB::update("?:backup_repository", array('profileName' => $params['profileName'], 'type' => $params['type'], 'credentials' => $accountInfo, 'status' => $params['status']), $where);
		
		if(!empty($query)){
			return $query;
		}
		else{
			return "Profile already exists.";
		}
	}
}

function backupRepositoryGetProfile($params){
	if(empty($params)){
		return false;
	}
	$where = array(
	      		'query' =>   "repositoryID=':repositoryID'",
	      		'params' => array(
	               ':repositoryID'=>$params['repositoryID']
   				)
        	);
	
	$datas = array();
	$data = DB::getRow("?:backup_repository", "*", $where);
	
	$datas = unserialize($data['credentials']);
	$datas['ProfileName'] = $data['profileName'];
	$datas['type'] = $data['type']; 
	
	if(!empty($datas)){
		return $datas;
	}
	else{
		return false;
	}
}

function backupRepositoryGetAllProfiles($params){
	$where = array(
	      		'query' =>   "type=':type'",
	      		'params' => array(
	               ':type'=>$params['type']
   				)
			);
	$profiles = DB::getArray("?:backup_repository", "repositoryID, profileName",$where);
	if(!empty($profiles)){
		return $profiles;
	}
	else{
		return false;
	}
}

function backupRepositoryDeleteProfile($params){
	$where = array(
	      		'query' =>   "repositoryID=':repositoryID'",
	      		'params' => array(
	               ':repositoryID'=>$params['repositoryID']
   				)
			);
	return DB::delete("?:backup_repository", $where);
}

function backupRepositoryResponseProcessors(&$responseProcessor){
	$responseProcessor['backupRepository']['upload'] = 'backupRepository';
}

function backupRepositoryTaskTitleTemplate(&$template){
	$template['backupRepository']['upload']['']	= "Upload backup to <#uniqueName#>";
}

function backupRepositoryGetDropBoxKeys(){
	
	$DropBoxTokens = getOption('DropBoxTokens');
	
	if(empty($DropBoxTokens)){
		return false;
	}
	return @unserialize($DropBoxTokens);
}

function backupRepositoryGetDropBoxAccess(){
	$DropBoxAccess = getOption('DropBoxAccess');
	
	if(empty($DropBoxAccess)){
		return false;
	}
	return @unserialize($DropBoxAccess);
}

function backupRepositorySaveDropBoxAccountDetails($params){
	require_once APP_ROOT . '/addons/backupRepository/lib/Dropbox2/API.php';
	require_once APP_ROOT . '/addons/backupRepository/lib/Dropbox2/Exception.php';
	require_once APP_ROOT . '/addons/backupRepository/lib/Dropbox2/OAuth/Consumer/ConsumerAbstract.php';
	require_once APP_ROOT . '/addons/backupRepository/lib/Dropbox2/OAuth/Consumer/Curl.php';
	
	try{
		$oauth = new IWP_Dropbox_OAuth_Consumer_Curl($params['appKey'], $params['appSecretKey']);
		$oauth->setToken($params['accessToken']);
		$dropbox = new IWP_Dropbox_API($oauth);
		$response = $dropbox->accountInfo();
		$params['email'] = $response['body']->email;			
	}
	catch(Exception $e){
		$t = array('status' => 'error', 'errorMsg' => $e->getMessage());
	}
	updateOption('DropBoxAccess', serialize($params));
}
function backupRepositorySaveGoogleDriveCreds($params){
	updateOption('googleDriveCredentials', serialize($params));
}

function backupRepositoryGetGoogleDriveCreds(){
	$params = getOption('googleDriveCredentials');
	return unserialize($params);
}

function backupRepositorySetGoogleDriveArgs($initialArgs)
{
	$googleArgs = array();
	$googleCreds = array();
	$params['repositoryID'] = $initialArgs['gDriveEmail'];
	$g_token = backupRepositoryGetProfile($params);
	$googleCreds = backupRepositoryGetGoogleDriveCreds();
	$googleArgs['token'] = $g_token;
	$googleArgs['clientID'] = $googleCreds['clientID'];
	$googleArgs['clientSecretKey'] = $googleCreds['clientSecretKey'];
	$googleArgs['redirectURL'] = $googleCreds['redirectURL'];
	$googleArgs['gdrive_site_folder'] = $initialArgs['gdrive_site_folder'];
	return $googleArgs;
}

function backupRepositoryIsNotifyDropBoxUpgrade(){
	$dropBoxAccess = backupRepositoryGetDropBoxAccess();
	if (function_exists('scheduleBackupCronRun')) {
		$settings = DB::getArray("?:backup_schedules", "*", 1);
		foreach ($settings as $key => $data) {
			if (!$data['paused']) {
				$additionalDatas = unserialize($data['additionalDatas']);
				if (!empty($additionalDatas['secure']['account_info']) && !empty($additionalDatas['secure']['account_info']['iwp_dropbox'])) {
					$dropBox = $additionalDatas['secure']['account_info']['iwp_dropbox'];
					if (empty($dropBox['dropbox_access_token'])) {
						return true;
					}
				}
			}
		}

	}elseif(!$dropBoxAccess){
		return true;
	}

	return false;

}

function backupRepositoryUpgradeSchedules(){
	$dropBoxAccess = backupRepositoryGetDropBoxAccess();
	if (function_exists('scheduleBackupCronRun')) {
		$settings = DB::getArray("?:backup_schedules", "*", 1, 'scheduleID');
		foreach ($settings as $scheduleID => $data) {
			$additionalDatas = unserialize($data['additionalDatas']);
			if (!empty($additionalDatas['secure']['account_info']) && !empty($additionalDatas['secure']['account_info']['iwp_dropbox'])) {
				$dropBox = $additionalDatas['secure']['account_info']['iwp_dropbox'];
				if (empty($dropBox['dropbox_access_token']) && !empty($dropBoxAccess)) {
					$where = array(
					      		'query' =>   "scheduleID=':scheduleID'",
					      		'params' => array(
					               ':scheduleID'=>$scheduleID
				   				)
				        	);
					unset($dropBox['oauth_token']);
					unset($dropBox['oauth_token_secret']);
					$dropBox['consumer_key'] = '';
					$dropBox['consumer_secret'] = '';
					$dropBox['dropbox_app_key'] = $dropBoxAccess['appKey'];
					$dropBox['dropbox_app_secure_key'] = $dropBoxAccess['appSecretKey'];
					$dropBox['dropbox_access_token'] = $dropBoxAccess['accessToken'];
					$additionalDatas['secure']['account_info']['iwp_dropbox'] = $dropBox;
					$settings = DB::update("?:backup_schedules", array('additionalDatas' =>serialize($additionalDatas)), $where);
				}
			}
		}

	}
}

function backupRepositoryDropbox($args){
	extract($args['iwp_dropbox']);
	if(isset($dropbox_access_token) && !empty($dropbox_access_token)){
		require_once APP_ROOT . '/addons/backupRepository/lib/Dropbox2/API.php';
		require_once APP_ROOT . '/addons/backupRepository/lib/Dropbox2/Exception.php';
		require_once APP_ROOT . '/addons/backupRepository/lib/Dropbox2/OAuth/Consumer/ConsumerAbstract.php';
		require_once APP_ROOT . '/addons/backupRepository/lib/Dropbox2/OAuth/Consumer/Curl.php';
		
		try{
			$oauth = new IWP_Dropbox_OAuth_Consumer_Curl($dropbox_app_key, $dropbox_app_secure_key);
			$oauth->setToken($dropbox_access_token);
			$dropbox = new IWP_Dropbox_API($oauth);
			$oldRoot = 'Apps/InfiniteWP';
			$dropbox_destination = $oldRoot.$dropbox_destination;
			$response = $dropbox->accountInfo();
			return array('status' => 'success');			
		}
		catch(Exception $e){
			return array('status' => 'error', 'errorMsg' => $e->getMessage());
		}
	}
	return array('status' => 'error', 'errorMsg' => 'Consumer Secret not available');
}

class googleDriveHelper{
	
	public static $client;
	public static $authHelper;
	public static $storage;
	private static $GDThisPage;
	private static $redirectURL;
	private static $isSetPathsAndKeysComplete = false;
	private static $oauth;
	
	public static function setPathsAndKeys(){
		
		if(self::$isSetPathsAndKeysComplete) return true;
		
		include_once(APP_ROOT.'/lib/googleAPIs/src/Google_Client.php');
		include_once(APP_ROOT.'/lib/googleAPIs/src/contrib/Google_DriveService.php');
		include_once(APP_ROOT.'/lib/googleAPIs/src/contrib/Google_Oauth2Service.php');
		//include_once(APP_ROOT.'/lib/googleAPIs/src/service/Drive.php');
		//include_once(APP_ROOT.'/lib/googleAPIs/src/service/Resource.php');
		include_once(APP_ROOT.'/lib/googleAPIs/storage.php');
		include_once(APP_ROOT.'/lib/googleAPIs/authHelper.php');
		
		self::$GDThisPage = APP_URL.'addons/backupRepository/lib/googleDrive.php';
		self::$redirectURL = APP_URL.'addons/backupRepository/lib/googleDrive.php';
		
		
		$googleKeys = getOption('googleDriveCredentials');							//get the creds from option table.
		$googleKeys = unserialize($googleKeys);
		
		$googleAPIKeys = array();
		$googleAPIKeys = backupRepositoryGetGoogleDriveCreds();
		/* $googleAPIKeys['clientID'] = '657972506832.apps.googleusercontent.com';
		$googleAPIKeys['clientSecretKey'] = 'FQ5fS20QmyGLE-3UpJisHo8F'; */
		/* $googleAPIKeys['clientID'] = $googleKeys['clientID'];
		$googleAPIKeys['clientSecretKey'] = $googleKeys['clientSecretKey']; */
		
		
		/* if(!empty($googleAPIKeys)){
			$googleAPIKeys = unserialize($googleAPIKeys);
		} */
	
		// Build a new client object to work with authorization.
		self::$client = new Google_Client();
		self::$client->setClientId($googleAPIKeys['clientID']);

		self::$client->setClientSecret($googleAPIKeys['clientSecretKey']);
		self::$client->setRedirectUri(self::$redirectURL);
		self::$client->setApplicationName('InfiniteWP Google Drive');
		self::$client->setScopes(array(
		  'https://www.googleapis.com/auth/drive',
		  'https://www.googleapis.com/auth/userinfo.email'));
		
		// Magic. Returns objects from the Analytics Service
		// instead of associative arrays.
		self::$client->setUseObjects(true);
		
		self::$oauth = new Google_Oauth2Service(self::$client);
		
		
		// Build a new storage object to handle and store tokens in sessions.
		// Create a new storage object to persist the tokens across sessions.
		self::$storage = new apiSessionStorage(); //googleAnalyticsStorageHelper();
		
		self::$authHelper = new AuthHelper(self::$client, self::$storage, self::$GDThisPage);
		
		self::$isSetPathsAndKeysComplete = true;

	}
	
	public static function testConnectionGoogle($args){
		
		include_once(APP_ROOT.'/lib/googleAPIs/src/Google_Client.php');
		include_once(APP_ROOT.'/lib/googleAPIs/src/contrib/Google_DriveService.php');
		include_once(APP_ROOT.'/lib/googleAPIs/src/contrib/Google_Oauth2Service.php');
		include_once(APP_ROOT.'/lib/googleAPIs/storage.php');
		include_once(APP_ROOT.'/lib/googleAPIs/authHelper.php');
		
		$gDriveArgs = backupRepositorySetGoogleDriveArgs($args);
		$accessToken = $gDriveArgs['token'];
		
		$client = new Google_Client();
		$client->setClientId($gDriveArgs['clientID']);

		$client->setClientSecret($gDriveArgs['clientSecretKey']);
		$client->setRedirectUri($gDriveArgs['redirectURL']);
		$client->setScopes(array(
		  'https://www.googleapis.com/auth/drive',
		  'https://www.googleapis.com/auth/userinfo.email'));
		
		$accessToken = $gDriveArgs['token'];
		$refreshToken = $accessToken['refresh_token'];
		
		try
		{
			$client->refreshToken($refreshToken);
			return array('status' => 'success');
		}
		catch(Exception $e)
		{	
			echo 'google Error ',  $e->getMessage(), "\n";
			return array('status' => 'error', 'errorMsg' => $e->getMessage());
		}
	}
	
	public static function getGoogleEmail(){
	
		$get = self::$oauth->userinfo->get();
		$getEmail = $get->email;
			
		return $getEmail;
		
	}
	
}

function backupRepositoryHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('backupRepository');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/backupRepository/css/backup_repo_styles.css')),
		array('js' => array('href' => 'addons/backupRepository/js/functions.js')),
		array('js' => array('href' => 'addons/backupRepository/js/init.js')),
		array('js' => array('href' => 'addons/backupRepository/js/load.js')),
	);
	$headFiles['backupRepository'] = $addonDetails;
	?>
<script>
var IsNotifyDropBoxUpgradeMsg = "<?php echo backupRepositoryIsNotifyDropBoxUpgrade(); ?>";
</script>

	<?php
}