<?php

function bulkPublishAddonMenus(&$menus){
	//$menus[] = '<li><a class="navLinks optionSelect" page="posts">Publish</a></li>';
	$menus['manage']['subMenus'][] = array('page' => 'posts', 'displayName' => 'Posts, Pages &amp; Links');
}

function bulkPublishGetLinks(){
	
	$actionID = Reg::get('currentRequest.actionID');
	$where = array(
	      		'query' =>  "type = ':type' AND paramID = ':paramID'",
	      		'params' => array(
	      		   ':type'=>'getLinks',
	      		   ':paramID'=>$actionID
   				)
			);
		
	$getDatas = DB::getFields("?:temp_storage", "data", $where);
			
	DB::delete("?:temp_storage", $where);
		
	if(empty($getDatas)){
		return array();
	}
	$finalData = array();
	foreach($getDatas as $data){
		$finalData = array_merge_recursive($finalData, (array)unserialize($data));	
	}
	arrayMergeRecursiveNumericKeyHackFix($finalData);
		
	return $finalData;
}

function bulkPublishGetPosts(){
	
	$actionID = Reg::get('currentRequest.actionID');

	$where = array(
	      		'query' =>  "type = ':type' AND paramID = ':paramID'",
	      		'params' => array(
	      		   ':type'=>'getPosts',
	      		   ':paramID'=>$actionID
   				)
			);
		
	$getDatas = DB::getFields("?:temp_storage", "data", $where);

	DB::delete("?:temp_storage", $where);
		
	if(empty($getDatas)){
		return array();
	}
	$finalData = array();
	foreach($getDatas as $data){
		$finalData = array_merge_recursive($finalData, (array)unserialize($data));	
	}
	arrayMergeRecursiveNumericKeyHackFix($finalData);
	
	return $finalData;
}

function bulkPublishGetPages(){
	
	$actionID = Reg::get('currentRequest.actionID');

	$where = array(
	      		'query' =>  "type = ':type' AND paramID = ':paramID'",
	      		'params' => array(
	      		   ':type'=>'getPages',
	      		   ':paramID'=>$actionID
   				)
			);
		
	$getDatas = DB::getFields("?:temp_storage", "data", $where);
		
	DB::delete("?:temp_storage", $where);
		
	if(empty($getDatas)){
		return array();
	}
	$finalData = array();
	foreach($getDatas as $data){
		$finalData = array_merge_recursive($finalData, (array)unserialize($data));	
	}
	arrayMergeRecursiveNumericKeyHackFix($finalData);
		
	return $finalData;
}

function bulkPublishResponseProcessors(&$responseProcessor){
	$responseProcessor['links']['add'] 			= 'addLinks';
	$responseProcessor['links']['get'] 			= 'getLinks';
	$responseProcessor['links']['delete'] 		= 'deleteLinks';
	$responseProcessor['links']['bulkDelete']	= 'bulkDeleteLinks';
	
	$responseProcessor['post']['add'] 			= 'addPostPage';
	$responseProcessor['posts']['get']			= 'getPosts';
	$responseProcessor['posts']['delete'] 		= 'deletePosts';
	$responseProcessor['posts']['bulkDelete'] 	= 'bulkDeletePosts';
	
	$responseProcessor['page']['add']			= 'addPostPage';
	$responseProcessor['pages']['get'] 			= 'getPages';
	$responseProcessor['pages']['delete'] 		= 'deletePages';
	$responseProcessor['pages']['bulkDelete']	= 'bulkDeletePages';
	
}

function bulkPublishTaskTitleTemplate(&$template){
	$template['links']['add']['']			= "Add links in <#sitesCount#> site<#sitesCountPlural#>";
	$template['links']['get']['']			= "Get links from <#sitesCount#> site<#sitesCountPlural#>";
	$template['links']['delete']['']		= "Delete a links";
	$template['links']['bulkDelete']['']	= "Delete links from <#sitesCount#> site<#sitesCountPlural#>";
	
	$template['post']['add']['']			= "Add a post in <#sitesCount#> site<#sitesCountPlural#>";	
	$template['posts']['get']['']			= "Get posts from <#sitesCount#> site<#sitesCountPlural#>";
	$template['posts']['delete'][''] 		= "Delete a post";
	$template['posts']['bulkDelete'][''] 	= "Delete posts from <#sitesCount#> site<#sitesCountPlural#>";
	
	$template['page']['add']['']			= "Add a page in <#sitesCount#> site<#sitesCountPlural#>";
	$template['pages']['get'][''] 			= "Get pages from <#sitesCount#> site<#sitesCountPlural#>";
	$template['pages']['delete'][''] 		= "Delete a page";
	$template['pages']['bulkDelete'][''] 	= "Delete pages from <#sitesCount#> site<#sitesCountPlural#>";
	
}

function bulkPublishHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('bulkPublish');
	$addonDetails['files'] = array(
		array('css'   => array('href'  => 'addons/bulkPublish/css/bulk_publish_styles.css')),
		array('css'    => array('href'  => 'addons/bulkPublish/js/lib/zebra/css/zebra_datepicker.css')),
        array('tp'    => array('HTML'  => '<script type="text/javascript" src="addons/bulkPublish/js/lib/tiny_mce/tiny_mce.js"></script>')),
        array('tp'    => array('HTML'  => '<script type="text/javascript" src="addons/bulkPublish/js/lib/tiny_mce/jquery.tinymce.js"></script>')),
        array('tp'    => array('HTML'  => '<script type="text/javascript" src="addons/bulkPublish/js/lib/zebra/javascript/zebra_datepicker.js"></script>')),
        array('js'    => array('href'  => 'addons/bulkPublish/js/functions.js')),
        array('js'    => array('href'  => 'addons/bulkPublish/js/init.js')),
        array('js'    => array('href'  => 'addons/bulkPublish/js/load.js')),
        array('tp'    => array('HTML'  => '<script type="text/javascript" src="addons/bulkPublish/js/lib/wp-langs-en.min.js"></script>')),
        array('tp'    => array('HTML'  => '<script type="text/javascript" src="addons/bulkPublish/js/lib/wp-tinymce-schema.min.js"></script>')),
	);
	$headFiles['bulkPublish'] = $addonDetails;
}