<?php

/*
slug: clientReporting
version: 3.3.2
*/


class addonClientReporting{
	
	private static $version = '3.3.2';

	public static function version(){
		return self::version;
	}
	
	public static function init(){
		require_once(APP_ROOT."/addons/clientReporting/controllers/func.php");
		require_once(APP_ROOT."/addons/clientReporting/controllers/funcNew.php");
		require_once(APP_ROOT."/addons/clientReporting/controllers/manageClientsClientReporting.php");
		if(defined('CLIENT_REPORTING_LANG') && file_exists(APP_ROOT.'/addons/clientReporting/lang/'.CLIENT_REPORTING_LANG.'.php')){
			require_once(APP_ROOT.'/addons/clientReporting/lang/'.CLIENT_REPORTING_LANG.'.php');	
			$GLOBALS['LANG'] = $lang;
		}
		else{
			require_once(APP_ROOT.'/addons/clientReporting/lang/en-us.php');	
			$GLOBALS['LANG'] = $lang;
		}

		panelRequestManager::addFunctions('clientReportingGenerate','clientReportingGeneratePdf','clientReportingGetLogo', 'clientReportingSchedule', 'clientReportingScheduleReportViewHTML', 'clientReportingManualReportViewHTML', 'clientReportingGetSchedule', 'clientReportingScheduleReportDelete', 'clientReportingDeleteSentPdf', 'clientReportingScheduleReportPause', 'clientReportingScheduleReportRunNow', 'clientReportingGetHeaderFooterCont', 'confirmCustomLanUpdateNotes');
		
		/* The following lines are used for CR Addon (New) */
		
		panelRequestManager::addFunctions('clientReportingNewManualReportViewHTML','clientReportingNewScheduleReportViewHTML','clientReportingSaveScheduleNew','clientReportingNewGeneratePdf','clientReportingNewGetLogo','clientReportingNewGetHeaderFooterCont','clientReportingScheduleReportPauseNew', 'clientReportingScheduleReportNewRunNow','clientReportingNewGetSchedule','clientReportingScheduleReportDeleteNew','manualReportingNewPreGeneratePdf','clientReportingNewDeleteSentPdf','scheduleReportingNewGeneratePdf','scheduleReportingSaveTempDetails');

		/* The following lines are used for CR Addon (Phoenix) */
		panelRequestManager::addFunctions('clientReportingPhoenixManualReportViewHTML', 'clientReportingPhoenixGetLogo', 'clientReportingPhoenixGetHeaderFooterCont', 'clientReportingPhoenixScheduleReportViewHTML', 'clientReportingManageLanguages', 'clientReportingNewloadLangVariables', 'clientReportingAddLanguage', 'clientReportingRemoveLanguage', 'clientReportingGetTemplateFields', 'clientReportingGetCRLanguages', 'manualReportingPhoenixPreGenerateHTML', 'clientReportingNewGenerateHTML', 'clientReportingSaveSchedulePhoenix', 'scheduleReportingPhoenixGenerateHTML', 'clientReportingPhoenixGetSchedule', 'clientReportingScheduleReportPausePhoenix', 'clientReportingNewDeleteSentPhoenix', 'clientReportingDeleteSentPhoenix', 'clientReportingScheduleReportDeletePhoenix', 'clientReportingSaveProfile', 'getClientReportingProfile', 'loadClientReportingProfile', 'deleteClientReportingProfile', 'CRTestFTPConnection');
		
		/* The above lines are used for CR Addon (New) */
		regHooks('addonMenus', 'cronRun', 'removeSite', 'getNextSchedule','responseProcessors','taskTitleTemplate', 'headHTMLFiles');
	}
	
	public static function install(){
		
		$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:client_report_schedule` (
						  `clientReportScheduleID` int(10) unsigned NOT NULL AUTO_INCREMENT,
						  `profileName` varchar(255) NOT NULL,
						  `period` enum('weekly','monthly') NOT NULL,
						  `schedule` varchar(50) NOT NULL,
						  `params` text,
						  `nextSchedule` int(10) unsigned DEFAULT NULL,
						  `lastRun` int(10) unsigned DEFAULT NULL,
						  `paused` enum('1','0') DEFAULT NULL,
						  `version` ENUM('old','new','phoenix') NOT NULL DEFAULT 'old',
						  PRIMARY KEY (`clientReportScheduleID`)
						)".DB::getSQLTableEnv().";");


		$Q2 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:client_report_sent_pdf` (
						  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
						  `clientReportScheduleID` int(10) unsigned DEFAULT NULL,
						  `profileName` varchar(255) DEFAULT NULL,
						  `params` text,
						  `pdfURL` varchar(255) NOT NULL,
						  `reportType` enum('schedule','manual') DEFAULT NULL,
						  `version` ENUM('old','new','phoenix') NOT NULL DEFAULT 'old',
						  `sentTime` int(10) unsigned DEFAULT NULL,
						  PRIMARY KEY (`ID`)
						)".DB::getSQLTableEnv().";");
		
		if($Q1 && $Q2){
			return true;
		}
		return false;

	}
	
	
	public static function update(){
		
		$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:client_report_schedule` (
						  `clientReportScheduleID` int(10) unsigned NOT NULL AUTO_INCREMENT,
						  `profileName` varchar(255) NOT NULL,
						  `period` enum('weekly','monthly') NOT NULL,
						  `schedule` varchar(50) NOT NULL,
						  `params` text,
						  `nextSchedule` int(10) unsigned DEFAULT NULL,
						  `lastRun` int(10) unsigned DEFAULT NULL,
						  `paused` enum('1','0') DEFAULT NULL,
						  `version` ENUM('old','new','phoenix') NOT NULL DEFAULT 'old',
						  PRIMARY KEY (`clientReportScheduleID`)
						)".DB::getSQLTableEnv().";");
		
		
		$Q2 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:client_report_sent_pdf` (
						  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
						  `clientReportScheduleID` int(10) unsigned DEFAULT NULL,
						  `profileName` varchar(255) DEFAULT NULL,
						  `params` text,
						  `pdfURL` varchar(255) NOT NULL,
						  `reportType` enum('schedule','manual') DEFAULT NULL,
						  `version` ENUM('old','new','phoenix') NOT NULL DEFAULT 'old',						  
						  `sentTime` int(10) unsigned DEFAULT NULL,
						  PRIMARY KEY (`ID`)
						)".DB::getSQLTableEnv().";");
		
		if(
			version_compare(getOldAddonVersion('clientReporting'), '2.4.1beta1', '<')
		) {
			$deleteFiles = array('/addons/clientReporting/initHTMLHead.php' => array('type' => 'f') );
			fileSystemRemoveFiles($deleteFiles);
			
			$return = self::doAddVersionField();
			if(!$return) {
				return false;
			}			

			$return = self::doOptionTableCollationConversion();
			if(!$return) {
				return false;
			}			
			
			$return = self::doCRTablesCollationConversion();
			if(!$return) {
				return false;
			}			
		}

		if(version_compare(getOldAddonVersion('clientReporting'), '2.4.1beta2', '<')) {
			updateOption('showCustomLanUpdateNotes', 1);
		}

		if(version_compare(getOldAddonVersion('clientReporting'), '3.0.0', '<')) {
			$return = self::updateDBafterCR();
			if(!$return) {
				return false;
			}
		}
		
		if (version_compare(getOldAddonVersion('clientReporting'), '3.0.2', '<')) {
			$languages = getOption('clientReportingLanguages');
			$Q1 = updateOption('clientReportingLanguages', base64_decode($languages));
		}
		if($Q1 && $Q2){
			return true;
		}
		return false;
	}
	
	public static function doOptionTableCollationConversion() {
		
		/*$charSetCollation = DB::getSQLCharSetCollation();
		$tableName = '`?:options`';
		
		if(!isUTF8Collation($tableName)) {
			$sql = "
				ALTER TABLE 
					".$tableName." 
				DEFAULT 
					".$charSetCollation.";
			";
			$isDone = DB::doQuery($sql);
			if(!$isDone) {
				return false;
			}
			
			//Binary conversion
			$sql = "
				ALTER TABLE 
					".$tableName." 
				CHANGE 
					`optionName` `optionName` VARBINARY(255) NOT NULL, 
				CHANGE 
					`optionValue` `optionValue` LONGBLOB NULL DEFAULT NULL;
			";
			$isDone = DB::doQuery($sql);
			if(!$isDone) {
				return false;
			}			
			//Binary conversion
			
			$sql = "
				ALTER TABLE 
					".$tableName." 
				CHANGE 
					`optionName` `optionName` VARCHAR(255) ".$charSetCollation." NOT NULL, 
				CHANGE 
					`optionValue` `optionValue` LONGBLOB ".$charSetCollation." NULL DEFAULT NULL;
			";
			$isDone = DB::doQuery($sql);
			if(!$isDone) {
				return false;
			}			
		}*/
		
		$headerFooterLogoCont = getOption('headerFooterLogoCont');
		if($headerFooterLogoCont === 'b:0;' || $headerFooterLogoCont === '' || !$headerFooterLogoCont) {
			deleteOption('headerFooterLogoCont');
		} else if($headerFooterLogoCont != '' && @unserialize($string) !== false) {
			updateOption('headerFooterLogoCont', base64_encode($headerFooterLogoCont));
		}
		
		return true;
	}
	
	public static function doCRTablesCollationConversion() {
		
		$charSetCollation = DB::getSQLCharSetCollation();
		
		$tableName = '`?:client_report_schedule`';
		if(!isUTF8Collation($tableName)) {
			$sql = "
				ALTER TABLE 
					".$tableName." 
				DEFAULT 
					".$charSetCollation.";
			";
			$isDone = DB::doQuery($sql);
			if(!$isDone) {
				return false;
			}
			
			//Binary conversion
			$sql = "
				ALTER TABLE 
					".$tableName." 
				CHANGE 
					`profileName` `profileName` VARBINARY(255) NOT NULL, 
				CHANGE 
					`schedule` `schedule` VARBINARY(50) NOT NULL, 
				CHANGE 
					`params` `params` BLOB NULL DEFAULT NULL;				
			";
			$isDone = DB::doQuery($sql);
			if(!$isDone) {
				return false;
			}
			//Binary conversion
			
			$sql = "
				ALTER TABLE 
					".$tableName." 
				CHANGE 
					`profileName` `profileName` VARCHAR(255) ".$charSetCollation." NOT NULL, 
				CHANGE 
					`period` `period` ENUM('weekly','monthly') ".$charSetCollation." NOT NULL, 
				CHANGE 
					`schedule` `schedule` VARCHAR(50) ".$charSetCollation." NOT NULL, 
				CHANGE 
					`params` `params` TEXT ".$charSetCollation." NULL DEFAULT NULL, 
				CHANGE 
					`paused` `paused` ENUM('1','0') ".$charSetCollation." NULL DEFAULT NULL;				
			";
			$isDone = DB::doQuery($sql);
			if(!$isDone) {
				return false;
			}
		}
		
		$getScheduleResult = DB::getArray("select clientReportScheduleID, params, nextSchedule from ".$tableName." order by clientReportScheduleID asc");
		if(!empty($getScheduleResult)) {
			foreach($getScheduleResult as $key => $params) {
				if($params['params'] != '' && @unserialize($params['params']) !== false) {
					$params['params'] = base64_encode($params['params']);
					$sql = "update ".$tableName." set params = '".$params['params']."' where clientReportScheduleID = '".$params['clientReportScheduleID']."'";
					DB::doQuery($sql);				
				}
				if($params['nextSchedule'] == 0) {
					$sql = "update ".$tableName." set nextSchedule = '".time()."' where clientReportScheduleID = '".$params['clientReportScheduleID']."'";
					DB::doQuery($sql);					
				}
			}
		}
		
		$tableName = '`?:client_report_sent_pdf`';
		if(!isUTF8Collation($tableName)) {
			$sql = "
				ALTER TABLE 
					".$tableName." 
				DEFAULT 
					".$charSetCollation.";
			";
			$isDone = DB::doQuery($sql);
			if(!$isDone) {
				return false;
			}
			
			//Binary conversion
			$sql = "
				ALTER TABLE 
					".$tableName." 
				CHANGE 
					`profileName` `profileName` VARBINARY(255) NULL DEFAULT NULL, 
				CHANGE 
					`params` `params` BLOB NULL DEFAULT NULL, 
				CHANGE 
					`pdfURL` `pdfURL` VARBINARY(255) NOT NULL;				
			";
			$isDone = DB::doQuery($sql);
			if(!$isDone) {
				return false;
			}			
			//Binary conversion		
			
			$sql = "
				ALTER TABLE 
					".$tableName." 
				CHANGE 
					`profileName` `profileName` VARCHAR(255) ".$charSetCollation." NULL DEFAULT NULL, 
				CHANGE 
					`params` `params` TEXT ".$charSetCollation." NULL DEFAULT NULL, 
				CHANGE 
					`pdfURL` `pdfURL` VARCHAR(255) ".$charSetCollation." NOT NULL,  
				CHANGE 
					`reportType` `reportType` ENUM('schedule','manual') ".$charSetCollation." NULL DEFAULT NULL;				
			";
			$isDone = DB::doQuery($sql);
			if(!$isDone) {
				return false;
			}
		}
		
		$getSentPdfResult = DB::getArray("select ID, params from ".$tableName." order by ID asc");
		if(!empty($getSentPdfResult)) {
			foreach($getSentPdfResult as $key => $params) {
				if($params['params'] != '' && @unserialize($params['params']) !== false) {
					$params['params'] = base64_encode($params['params']);
					$sql = "update ".$tableName." set params = '".$params['params']."' where ID = '".$params['ID']."'";
					DB::doQuery($sql);
				}
			}
		}
		return true;
	}
	
	public static function doAddVersionField() {
		if(!(DB::getExists("SHOW COLUMNS FROM `?:client_report_sent_pdf` WHERE Field = 'version'"))){
			$isDone = DB::doQuery("ALTER TABLE `?:client_report_sent_pdf`  ADD `version` ENUM('old','new') NOT NULL DEFAULT 'old' AFTER `reportType`;");
			if(!$isDone) {
				return false;
			}
		}
		
		if(!(DB::getExists("SHOW COLUMNS FROM `?:client_report_schedule` WHERE Field = 'version'"))){
			$isDone = DB::doQuery("ALTER TABLE `?:client_report_schedule` ADD `version` ENUM('old','new') NOT NULL DEFAULT 'old' AFTER `paused`;");
			if(!$isDone) {
				return false;
			}
		}
		return true;
	}

	public static function updateDBafterCR(){
		$sql ="ALTER TABLE `?:client_report_schedule` CHANGE `version` `version` ENUM('old','new','phoenix') NOT NULL DEFAULT 'old'";
		$isDone = DB::doQuery($sql);

		$sql2 ="ALTER TABLE `?:client_report_sent_pdf` CHANGE `version` `version` ENUM('old','new','phoenix') NOT NULL DEFAULT 'old'";
		$isDone2 = DB::doQuery($sql2);

		if(!$isDone || !$isDone2) {
		    return false;
		}
		return true;
	}

}

?>