<?php

function clientReportingRemoveSite($siteID) {
	$table_name = '?:client_report_schedule';
	$getParams = DB::getArray($table_name, "params, clientReportScheduleID", "1");
	
	if(!empty($getParams)) {
		foreach($getParams as $key => $paramsArray) {
			$params = unserialize(base64_decode($paramsArray['params']));
			if(in_array($siteID, $params['siteID'])) {
				unset($params['siteID'][array_search($siteID, $params['siteID'])]);
				
				$where = array(
							'query' =>  "clientReportScheduleID = ':clientReportScheduleID'",
							'params' => array(
							   ':clientReportScheduleID' => $paramsArray['clientReportScheduleID']
							)
				);			
				DB::update($table_name, array("params" => base64_encode(serialize($params))), $where);
			}
		}
	}
}

function clientReportingGetNextSchedule(&$nextScheduleTime){
	$nextTime = DB::getField("?:client_report_schedule", "MIN(nextSchedule)", "paused='0' ");
	if(!empty($nextTime)){
		$nextScheduleTime[] = $nextTime;
	}
}

function clientReportingAddonMenus(&$menus){
	$menus['tools']['subMenus'][] = array('page' => 'clientReporting', 'displayName' => 'Client Reporting');
}

function clientReportingHeaderFooterLogoSave($params){	
	if(!empty($params)){
		$params['headerContent'] = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['headerContent']));
		$params['footerContent'] = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['footerContent']));		

		doSetCharsetToUTF8();
		updateOption("headerFooterLogoCont", base64_encode(serialize($params)));
	}
}

function clientReportingGetLogo(){
	$headerFooterLogoCont = getOption("headerFooterLogoCont");
	$headerFooterLogoCont = unserialize(base64_decode($headerFooterLogoCont));
	return $headerFooterLogoCont['logoName'];
}

function clientReportingGetHeaderFooterCont(){
	$headerFooterCont = getOption("headerFooterLogoCont");
	$headerFooterData = unserialize(base64_decode($headerFooterCont));
	
	$tableName = '?:options';
	
	$headerFooterData['headerContent']	= html_entity_decode($headerFooterData['headerContent'], ENT_COMPAT, 'UTF-8' );
	$headerFooterData['footerContent']	= html_entity_decode($headerFooterData['footerContent'], ENT_COMPAT, 'UTF-8' );

	$headerFooterCont = array('headerContent' => $headerFooterData['headerContent'], 'footerContent' => $headerFooterData['footerContent']);
	return $headerFooterCont;
}

function clientReportingGetSchedule($params){
	if(!empty($params['clientReportScheduleID'])){
		$tableName = "?:client_report_schedule";
		$where = array(
		      		'query' =>  "clientReportScheduleID = ':clientReportScheduleID' and version = ':version'",
		      		'params' => array(
		      		   ':clientReportScheduleID'=>$params['clientReportScheduleID'],
					   ':version' => 'old'
       				)
    			);
		$getManualSentReport = DB::getRow($tableName, "*", $where);
		$scheduleData = unserialize(base64_decode($getManualSentReport['params']));
		
		$scheduleData['headerFooterLogoCont']['headerContent']	= html_entity_decode($scheduleData['headerFooterLogoCont']['headerContent'], ENT_COMPAT, 'UTF-8' );
		$scheduleData['headerFooterLogoCont']['footerContent']	= html_entity_decode($scheduleData['headerFooterLogoCont']['footerContent'], ENT_COMPAT, 'UTF-8' );
		$scheduleData['clientNote']								= html_entity_decode($scheduleData['clientNote'], ENT_COMPAT, 'UTF-8' );
		$scheduleData['email']['message']						= html_entity_decode($scheduleData['email']['message'], ENT_COMPAT, 'UTF-8' );
		$scheduleData['email']['fromName']						= html_entity_decode($scheduleData['email']['fromName'], ENT_COMPAT, 'UTF-8' );
		$scheduleData['email']['subject']						= html_entity_decode($scheduleData['email']['subject'], ENT_COMPAT, 'UTF-8' );
		$scheduleData['profileName']							= html_entity_decode($scheduleData['profileName'], ENT_COMPAT, 'UTF-8' );
		
		$scheduleData['clientReportScheduleID'] = $getManualSentReport['clientReportScheduleID'];
		return $scheduleData;
	}
}

function manualReportViewGetData(){
	$where = array(
			      		'query' =>  "reportType = ':reportType' and version=':version' ORDER BY ID ASC",
			      		'params' => array(
			      		   ':reportType' => 'manual',
						   ':version' => 'old'
           				)
        			);
	$getManualSentReport = DB::getArray("?:client_report_sent_pdf", "*", $where);
	if(!empty($getManualSentReport))
	foreach($getManualSentReport as $arrKey => $value){
		$paramData = unserialize(base64_decode($value['params']));
		$manualSentReportData[$value['ID']] = array('sendPdfID' => $value['ID'], 'toMail' => unserialize($paramData['toEmail']), 'sitesCount' => $paramData['sitesCount'], 'sentTime' => $value['sentTime'], 'pdfURL' => APP_URL.'uploads/'.unserialize(base64_decode($value['pdfURL'])));
	}
	
	return $manualSentReportData;
}

function clientReportingManualReportViewHTML(){
	$manualSentReportData = manualReportViewGetData();
	$HTML = TPL::get('/addons/clientReporting/templates/manualReportView.tpl.php', array('manualSentReportData' => $manualSentReportData));
	return $HTML;
}


function scheduleReportViewGetData(){
	$table_name = "?:client_report_schedule";
	$where = array(
		'query' => "version=':version' ORDER BY clientReportScheduleID ASC",
		'params' => array(
			":version" => 'old'
		)
	);
	$getSchedule = DB::getArray($table_name, "*", $where);
	if(!empty($getSchedule)){
		foreach($getSchedule as $key => $value){
			$params = unserialize(base64_decode($value['params']));
			$siteIDCount = count($params['siteID']);

			$scheduleReportData[$value['clientReportScheduleID']] = array('clientReportScheduleID' => $value['clientReportScheduleID'], 'profileName' => $params['profileName'], 'siteIDCount' => $siteIDCount, 'period' => $value['period'], 'paused' => $value['paused']);
			$where = array(
			      		'query' =>  "reportType = ':reportType' AND clientReportScheduleID = ':clientReportScheduleID' and version=':version' ORDER BY sentTime DESC",
			      		'params' => array(
			      		   ':reportType' => 'schedule',
			      		   ':clientReportScheduleID' => $value['clientReportScheduleID'],
						   ':version' => 'old'
           				)
        			);

			$getScheduleSentReport = DB::getArray("?:client_report_sent_pdf", "*", $where);
			
			if(empty($getScheduleSentReport)){ continue; }
			foreach($getScheduleSentReport as $arrayKey => $sentReportData){
				$paramData = unserialize(base64_decode($sentReportData['params']));
				$scheduleReportData[$value['clientReportScheduleID']]['data'][$sentReportData['ID']] = array('sentPdfID' => $sentReportData['ID'], 'toMail' => unserialize($paramData['toEmail']), 'sentTime' => $sentReportData['sentTime'], 'pdfURL' =>  APP_URL.'uploads/'.unserialize(base64_decode($sentReportData['pdfURL'])));
			}
		}		

		return $scheduleReportData;
	}
}

function clientReportingScheduleReportViewHTML(){
	$scheduleReportData = scheduleReportViewGetData();
	$HTML = TPL::get('/addons/clientReporting/templates/scheduleReportView.tpl.php', array('scheduleReportData' => $scheduleReportData));
	return $HTML;
}

//Add or Edit Schedule
function clientReportingSchedule($params){
	if(empty($params)){	return false; }
	$params['headerFooterLogoCont']['headerContent'] = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['headerFooterLogoCont']['headerContent']));
	$params['headerFooterLogoCont']['footerContent'] = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['headerFooterLogoCont']['footerContent']));
	$params['clientNote']                           = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['clientNote']));
	$params['email']['message'] 					 = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['email']['message']));
	$params['email']['fromName'] 					 = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['email']['fromName']));
	$params['email']['subject'] 					 = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['email']['subject']));
	$params['profileName']                                           = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['profileName']));
	
	$params['headerFooterLogoCont']['headerContent'] 		= htmlentities($params['headerFooterLogoCont']['headerContent'],ENT_COMPAT,'UTF-8');
	$params['headerFooterLogoCont']['footerContent'] 		= htmlentities($params['headerFooterLogoCont']['footerContent'],ENT_COMPAT,'UTF-8');
	$params['clientNote'] 									= htmlentities($params['clientNote'],ENT_COMPAT,'UTF-8');
	$params['email']['message'] 							= htmlentities($params['email']['message'],ENT_COMPAT,'UTF-8');
	$params['email']['fromName'] 							= htmlentities($params['email']['fromName'],ENT_COMPAT,'UTF-8');
	$params['email']['subject'] 							= htmlentities($params['email']['subject'],ENT_COMPAT,'UTF-8');
	$params['profileName'] 									= htmlentities($params['profileName'],ENT_COMPAT,'UTF-8');
		
	if(empty($params['clientReportScheduleID'])){
		clientReportingHeaderFooterLogoSave($params['headerFooterLogoCont']);
		$nextSchedule = clientReportingNextSchedule($params['period'], $params['schedule']);
		doSetCharsetToUTF8();		
		$addSchedule = DB::insert("?:client_report_schedule", array("profileName" => $params['profileName'], "period" => $params['period'], "schedule" => $params['schedule'], "params" => base64_encode(serialize($params)), "nextSchedule" => $nextSchedule, "paused" => 0));
	
		if($addSchedule){ return true; } else{ return false; }
	}
	else{

		$nextSchedule = clientReportingNextSchedule($params['period'], $params['schedule']);
		$where = array(
			      		'query' =>  "clientReportScheduleID = ':clientReportScheduleID' and version=':version'",
			      		'params' => array(
			      		   ':clientReportScheduleID' => $params['clientReportScheduleID'],
						   ':version' => 'old'
           				)
        			);
		doSetCharsetToUTF8();
		$editSchedule = DB::update("?:client_report_schedule", array("profileName" => $params['profileName'], "period" => $params['period'], "schedule" => $params['schedule'], "params" => base64_encode(serialize($params)), "nextSchedule" => $nextSchedule), $where);
	
		if($editSchedule){ return true; } else{ return false; }
	}
}

//pause or resume the scheduled report
function clientReportingScheduleReportPause($params){
	if(empty($params)){	return false; }
	else{
		$where = array(
			      		'query' =>  "clientReportScheduleID = ':clientReportScheduleID' and version=':version'",
			      		'params' => array(
			      		   ':clientReportScheduleID' => $params['clientReportScheduleID'],
						   ':version' => 'old'
           				)
        			);
		$paused = DB::update("?:client_report_schedule", array('paused' => $params['paused']), $where);
		if($paused){ return true; }
	}
}

function clientReportingScheduleReportDelete($params){
	if(empty($params)){	return false; }
	$where = array(
			      		'query' =>  "clientReportScheduleID = ':clientReportScheduleID' and version=':version'",
			      		'params' => array(
			      		   ':clientReportScheduleID' => $params['clientReportScheduleID'],
						   ':version' => 'old'
           				)
        			);
	$getSentPdfURL = DB::getArray("?:client_report_sent_pdf", "pdfURL", $where);
	if(!empty($getSentPdfURL)){
		foreach($getSentPdfURL as $key => $URL){
			$pdfURL = unserialize(base64_decode($URL['pdfURL']));
			$pdfPath = parse_url($pdfURL);
			$fileNameArray = explode('/', $pdfPath['path']);
			$fileName = end($fileNameArray);
			@unlink(APP_ROOT.'/uploads/'.$fileName);			
		}
	}
	$where = array(
		'query' =>  "clientReportScheduleID = ':clientReportScheduleID' and version=':version'",
		'params' => array(
		   ':clientReportScheduleID' => $params['clientReportScheduleID'],
		   ':version' => 'old'
		)	
	);
	DB::delete("?:client_report_sent_pdf", $where);
	$deleteScheduleAndPdf = DB::delete("?:client_report_schedule", $where);
	
	if($deleteScheduleAndPdf){ return true; } else{ return false; }
}

function clientReportingDeleteSentPdf($params){
	if(empty($params)){	return false; }
	$where = array(
			      		'query' =>  "ID = ':ID' AND reportType = ':reportType'",
			      		'params' => array(
			      		   ':ID' => $params['sentPdfID'],
			      		   ':reportType' => $params['reportType']
           				)
        			);
	$getResult = DB::getArray("?:client_report_sent_pdf", "pdfURL, params", $where);
	$reportParams = unserialize(base64_decode($getResult[0]['params']));
	$pdfURL = unserialize(base64_decode($getResult[0]['pdfURL']));
	if (!empty($reportParams['ftpDetails']) && !empty($reportParams['ftpDetails']['hostName'])) {
		$ftpDetails = $reportParams['ftpDetails'];
		$connection = false;
		$ftpReport  = true;
		if ($ftpDetails['useSftp'] == false ) {
			$connResult = CRFTPDelete($ftpDetails, $connection);
		}else{
			$connResult = CRSFTPDelete($ftpDetails, $connection);
		}
		if ($connResult !== true){
			addNotification($type='E', $title='Client Report Failed!', $message=$connResult['errorMsg'], $state='U', $callbackOnClose='', $callbackReference='');
			return false;
		}
	}else{
		$pdfPath = parse_url($pdfURL);
		$fileNameArray = explode('/', $pdfPath['path']);
		$fileName = end($fileNameArray);
		@unlink(APP_ROOT.'/uploads/'.$fileName);
	}
	$where = array(
	      		'query' =>   "ID=':ID'",
	      		'params' => array(
	               ':ID' => $params['sentPdfID']
   				)
			);	
	$deleteSentPdf = DB::delete("?:client_report_sent_pdf", $where);
	
	$deleteSentPdf = DB::delete("?:client_report_sent_pdf", $where);
	
	if($deleteSentPdf){ return true; } else{ return false; }
}

function clientReportingScheduleReportRunNow($params){
	$res = clientReportingCronRun($params, false);
	if($res){
		addNotification($type='N', $title='Client Report', $message='Run now completed.', $state='U', $callbackOnClose='', $callbackReference='');
	}
	return $res;
}
function fetchReportDetailsUsingID($params = '') {
	needFreshCall(3);

	$tableName = "?:client_report_schedule";
	if(isset($params) && isset($params['runType'])) {
		if($params['runType'] == "scheduleReportNewRunNow"){
			$version = 'new';
		} else if($params['runType'] == "scheduleReportRunNow"){
			$version = 'old';
		} else if ($params['runType'] == 'scheduleReportPhoenixRunNow') {
			$version = 'phoenix';
		}
		$where = array(
						'query' =>  "clientReportScheduleID = ':clientReportScheduleID' and version = ':version'",
						'params' => array(
						   ':clientReportScheduleID' => $params['clientReportScheduleID'],
						   ':version' => $version
						)
					);
	} else {
		$where = array(
			      		'query' =>  "nextSchedule <= ':nextSchedule' AND paused = ':paused'",
			      		'params' => array(
			      		   ':nextSchedule' => time(),
			      		   ':paused' => '0'
           				)
        			);
	}
	$settings = DB::getArray($tableName, "*", $where);
	return($settings);
}
//Run scheduled client report.
function clientReportingCronRun($globalParams = '', $isCron = true) {
	@ob_end_clean();
	$tableName = "?:client_report_schedule";
	$settings = fetchReportDetailsUsingID($globalParams);
	if(!empty($settings)){
		$crOldRunCount = 0;
		foreach($settings as $key => $value) {
			if(
				(
					!empty($value['version']) 
					&& $value['version'] == 'old' 
					&& $crOldRunCount == 0
				) || (
					!empty($value['version']) 
					&& $value['version'] == 'new'		
				) || (
					!empty($value['version']) 
					&& $value['version'] == 'phoenix'
				)
			) {
				
				$params = unserialize(base64_decode($value['params']));
				//calculate the next schedule and update in the DB, Uncomment this later.
				if(
					!empty($globalParams) 
					&& !empty($globalParams['runType']) 
					&& in_array($globalParams['runType'],array("scheduleReportRunNow", "scheduleReportNewRunNow"))
				){
					$nextSchedule = $value['nextSchedule'];
				}
				else{
					$nextSchedule = clientReportingNextSchedule($params['period'], $value['schedule']);	
				}
				$where = array(
							'query' =>  "clientReportScheduleID = ':clientReportScheduleID'",
							'params' => array(
							   ':clientReportScheduleID' => $value['clientReportScheduleID']
							)
						);
				DB::update($tableName, array('nextSchedule' => $nextSchedule), $where);
				returnScheduledReportDates($params);
				$params['clientReportScheduleID'] = $value['clientReportScheduleID'];				
			}
			
			if(!empty($value['version']) && $value['version'] == 'old') {
				if($crOldRunCount == 0) {
					$res = clientReportingCronRunInner($params, $isCron, $tableName);
				}
				$crOldRunCount++;
			} else if(!empty($value['version']) && $value['version'] == 'new') {
				$action = 'runReport';
				$request = array(
					'args' => array(
						'params' => array(
							'action' => $action,
							'clientReportScheduleID' => $params['clientReportScheduleID'],
							'runType' => $params['runType'],
							'requiredData' => array(
								'scheduleReportingNewGeneratePdf' => array(
									'details' => base64_encode(serialize($params)),
									'clientReportScheduleID' => $params['clientReportScheduleID'],
									'action' => $action
								)
							)							
						)
					),
					'action' => $action,						
				);
				$res = panelRequestManager::handler($request);
			} else if(!empty($value['version']) && $value['version'] == 'phoenix') {
				$action = 'runReport';
				$request = array(
					'args' => array(
						'params' => array(
							'action' => $action,
							'clientReportScheduleID' => $params['clientReportScheduleID'],
							'runType' => $params['runType'],
							'requiredData' => array(
								'scheduleReportingPhoenixGenerateHTML' => array(
									'details' => base64_encode(serialize($params)),
									'clientReportScheduleID' => $params['clientReportScheduleID'],
									'action' => $action
								)
							)							
						)
					),
					'action' => $action,						
				);
				$res = panelRequestManager::handler($request);
			}
			
		}
		return $res;
	}
}
function returnScheduledReportDates(&$params) {
	if($params['period'] == 'monthly'){
		$fromDate = date("M d, Y", strtotime("-1 month"));
	}
	else{
		$fromDate = date("M d, Y", strtotime("-1 week"));
	}
	$toDate 				= date("M d, Y");
	$params['dates'] = $fromDate .'-'. $toDate;	
}
function clientReportingCronRunInner($params, $isCron, $tableName) {
	$generateReportparams 	= array("type" =>$params['type'],
								"clientReportScheduleID" => $params['clientReportScheduleID'],
								"action" => $params['action'],
								"siteID" => $params['siteID'],
								"dates" => $params['dates'],
								"headerFooterLogoCont" => array(
									"headerContent" => $params['headerFooterLogoCont']['headerContent'],
									"footerContent" => $params['headerFooterLogoCont']['footerContent'],
									"logoName" => $params['headerFooterLogoCont']['logoName']
								),										
								"view" => $params['period']);
	
	$clientReportGeneratedData = clientReportingGenerate($generateReportparams, $isCron);
	
	if(isset($params['headerFooterLogoCont']['logoName'])){
		$pdfData['logoName'] = $params['headerFooterLogoCont']['logoName'];
	}
	
	$pdfData['headerContent'] 	= stripslashes(str_replace(array("\\r", "\\n") ,array("\r", "\n"), $params['headerFooterLogoCont']['headerContent']));
	$pdfData['footerContent'] 	= stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['headerFooterLogoCont']['footerContent']));
	$pdfData['clientNote'] 		= stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['clientNote']));
	$pdfData['reportType'] 		= "schedule";
	$pdfData['email'] 		= $params['email'];
	$pdfData['email']['message'] 					 = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['email']['message']));
	$pdfData['email']['fromName'] 					 = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['email']['fromName']));
	$pdfData['email']['subject'] 					 = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['email']['subject']));
	$pdfData['profileName'] 	= $params['profileName'];
	$pdfData['clientReportScheduleID'] 	= $params['clientReportScheduleID'];
	$pdfData['dateRange'] 		= $params['dates'];
	
	$pdfData['headerContent']							= html_entity_decode($pdfData['headerContent'], ENT_COMPAT, 'UTF-8' );
	$pdfData['footerContent']							= html_entity_decode($pdfData['footerContent'], ENT_COMPAT, 'UTF-8' );
	$pdfData['clientNote']								= html_entity_decode($pdfData['clientNote'], ENT_COMPAT, 'UTF-8' );

	$pdfData['email']['message']						= html_entity_decode($pdfData['email']['message'], ENT_COMPAT, 'UTF-8' );

	$pdfData['email']['fromName']						= html_entity_decode($pdfData['email']['fromName'], ENT_COMPAT, 'UTF-8' );
	$pdfData['email']['subject']						= html_entity_decode($pdfData['email']['subject'], ENT_COMPAT, 'UTF-8' );
	$pdfData['profileName']								= html_entity_decode($pdfData['profileName'], ENT_COMPAT, 'UTF-8' );
	$pdfData['report_generated_for_the_period']			= $clientReportGeneratedData['report_generated_for_the_period'];
	$pdfData['client_note']								= $clientReportGeneratedData['client_note'];
				
	$emptyTask = true;
	if(!empty($clientReportGeneratedData['result'])){
		foreach($clientReportGeneratedData['result'] as $siteID => $typeName){
			$val = array();
			if(!empty($typeName)){
			foreach($typeName as $type => $success){
				foreach($success as $countValue){
					$val[$type] = $countValue;
				}
			}
			$pdfData['siteID'][$siteID] = $val;
				$emptyTask = false;
			}
		}
	}
		
	if(empty($clientReportGeneratedData['result']) || $emptyTask == true ){ // it will send a mail to the panel admin (from email mentioned in the schedule.) abt no tasks or pdf.
		$pdfData['email']['message'] = "No operations were performed during ".$pdfData['dateRange']." in your reporting schedule - <strong>".$params['profileName']."</strong>. So the report was not emailed to the client.";
		$pdfData['email']['toEmail'] = $params['email']['fromEmail'];
		return sendMailPdfAttach($pdfData['email'], $isCron);
	}
	$res = clientReportingGeneratePdf($pdfData, $isCron, $tableName);
	return $res;
}

function clientReportingNextSchedule($type, $schedule){
	
	$schedule = explode("|", $schedule);
	if (empty($schedule))
		return false;
	switch ($type) {
				
		case 'weekly':
			if (isset($schedule[2]) && $schedule[2]) {
				$delay_time = $schedule[2] * 60;
			}
			$current_weekday  = date('w');
			$schedule_weekday = $schedule[1];
			$current_hour     = date("H");
			$schedule_hour    = $schedule[0];
			
			if ($current_weekday > $schedule_weekday)
				$weekday_offset = 7 - ($current_weekday - $schedule_weekday);
			else
				$weekday_offset = $schedule_weekday - $current_weekday;
			
			
			if (!$weekday_offset) { //today is scheduled weekday
				if ($current_hour >= $schedule_hour)
					$time = mktime($schedule_hour, 0, 0, date("m"), date("d") + 7, date("Y"));
				else
					$time = mktime($schedule_hour, 0, 0, date("m"), date("d"), date("Y"));
			} else {
				$time = mktime($schedule_hour, 0, 0, date("m"), date("d") + $weekday_offset, date("Y"));
			}
			
			break;
		
		case 'monthly':
			if (isset($schedule[2]) && $schedule[2]) {
				$delay_time = $schedule[2] * 60;
			}
			$current_monthday  = date('j');
			$schedule_monthday = $schedule[1];
			$current_hour      = date("H");
			$schedule_hour     = $schedule[0];
			
			if ($current_monthday > $schedule_monthday) {
				$time = mktime($schedule_hour, 0, 0, date("m") + 1, $schedule_monthday, date("Y"));
			} else if ($current_monthday < $schedule_monthday) {
				$time = mktime($schedule_hour, 0, 0, date("m"), $schedule_monthday, date("Y"));
			} else if ($current_monthday == $schedule_monthday) {
				if ($current_hour >= $schedule_hour)
					$time = mktime($schedule_hour, 0, 0, date("m") + 1, $schedule_monthday, date("Y"));
				else
					$time = mktime($schedule_hour, 0, 0, date("m"), $schedule_monthday, date("Y"));
				break;
			}
			
			break;
		default:
			break;
	}
	
	if (isset($delay_time) && $delay_time) {
		$time += $delay_time;
	}
	
	return $time;

}

function clientReportingGenerate($params, $isCron = false){
	
	$result_temp = array(
		'report_generated_for_the_period' => (L('report_generated_for_the_period')?L('report_generated_for_the_period'):'Report generated for the period'),
		'notes' => (L('client_note')?L('client_note'):'CLIENT NOTE')
	);
	
	if(empty($params) || empty($params['action'])){ 
		addNotification($type='E', $title='Invalid parameters', 'Invalid parameters you have requested.', $state='U', $callbackOnClose='', $callbackReference='');
		$result = array('result' => array());
		$result = array_merge($result, $result_temp);
		unset($result_temp);		
		return $result; 
	}
	
	if(in_array('themes',$params['action'])) $params['action'][]='theme';
	
	clientReportingHeaderFooterLogoSave($params['headerFooterLogoCont']);	
	
	$params['headerFooterLogoCont']['headerContent'] 		= htmlentities($params['headerFooterLogoCont']['headerContent'],ENT_COMPAT,'UTF-8');
	$params['headerFooterLogoCont']['footerContent'] 		= htmlentities($params['headerFooterLogoCont']['footerContent'],ENT_COMPAT,'UTF-8');
	
	if(!empty($params['dates'])){

		$dates 		= explode('-', $params['dates']);
		$fromDate 	= strtotime(trim($dates[0]));
		$toDate		= strtotime(trim($dates[1]));
		//$result['dateRange'] 	= date("M d, Y", $fromDate) .'-'. date("M d, Y", $toDate);
		if(!empty($fromDate) && !empty($toDate) && $fromDate != -1 && $toDate != -1){
			$action = '';
			
			$typeIn = $params['type'];
			if(is_array($typeIn)){
				//if(in_array('backup', $params['type'])){//old code - backup count not working
	//				$action = "OR (type = 'scheduleBackup' AND action = 'runTask')";
	//			}
				
				if(in_array('backup', $typeIn)){//new code
					$action = "OR 
					(
					(type = 'backup' AND (action = 'now' OR  action = 'multiCallNow')) 
					OR 
					(type = 'scheduleBackup' AND (action = 'runTask' OR  action = 'multiCallRunTask'))
					
				)";
					if(($key = array_search('backup', $typeIn)) !== false) {
						unset($typeIn[$key]);
					}
					
				}
			}
			$toDate += 86399;
			$dateQuery = "( ( type IN ('".implode("','", array_unique(DB::esc($typeIn)))."') AND action != 'get') ".$action." ) AND microtimeAdded >= ".DB::esc($fromDate)." AND  microtimeAdded <= ".DB::esc($toDate)." ";
		}
	}
	
	$siteName = array();
	$data = array();
	foreach($params['siteID'] as $siteIDs => $siteID){
		$data[$siteID] = array();
		$actionsHistoryData = array();
		$where1 = array(
		      		'query' =>  "siteID = ':siteID' AND ".$dateQuery."GROUP BY actionID ORDER BY historyID",
		      		'params' => array(
		      		   ':siteID' => $siteID
       				)
    			);

		$actionIDs = DB::getFields("?:history", "actionID", $where1);
		$where = array(
					'query' => "siteID = ':siteID'",
					'params' => array(
							':siteID' => $siteID
					)
				);
		$siteName[] = DB::getField("?:sites", "name", $where);
		
		if(!empty($actionIDs)){ 
			$actionsHistoryData = array();
			foreach($actionIDs as $actionID){
				$actionsHistoryData[ $actionID ] = panelRequestManager::getActionStatus($actionID);
				unset($actionIDs);
			}
		if(!empty($actionsHistoryData) && is_array($actionsHistoryData))
		foreach($actionsHistoryData as $actionID => $actionData){
			//if(in_array($actionData['type'], $params['type'])){
				if($actionData['type'] == "PTC" && !empty($params['action'])){
					foreach($params['action'] as $actionKey => $action){
						foreach($actionData['detailedStatus'] as $key => $detailedAction){
								if($detailedAction['siteID'] == $siteID && $detailedAction['detailedAction'] == $action){
								array_push($params['type'], $action);
								if($detailedAction['status'] == 'success')
								$data[$siteID][$detailedAction['detailedAction']][] = $actionData['status'];
							}
						}
					}
					
				}else{
					foreach($actionData['detailedStatus'] as $key => $detailedAction){
						if($detailedAction['siteID'] == $siteID && $detailedAction['status'] == 'success')
						$data[$siteID][$actionData['type']][] = $detailedAction['status'];
					}
				}
			//}		
		}
		}else{
			if(!in_array('googleAnalytics', $params['type']) && !in_array('malwareScanningSucuri', $params['type']))
				continue;
		}
		if(in_array('googleAnalytics', $params['type'])){
			if(function_exists('googleAnalyticsGetProfileData')){
				$where = array(
				      		'query' =>  "siteID = ':siteID'",
				      		'params' => array(
				      		   ':siteID' => $siteID
	           				)
	        			);
				$profileID = DB::getField("?:google_analytics_profiles_sites", "gaProfileID", $where);
				if(!empty($profileID)){
					$args['siteID'] = $siteID;
					//$args['view'] = ($params['view'] == "monthly") ? "month" : "week";
					$args['clientReportAnalyticsDate']['startDate'] = date('Y-m-d', $fromDate);
					$args['clientReportAnalyticsDate']['endDate'] = date('Y-m-d', $toDate);
					$GAPD = googleAnalyticsGetProfileData($args);
					if(!empty($GAPD))
					$data[$siteID]['googleAnalytics'] = $GAPD;
				}
			}
		}
		
		/*if(in_array('malwareScanningSucuri', $params['type'])){
			if(DB::getExists("SHOW TABLES LIKE '?:other_history'"))
			$data[$siteID]['malwareScanningSucuri'] = DB::getField("?:other_history", "count(status)", "type = 'malwareScanningSucuri' AND siteID	= '".$siteID."' AND status = 'completed'");
		}*/
	}
	
	$result = array();
	
	if(!empty($params['type']) && is_array($params['type']))
	foreach($params['type'] as $key => $type){
		foreach($data as $sID => $actionType){
			if(empty($actionType)) $result[$sID] = array();
			if($type == 'backup' && !empty($actionType['scheduleBackup'])){ $actionType[$type] = @array_merge($actionType['scheduleBackup'], (array)$actionType[$type]); }
			if($type == 'googleAnalytics' && !empty($actionType['googleAnalytics'])){
				foreach($actionType['googleAnalytics'] as $gaType => $gaValue){
					
					$floatVal = floatval ($gaValue);
					$val = round($floatVal, 2);
					
					if($gaType == 'ga:percentNewVisits' || $gaType == 'ga:bounceRate')
					$val = $val.'%';
					
					$result[$sID][L($gaType)] = array('success' => $val);	
				}
			}
			else{
				if(is_array($actionType[$type])){
					$result[$sID][L($type)] = @array_count_values($actionType[$type]);	
				}
			}
		}
	}
	
	if($params['combinedSitesReport'] == 'yes'){
		$dataAll = array();
		$siteName = implode(", ", $siteName);
		foreach($result as $siteID => $type){
			foreach($type as $status => $value){
				foreach($value as $key => $var){
					$dataAll[$siteName][$status][$key]+=$var;
				}
			}
		}
		$result = $dataAll;
	}
	$result = array(
		'result' => $result
	);
	$result = array_merge($result, $result_temp);
	unset($result_temp);
	return $result;
	
}

function clientReportingGeneratePdf($params, $isCron = false, $tableName=''){
if($isCron == false)  {
	ob_end_clean();
}
if(isset($params['logoName'])){
    $logoName = $params['logoName'];
}
else
{
    $logoName = clientReportingGetLogo();
}
$footerContent = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['footerContent']));
$clientNote = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), nl2br($params['clientNote'])));
$reportTitle = $params['reportTitle'];
$headerContent = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['headerContent']));
$dateRange = $params['dateRange'];

define('FOOTERCONTENT', $footerContent);

require_once(APP_ROOT.'/addons/clientReporting/lib/tcpdf/config/lang/eng.php');
require_once(APP_ROOT.'/addons/clientReporting/lib/tcpdf/tcpdf.php');

//if(class_exists('MYPDF') != true){

class MYPDF extends TCPDF {

    // Page footer
    public function Footer() {
        // Position at 15 mm from bottom
        $this->SetY(-15);
        // Set font
        $this->SetFont('helvetica', 'I', 8);
        
		// Footer Content
        $this->Cell(10, 10, FOOTERCONTENT, 'T', false, 'L', 0, '', 0, false, 'T', 'M');
		
		// Page number
		$this->Cell(0, 10, 'Page '.$this->getAliasNumPage().'/'.$this->getAliasNbPages(), T, false, 'R', 0, '', 0, false, 'T', 'M');
    }
}

//}
// create new PDF document
$pdf = new MYPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

//$pdf = new MYPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, false, 'ISO-8859-1', false);

// set default header data
//$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE.' 001', PDF_HEADER_STRING);

// set default header data
$pdf->SetHeaderData( $logoName, PDF_HEADER_LOGO_WIDTH, '', $headerContent);

// set header and footer fonts
$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

// set default monospaced font
$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

//set margins
$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);

$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

//set auto page breaks
$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

//set image scale factor
$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

//set some language-dependent strings
$pdf->setLanguageArray($l);

// set default font subsetting mode
$pdf->setFontSubsetting(true);

// set font
$pdf->SetFont('helvetica', '', 11);

// add a page
$pdf->AddPage();

$clientNoteArea = '';
if(!empty($clientNote)){
	$clientNoteArea = '<div style="border-top:1px solid #d2d5d7; border-bottom:1px solid #d2d5d7; margin:20px; padding:10px; line-height: 5px;"><div style="color:#525556; font-weight:bold; padding:10px;">'.(L('client_note')?L('client_note'):'CLIENT NOTE').'</div>'.$clientNote.'</div>';
}

if(!empty($params['siteID']) && is_array($params['siteID'])){
	$sitesCount = count($params['siteID']);
	$report_generated_for_the_period = L('report_generated_for_the_period') ? L('report_generated_for_the_period') : 'Report generated for the period';
$tb = <<<EOF
		$report_generated_for_the_period - $dateRange
EOF;
$pdf->writeHTML($tb, true, false, false, false, '');
foreach($params['siteID'] as $siteID => $data){
	$where = array(
			      		'query' =>  "siteID = ':siteID'",
			      		'params' => array(
			      		   ':siteID' => $siteID
           				)
        			);
	$siteName = DB::getField("?:sites", "name", $where);
	if(!$siteName){
		$siteName = $siteID;
	}
	$pdfHTML = '';
	foreach($data as $key => $value){
		$pdfHTML =  $pdfHTML.'<tr><td>'.$key.'</td> <td>'.$value.'</td></tr>';
	}
	 
$tbl = <<<EOF
	<style>
	.creport_data_table tr td{ border-bottom: 1px solid #eee;}
	</style>
	<br /><br />
	<table class="creport_data_table" border="0" cellpadding="5" cellspacing="0" nobr="true" style="border-collapse: collapse; border: 1px solid #D2D5D7; margin-top:10px;">
	
	 <tr style="background-color:#E5E8E9; color:#525556;">
	  <th colspan="2" align="left">$siteName</th>
	 </tr>
	 $pdfHTML
	 </table>
EOF;

 $pdf->writeHTML($tbl, true, false, false, false, '');
}
}

$tb2 = <<<EOF
<div style="clear:both"></div>
$clientNoteArea
<div style="clear:both"></div>
EOF;

$pdf->writeHTML($tb2, true, false, false, false, '');
  	//Close and output PDF document
	$path = APP_ROOT.'/uploads/';
	$fileName = 'clientReport-'.md5(date('m-d-Y-').microtime()).'.pdf';
	
	if($params['reportType'] == 'schedule' || $params['generatePdfAndSendMail'] == '1'){
		$pdf->Output($path.$fileName, 'F');
                $params['email']['message'] 					 = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['email']['message']));
                $params['email']['fromName'] 					 = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['email']['fromName']));
                $params['email']['subject'] 					 = stripslashes(str_replace(array("\\r", "\\n"), array("\r", "\n"), $params['email']['subject']));

		$sendMail = sendMailPdfAttach($params['email'], $isCron, $path.$fileName, $tableName);
		if($sendMail){
			doSetCharsetToUTF8();			
			DB::insert("?:client_report_sent_pdf", array('clientReportScheduleID' => $params['clientReportScheduleID'], 'profileName' => $params['profileName'], 'params' => base64_encode(serialize(array('toEmail' => serialize($params['email']['toEmail']), 'sitesCount' => $sitesCount))), 'pdfURL' => base64_encode(serialize($fileName)), 'reportType' => $params['reportType'], 'sentTime' => time()));
			return true;
		}
	}
	else{
		$pdf->Output($fileName, 'D');
		exit;
	}
}

function sendMailPdfAttach($params, $isCron = false, $attachment='', $tableName=''){
	$options = array();
	$options['attachment'] = $attachment;
	$emailSettings = getOption("emailSettings");
	if($emailSettings){
		$emailSettings = unserialize($emailSettings);
	}
	$options['emailSettings'] = $emailSettings;
	$options['CharSet'] = 'utf-8';
	
	$message = nl2br($params['message']);
	
	$list = get_html_translation_table(HTML_ENTITIES);
	unset($list['"']);
	unset($list['<']);
	unset($list['>']);
	unset($list['&']);

	$search = array_keys($list);
	$values = array_values($list);

	$message = str_replace($search, $values, $message);		

	$from = $params['fromEmail'];

	$fromName = $params['fromName'];
	$toEmails = explode(',', $params['toEmail']);
	
	$subject = $params['subject'];	
	
	$successCount = 0;
	foreach($toEmails as $key => $toEmail){
		$to = trim($toEmail);
		$isSent = sendMail($from, $fromName, $to, $toName, $subject, $message, $options);
		if($isSent) {
			$successCount++;
			if($isCron === false) {
				addNotification($type='N', $title='Client Report', $mes='E-Mail Sent Successfully to '.$to.'.', $state='U', $callbackOnClose='', $callbackReference='');
			}
		} else {
			if($isCron === false) {
				addNotification($type='E', $title='Client Report', $mes='E-Mail Sent failed to '.$to.'.', $state='U', $callbackOnClose='', $callbackReference='');
			}
		}
	}
	
	return $successCount;	
}

if(!function_exists('L')){
	function L($var){
		return $GLOBALS['LANG'][$var];
	}
}

function showCustomLanUpdateNotes(){
	$showCustomLanUpdateNotes = getOption('showCustomLanUpdateNotes');
	if ($showCustomLanUpdateNotes && defined('CLIENT_REPORTING_LANG') && file_exists(APP_ROOT.'/addons/clientReporting/lang/'.CLIENT_REPORTING_LANG.'.php')) {
		return 1;
	}
}

function confirmCustomLanUpdateNotes(){
	updateOption('showCustomLanUpdateNotes', 0);
}

function clientReportingHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('clientReporting');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/clientReporting/css/report.css')),
		array('css' => array('href' => 'addons/clientReporting/css/spectrum.css')),
		array('css' => array('href' => 'addons/clientReporting/css/reportNew.css')),
		array('js' => array('href' => 'addons/clientReporting/js/functions.js')),
		array('js' => array('href' => 'addons/clientReporting/js/spectrum.js')),
		array('js' => array('href' => 'addons/clientReporting/js/init.js')),
		array('js' => array('href' => 'addons/clientReporting/js/load.js')),
		array('js' => array('href' => 'addons/clientReporting/js/functionsNew.js')),
		array('js' => array('href' => 'addons/clientReporting/js/initNew.js')),
		array('js' => array('href' => 'addons/clientReporting/js/loadNew.js')),
		array('js' => array('href' => 'js/jquery.json-keycount.js'))	
	);
	$headFiles['clientReporting'] = $addonDetails;
	?>
	<script >
	var showCustomLanUpdateNotes = <?php echo showCustomLanUpdateNotes() ? 1 : 0; ?>;
	</script>
	<?php
}