<?php

function codeSnippetsAddonMenus(&$menus){
	$menus['tools']['subMenus'][] = array('page' => 'codeSnippets', 'displayName' => 'Code Snippets');
}

function codeSnippetsAdd($params){
	if(empty($params)){
		return false;
	}
	$where = array(
	      		'query' =>  "cmdName = ':cmdName'",
	      		'params' => array(
	      		   ':cmdName' => $params['cmdName']
   				)
			);
	$exists = DB::getExists("?:code_snippets", "cmdName", $where);
	
	
	if(!$exists){
		$cmd = stripslashes(str_replace("\\r","\r",str_replace("\\n","\n",$params['cmd'])));
        $cmdName = stripslashes(str_replace("\\r","\r",str_replace("\\n","\n",$params['cmdName'])));
		$query = DB::insert("?:code_snippets", array("cmdName" => $cmdName, "cmd" => $cmd));
		if(!empty($query)){
			return $query;
		}
		else{
			return "Oops! Try again.";
		}
	}
	else{
		return "Snippet already exists.";
	}
}

function codeSnippetsGet($params){
	if(empty($params)){
		return false;
	}
	$where = array(
	      		'query' =>  "cmdID = ':cmdID'",
	      		'params' => array(
	      		   ':cmdID' => $params['cmdID']
   				)
			);
	$data = DB::getRow("?:code_snippets", "*", $where);
	
	
	if(!empty($data)){
		$data['cmd'] = $data['cmd'];
		$data['cmdID'] = $params['cmdID'];
		return $data;
	}
	else{
		return false;
	}
}

function codeSnippetsUpdate($params){
	if(empty($params)){
		return false;
	}

	if(!empty($params['cmdID'])){
		$cmd = stripslashes(str_replace("\\r","\r",str_replace("\\n","\n",$params['cmd'])));
        $where = array(
	      		'query' =>  "cmdID = ':cmdID'",
	      		'params' => array(
	      		   ':cmdID' => $params['cmdID']
   				)
			);
		$query = DB::update("?:code_snippets", array("cmd" => $cmd), $where);
		if(!empty($query)){
			return $query;
		}
		else{
			return "Oops! Try again.";
		}
	}
	else{
		return "Snippet not exists.";
	}
}


function codeSnippetsGetAll(){
	$snippets = DB::getArray("?:code_snippets", "*", "1 ORDER BY cmdID DESC");
	
	if(!empty($snippets)){
		return $snippets;
	}
	else{
		return false;
	}
}

function codeSnippetsGetAllHTML(){
	$snippets = codeSnippetsGetAll();
	$HTML = TPL::get('/addons/codeSnippets/templates/view.tpl.php', array('snippets' => $snippets));
	return $HTML;
	
}

function codeSnippetsDelete($params){
	if(empty($params)){
		return false;
	}
	$where = array(
	      		'query' =>   "cmdID=':cmdID'",
	      		'params' => array(
	               ':cmdID' => $params['cmdID']
   				)
			);	
	return DB::delete("?:code_snippets", $where);
	
}

function codeSnippetsResult(){
	
	$actionID = Reg::get('currentRequest.actionID');
	$where = array(
	      		'query' =>  "type = ':type' AND paramID = ':paramID'",
	      		'params' => array(
	      		   ':type' => 'codeSnippets',
	      		   ':paramID' => $actionID
   				)
			);	
	$responseDatas = DB::getFields("?:temp_storage", "data", $where);

	$where = array(
	      		'query' =>  "type = ':type' AND paramID = ':paramID'",
	      		'params' => array(
	      		   ':type' => 'getUsers',
	      		   ':paramID' => $actionID
   				)
			);			
	DB::delete("?:temp_storage", $where);	
		
	if(empty($responseDatas)){
		return array();
	}
	$finalData = array();
	foreach($responseDatas as $data){
		$finalData = array_merge_recursive($finalData, (array)unserialize($data));	
	}
	arrayMergeRecursiveNumericKeyHackFix($finalData);
	return $finalData;
}


function codeSnippetsResponseProcessors(&$responseProcessor){
	$responseProcessor['codeSnippets']['execute'] = 'codeSnippetsRunCmd';
}

function codeSnippetsTaskTitleTemplate(&$template){
	$template['codeSnippets']['execute']['']	= "Run code in <#sitesCount#> site<#sitesCountPlural#>";
}

function codeSnippetsHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('codeSnippets');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/codeSnippets/css/code_snippets_styles.css')),
		array('js' => array('href' => 'addons/codeSnippets/js/functions.js')),
		array('js' => array('href' => 'addons/codeSnippets/js/init.js')),
		array('js' => array('href' => 'addons/codeSnippets/js/load.js')),
	);
	$headFiles['codeSnippets'] = $addonDetails;
}