<?php
function duoSecurityErrorMsgTemplate(&$errorMsg){
	$errorMsg['duoConnectionError'] = 'Have some problem with Duo Security integration.';
        $errorMsg['duoFailed'] = 'Duo Security authentication Failed.';
}

function duoSecuritySecuritySettingsUpdate(&$settings){
	if(!empty($settings['duoAuth'])){
            $duoAuthInfo = array('duo_ikey'=>$settings['duoAuth']['duo_ikey'], 'duo_skey'=>$settings['duoAuth']['duo_skey'], 'duo_api_host'=>$settings['duoAuth']['duo_api_host']);
            updateOption('duoAuthIntegration', serialize($duoAuthInfo));
        }
}

function getDuoFrame($userName) {
    if(isExistOption('duoAuthIntegration')) {
        require_once(APP_ROOT."/addons/duoSecurity/lib/duo_web.php");
        $duoIntegrationInfo = unserialize(getOption('duoAuthIntegration'));
        $aKey = getDuoAppSign();
        $ikey = $duoIntegrationInfo['duo_ikey'];
        $skey = $duoIntegrationInfo['duo_skey'];
        $duoHost = $duoIntegrationInfo['duo_api_host'];
        $sig_request = Duo::signRequest($ikey, $skey, $aKey, $userName);
        $duoFrameStr = '<style>#duo_iframe {margin-left: -129px;}</style><script src="'.APP_URL.'addons/duoSecurity/lib/Duo-Web-v1.bundled.min.js"></script><input type="hidden" id="duo_host" value="'.$duoHost.'"><input type="hidden" id="duo_sig_request" value="'.$sig_request.'"><input type="hidden" type><script src="'.APP_URL.'addons/duoSecurity/lib/Duo-Init.js"></script><iframe id="duo_iframe" width="620" height="500" frameborder="0" allowtransparency="true" style="background: transparent;"></iframe>';
        return $duoFrameStr;
    } else {return false;}
}

function getDuoAppSign() {
    if(!(isExistOption('duoAppSign'))) {
        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $randstring = '';
        for ($i = 0; $i < 45; $i++) {
            $randstring .= $characters[rand(0, strlen($characters))];
        }
        updateOption('duoAppSign', $randstring);
        return $randstring;
    } else {
        return getOption('duoAppSign');
    }
}

function verifyDuoSign($params) {
    if(isExistOption('duoAuthIntegration')) {
        require_once(APP_ROOT."/addons/duoSecurity/lib/duo_web.php");
        $duoIntegrationInfo = unserialize(getOption('duoAuthIntegration'));
        $aKey = getDuoAppSign();
        $ikey = $duoIntegrationInfo['duo_ikey'];
        $skey = $duoIntegrationInfo['duo_skey'];
        $duoHost = $duoIntegrationInfo['duo_api_host'];
        $resp = Duo::verifyResponse($ikey, $skey, $aKey, $params['sig_response']);
	if($resp != NULL){
		loginByUserName($resp);
                header('Location: '.APP_URL); //'Location: ' => index.php
                exit;
	}
    } else {return false;}
}

function getDuoSettings() {
    if(isExistOption('duoAuthIntegration')) {
        $duoIntegrationInfo = unserialize(getOption('duoAuthIntegration'));
    } else {
        $duoIntegrationInfo = array('duo_ikey'=>'', 'duo_skey'=>'', 'duo_api_host'=>'');
    }
    return $duoIntegrationInfo;
}

function duoSecurityHeadHTMLFiles(&$headFiles){
    $addonDetails['version'] = getAddonVersion('duoSecurity');
    $addonDetails['files'] = array(
        array('css' => array('href' => 'addons/duoSecurity/css/duoSecurity.css')),
        array('js' => array('href' => 'addons/duoSecurity/js/functions.js')),
        array('js' => array('href' => 'addons/duoSecurity/js/load.js')),
        array('js' => array('href' => 'addons/duoSecurity/js/init.js')),
    );
    $headFiles['duoSecurity'] = $addonDetails;
    $GLOBALS["duoSettings"]  =  json_encode(array("data"=>panelRequestManager::requiredData(array("getDuoSettings"=>1))));
 ?>
 <script>
    var duoSettings = <?php echo $GLOBALS["duoSettings"]; ?>;
 </script>
 <?php }