<?php

function fileEditorAddonMenus(&$menus){
	$menus['tools']['subMenus'][] = array('page' => 'fileEditor', 'displayName' => 'File Uploader');
}

function fileEditorResponseProcessors(&$responseProcessor){
	$responseProcessor['fileEditor']['fileUpload'] = 'fileEditorUpload';
}

function fileEditorTaskTitleTemplate(&$template){
	$template['fileEditor']['fileUpload']['']	= "Uploading 1 file to <#sitesCount#> site<#sitesCountPlural#>";
}

function fileEditorUploader(){
	$actionID = Reg::get('currentRequest.actionID');
	$where = array(
	      		'query' =>  "type = ':type' AND paramID = ':paramID'",
	      		'params' => array(
	      		   ':type' => 'fileEditor',
	      		   ':paramID' => $actionID
   				)
			);	
	$linkData = DB::getFields("?:temp_storage", "data", $where);

	
		
	DB::delete("?:temp_storage", $where);
		
	if(empty($linkData)){
		return array();
	}
	$refinedData = array();

	foreach($linkData as $data){
		$refinedData = array_merge_recursive($refinedData, (array)unserialize($data));	
	}
	arrayMergeRecursiveNumericKeyHackFix($refinedData);
	foreach($refinedData as $siteID => $links){
		$where = array(
		      		'query' =>  "siteID = ':siteID'",
		      		'params' => array(
		      		   ':siteID' => $siteID
       				)
    			);
		$siteData = DB::getRow("?:sites","URL",$where);

		
		$refinedData['siteURLs'][] = $siteData['URL'];
		$refinedData['siteIDs'][] = $siteID;
	}

	return $refinedData;
}

function fileEditorHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('fileEditor');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/fileEditor/css/fileEditor.css')),
		array('js' => array('href' => 'addons/fileEditor/js/functions.js')),
		array('js' => array('href' => 'addons/fileEditor/js/init.js')),
		array('js' => array('href' => 'addons/fileEditor/js/load.js')),
	);
	$headFiles['fileEditor'] = $addonDetails;
}