<?php

/*
slug: googleAnalytics
version: 1.1.5
*/

class addonGoogleAnalytics{
	
	private static $version = '1.1.5';

	public static function version(){
		return self::version;	
	}
	
	public static function init(){
		require_once(APP_ROOT."/addons/googleAnalytics/controllers/func.php");	
		panelRequestManager::addFunctions('googleAnalyticsGetProfileData', 'googleAnalyticsFetchFreshProfiles', 'googleAnalyticsEditSiteOptions', 'googleAnalyticsInstallPopulateSites','googleAnalyticsSetProfilesAndSites','googleAnalyticsActiveSites', 'googleAnalyticsGrantAccess', 'googleAnalyticsSaveAPIKeys', 'googleAnalyticsSaveAPIKeysAndRedirect', 'googleAnalyticsGetAPIKeys','googleAnalyticsMappedSites', 'googleAnalyticsGetConnectedAccounts', 'googleAnalyticsRemoveAccount', 'googleAnalyticsUpdateProfileData', 'googleAnalyticsUpdateAllProfileData','removeUnwantedProfiles');
		regHooks('addonMenus', 'responseProcessors', 'taskTitleTemplate','postAddSite', 'runOffBrowserLoad','removeSite', 'headHTMLFiles');
	}	
	
	public static function install(){
		
	
		$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:google_analytics_profiles` (
	  `gaID` int(10) unsigned NOT NULL,
	  `gaSiteURL` varchar(255) NOT NULL,
	  `gaProfileName` varchar(255) NOT NULL,
	  `gaProfileID` int(10) unsigned DEFAULT NULL,
	  `gaParams` text NOT NULL,
	  `gaDefault` enum('0','1') NOT NULL DEFAULT '0',
	  UNIQUE  `gaID_gaProfileID` (  `gaID` ,  `gaProfileID` )
	)".DB::getSQLTableEnv().";");
	
	
	$Q2 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:google_analytics_profiles_sites` (
	  `siteID` int(10) unsigned DEFAULT NULL,
	  `gaProfileID` varchar(15) DEFAULT NULL,
	  `gaID` int(10) unsigned NOT NULL,
	  UNIQUE KEY `siteID` (`siteID`,`gaProfileID`),
	  UNIQUE KEY `siteID_2` (`siteID`)
	)".DB::getSQLTableEnv().";");


	$Q3 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:google_analytics_accounts_details` (
			  `gaID` int(10) unsigned NOT NULL AUTO_INCREMENT,
			  `userID` int(10) unsigned DEFAULT NULL,
			  `gaUsername` varchar(100)  DEFAULT NULL,
			  `gaAccName` text NOT NULL,
			  `gaAccessToken` longtext NOT NULL,
			  PRIMARY KEY (  `gaID` ),
			  UNIQUE KEY `gaUsername` (`gaUsername`)
			)".DB::getSQLTableEnv().";");
	
	if($Q1 && $Q2 && $Q3){
			return true;	
		}
		return false;
	}

	public static function update(){
		
		if(version_compare(getOldAddonVersion('googleAnalytics'), '1.0.8', '<')){
			//from v1.0.8 Google API Lib is kept common in base app, so deleting common API files here
			$deleteFiles = array(
				'/addons/googleAnalytics/lib/authHelper.php' => array('type' => 'f'),
				'/addons/googleAnalytics/lib/storage.php' => array('type' => 'f'),
				'/addons/googleAnalytics/lib/src' => array('type' => 'd'),
				);
			fileSystemRemoveFiles($deleteFiles);
		}

		if(version_compare(getOldAddonVersion('googleAnalytics'), '1.0.16', '<')){
			DB::doQuery("DELETE FROM `?:google_analytics_profiles_sites` WHERE siteID NOT IN (SELECT siteID FROM `?:sites`) ");
		}
		if(version_compare(getOldAddonVersion('googleAnalytics'), '1.1.0beta1', '<')){
			self::convertDBToV1_1();
		}
		if(version_compare(getOldAddonVersion('googleAnalytics'), '1.1.2beta1', '<')){
			$deleteFiles = array('/addons/googleAnalytics/initHTMLHead.php' => array('type' => 'f') );
			fileSystemRemoveFiles($deleteFiles);
		}
		
		return true;
	}

	private function convertDBToV1_1(){

			$Q3 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:google_analytics_accounts_details` (
				  `gaID` int(10) unsigned NOT NULL AUTO_INCREMENT,
				  `userID` int(10) unsigned DEFAULT NULL,
				  `gaUsername` varchar(100)  DEFAULT NULL,
				  `gaAccName` text NOT NULL,
				  `gaAccessToken` longtext NOT NULL,
				  PRIMARY KEY (  `gaID` ),
				  UNIQUE KEY `gaUsername` (`gaUsername`)
				)".DB::getSQLTableEnv().";");
			

			$GAP  = DB::getArray("?:google_analytics_profiles", "*", "1");
			$gaAccessToken = getOption('googleAnalyticsAccessToken');
			if(!(DB::getExists("SHOW COLUMNS FROM `?:google_analytics_profiles` WHERE Field = 'gaID'"))){
				DB::doQuery("ALTER TABLE `?:google_analytics_profiles` ADD `gaID` INT(10) UNSIGNED NULL FIRST");
			}
			if(!(DB::getExists("SHOW COLUMNS FROM `?:google_analytics_profiles_sites` WHERE Field = 'gaID'"))){
				DB::doQuery("ALTER TABLE `?:google_analytics_profiles_sites` ADD `gaID` INT(10) UNSIGNED NULL DEFAULT NULL");
			}
			if (!empty($GAP)) {
				$gaID= DB::insert("?:google_analytics_accounts_details",array("userID" => $GAP[0]['userID'], "gaUsername" => $GAP[0]['gaUsername'], "gaAccName" => $GAP[0]['gaAccName'], "gaAccessToken" => $gaAccessToken));
				$profileIDs = array();
				foreach ($GAP as $key) {
					array_push($profileIDs, $key['gaProfileID']);
				}
				$in = implode("','", DB::esc($profileIDs));
				if (DB::getExists("?:google_analytics_profiles", "gaID", "gaID IS NULL")) {
					DB::update("?:google_analytics_profiles","gaID='".$gaID."'","gaProfileID IN ('".$in."')");
				}
				$siteProfileIDs = DB::getFields("?:google_analytics_profiles_sites", "gaProfileID", "gaProfileID IS NOT NULL");
				$in = implode("','", $siteProfileIDs);
				if (!empty($siteProfileIDs)) {
					$where = array(
					      		'query' =>  "gaProfileID IN (':in')",
					      		'params' => array(
					               ':in'=>$in
								)
							);
					DB::update("?:google_analytics_profiles_sites","gaID='".$gaID."'",$where);
				}

			}
			if((DB::getExists("SHOW COLUMNS FROM `?:google_analytics_profiles` WHERE Field = 'userID'"))){
				DB::doQuery("ALTER TABLE `?:google_analytics_profiles` DROP `userID`, DROP `gaUsername`, DROP `gaAccName`");
			}
			if((DB::getExists("SHOW INDEX FROM `?:google_analytics_profiles` WHERE Key_name = 'ga_profileID'"))){
				DB::doQuery("ALTER TABLE `?:google_analytics_profiles` DROP INDEX ga_profileID");
			}
			if(!(DB::getExists("SHOW INDEX FROM `?:google_analytics_profiles` WHERE Key_name = 'gaID_gaProfileID'"))){
				DB::doQuery("ALTER TABLE `?:google_analytics_profiles` ADD UNIQUE  `gaID_gaProfileID` (  `gaID` ,  `gaProfileID` )");
			}
			deleteOption('googleAnalyticsAccessToken');
			
	}
}

?>