<?php

function googleAnalyticsAddonMenus(&$menus){
	//$menus[] = '<li><a class="navLinks optionSelect" page="googleAnalytics">Google Analytics</a></li>';
	$menus['monitor']['subMenus'][] = array('page' => 'googleAnalytics', 'displayName' => 'Google Analytics');
}

function googleAnalyticsFetchProfiles($accessToken = '', $gaProfileDetails = ''){
	try{
		googleAnalyticsHelper::setPathsAndKeys();
		if (empty($accessToken)) {
			$accessToken = googleAnalyticsHelper::$storage->get($accessToken);
		}
		if(!googleAnalyticsHelper::authAndSetToken($accessToken)){ return false; }
		$analytics = new Google_AnalyticsService(googleAnalyticsHelper::$client);	
		$accounts = $analytics->management_accounts->listManagementAccounts();
		$getAccounts = googleAnalyticsHelper::getAccounts($accounts); //&$accounts

		$freshProfilesInsert = array();	
		$gaID = $gaProfileDetails;
		$newProfileIDs = array();
		if(!empty($getAccounts)){
			foreach($getAccounts as $getaccount){
				
				$webproperties = $analytics->management_webproperties->listManagementWebproperties($getaccount['accID']);
				
				
				foreach($webproperties->items as $item){
					sleep(1);
					$profiles = $analytics->management_profiles->listManagementProfiles($item->accountId, $item->id);
					
					if (count($profiles->getItems()) > 0) {
					  $items = $profiles->getItems();
					  $firstProfileId = $items[0]->getId();
					} 
					$userID = (isset($GLOBALS['userID']) && !empty($GLOBALS['userID']))?$GLOBALS['userID']:$_SESSION['userID'];
					if(!empty($profiles->items) && is_array($profiles->items)){
						foreach($profiles->items as $profile){
							//$freshProfilesInsert[] = array('userID' => $userID, 'gaUsername' => $profiles->username, 'gaAccName' => $getaccount['accName'], 'gaSiteURL' => $item->websiteUrl, 'gaProfileName' => $profile->name, 'gaProfileID' => $profile->id, 'gaParams' => serialize($profile), 'gaDefault' => (($firstProfileId == $profile->id) ? 1 : 0), 'gaAccessToken' => serialize($getAccessToken));
							$freshProfilesInsert[] = array('accountsDetails' => array('userID' => $userID, 'gaUsername' => $profiles->username, 'gaAccName' => $getaccount['accName'],'gaAccessToken' => serialize($accessToken) ), 'profileDetails' => array('gaID' => $gaID, 'gaSiteURL' => $item->websiteUrl, 'gaProfileName' => $profile->name, 'gaProfileID' => $profile->id, 'gaParams' => serialize($profile), 'gaDefault' => (($firstProfileId == $profile->id) ? 1 : 0) ) );
						}
					}
				}
			}
		}
	}catch(Google_ServiceException $e){
		$cd = $e->getCode();
		$errors = $e->getErrors();
		addNotification($type='E', $title='Google Analytics Service Exception (Error#'.$cd.')', $message=$errors[0]['message'], $state='U', $callbackOnClose='', $callbackReference='');
	}
	catch(Google_Exception $e){
		$cd = $e->getCode();
		$msg = $e->getMessage();
		addNotification($type='E', $title='Google Analytics Exception (Error#'.$cd.')', $message=$msg, $state='U', $callbackOnClose='', $callbackReference='');
	}
	
	//DB::delete("?:google_analytics_profiles", "1"); //delete all rows
	if(!empty($freshProfilesInsert)){
		foreach($freshProfilesInsert as $freshProfile){
			//DB::insert("?:google_analytics_profiles", $freshProfile);
			$where = array(
			      		'query' =>  "gaUsername=':gaUsername'",
			      		'params' => array(
			               ':gaUsername'=>$freshProfile['accountsDetails']['gaUsername']
						)
					);
			if (!DB::getExists("?:google_analytics_accounts_details", "gaUsername", $where)) {
				$gaID = DB::insert("?:google_analytics_accounts_details", $freshProfile['accountsDetails']);
			}
			if (isset($gaID) && !empty($gaID)) {
				array_push($newProfileIDs, $freshProfile['profileDetails']['gaProfileID']);
				$freshProfile['profileDetails']['gaID'] = $gaID;
				$isNewProfileInserted = DB::insert("?:google_analytics_profiles", $freshProfile['profileDetails']);
			}

		}
		removeUnwantedProfiles($gaID, $newProfileIDs);
	}
	else{
		removeUnwantedProfiles($gaID);
	}
	
	updateOption('gaLastProfilesFetch', time());
	
	$run = getOption('gaMapProfilesAndSitesInitialRun');
	if(empty($run) || $run == 'N' || $isNewProfileInserted){
		googleAnalyticsPostAddSite();
		updateOption('gaMapProfilesAndSitesInitialRun', 'Y');
	}
	return true;
}
function googleAnalyticsUpdateAllProfileData(){
	$getAllGAAccounts = DB::getArray("?:google_analytics_accounts_details", "gaAccessToken, gaID", "1");
	if (!empty($getAllGAAccounts) && isset($getAllGAAccounts)) {
		foreach ($getAllGAAccounts as $key => $gaAccount) {
			$where = array(
			      		'query' =>  "gaID=:gaID",
			      		'params' => array(
			               ':gaID'=>$gaAccount['gaID']
						)
					);
			$profileID = DB::getFields("?:google_analytics_profiles", "gaProfileID", $where);
			googleAnalyticsFetchProfiles(unserialize($gaAccount['gaAccessToken']), $gaAccount['gaID']);
		}
	}
	
}
function removeUnwantedProfiles($gaID, $newProfileIDs = array()){
	if(!empty($newProfileIDs)){
		$where = array(
		      		'query' =>  "gaID=':gaID'",
		      		'params' => array(
		               ':gaID'=>$gaID
					)
				);
		$oldProfileIDs = DB::getFields("?:google_analytics_profiles", "gaProfileID", $where);
		$unwantedProfileIDs = array_diff($oldProfileIDs, $newProfileIDs);
		if(!empty($unwantedProfileIDs)){
			foreach ($unwantedProfileIDs as $profileID) {
				$where = array(
				      		'query' =>  "gaProfileID = ':gaProfileID' AND gaID = ':gaID'",
				      		'params' => array(
				      		   ':gaProfileID' => $profileID,
				      		   ':gaID' => $gaID
	           				)
	        			);	
				DB::delete("?:google_analytics_profiles", $where);
				DB::update("?:google_analytics_profiles_sites", "gaProfileID = NULL, gaID= NULL", $where);
			}
			updateOption('gaMapProfilesAndSitesInitialRun', "N");
		}
	}else{
		$where = array(
		      		'query' =>  "gaID=:gaID",
		      		'params' => array(
		               ':gaID'=>$gaID
					)
				);
		$profileIDs = DB::getFields("?:google_analytics_profiles", "gaProfileID", $where);
		$GAP  = DB::delete("?:google_analytics_profiles", $where);
		foreach ($profileIDs as $profileID ) {
			$where = array(
			      		'query' =>  "gaProfileID=':profileID' AND gaID=':gaID'",
			      		'params' => array(
			               ':profileID'=>$profileID,
			               ':gaID'=>$gaID
						)
					);
			DB::update("?:google_analytics_profiles_sites", "gaProfileID = NULL, gaID= NULL", $where);
		}
		updateOption('gaMapProfilesAndSitesInitialRun', "N");
	}
}
function googleAnalyticsGrantAccess(){
	$result = getOption('googleAnalyticsAccessStatus');
	if(!empty($result)){
		return $result;
	}
	return false;
}

function googleAnalyticsPostAddSite($siteID=false){
	
	googleAnalyticsInstallPopulateSites();
	
	$successMaps = 0;
	$whereJoin = '';
	if(!empty($siteID)){
		$whereJoin = " AND S.siteID = '".DB::esc($siteID)."'";
	}
	
	$sites = DB::getFields("?:sites S, ?:google_analytics_profiles_sites GAPS", "S.URL, S.siteID", "S.siteID = GAPS.siteID AND (GAPS.gaProfileID IS NULL OR GAPS.gaProfileID = '')".$whereJoin, "siteID");
	if(!empty($sites)){
		foreach($sites as $siteID => $siteAddress){
			$siteAddress = str_ireplace(array('www.', 'http://', 'https://'), '', $siteAddress);
			$siteAddress = rtrim($siteAddress, '/');
			$where = array(
	      				'query' =>  "gaProfileID AND gaID NOT IN(SELECT gaProfileID FROM ?:google_analytics_profiles_sites WHERE (gaProfileID IS NULL AND gaProfileID = '')) AND gaSiteURL LIKE '%:siteAddress%'",
		      			'params' => array(
		               		':siteAddress'=>$siteAddress
						)
					);
			$gaProfiles = DB::getArray("?:google_analytics_profiles", "gaID,gaProfileID", $where);
			if(!empty($gaProfiles)){
				$where = array(
		      				'query' =>  "siteID=:siteID",
			      			'params' => array(
			               		':siteID'=>$siteID
							)
						);
				DB::update("?:google_analytics_profiles_sites", array('gaProfileID' => $gaProfiles[0]['gaProfileID'], 'gaID' => $gaProfiles[0]['gaID']), $where);
				$successMaps++;
			}
		}
	}
	if($successMaps > 0){
		addNotification($type='N', $title='Google Analytics site'.(($successMaps > 1) ? 's' : '').' mapped', $message=$successMaps.' site'.(($successMaps > 1) ? 's' : '').' mapped with google analytics.', $state='U', $callbackOnClose='', $callbackReference='');
	}
}


//active analytic profile
function googleAnalyticsActiveSites(){
	return DB::getFields("?:google_analytics_profiles_sites", "siteID", "gaProfileID IS NOT NULL");
}

//Mapped site and profileID analytic profile
function googleAnalyticsMappedSites(){
	$mappedSites = DB::getArray("?:google_analytics_profiles_sites", "siteID,gaProfileID", "gaProfileID IS NOT NULL");
	foreach($mappedSites as $key => $value){
		$option[$value['siteID']] = array('gaProfileID' => $value['gaProfileID']); 
	}
	return $option;
}

//Update 'site' with 'profileID' in 'ga_profiles_sites' table.
function googleAnalyticsSetProfilesAndSites($params){
		if(empty($params['googleProfileID'])){
			 $params['googleProfileID'] = array('NULL');
		}
		$where = array(
	      			'query' =>  "siteID=:siteID",
		      		'params' => array(
		               ':siteID'=>$params['siteID']
					)
				);
		DB::update("?:google_analytics_profiles_sites", array('gaProfileID' => $params['googleProfileID'], 'gaID' => $params['gaID']), $where);
}

function googleAnalyticsInstallPopulateSites(){
	
	$siteIDs = DB::getFields("?:sites", "siteID", "1");
	if(!empty($siteIDs)){
		foreach($siteIDs as $siteID){
			$where = array(
	      			'query' =>  "siteID=:siteID",
		      		'params' => array(
		               ':siteID'=>$siteID
					)
				);
			if(!DB::getExists("?:google_analytics_profiles_sites", "siteID", $where)){
				DB::insert("?:google_analytics_profiles_sites", array('siteID' => $siteID));
			}
		}
	}
}

function googleAnalyticsEditSiteOptions(){
	
	$gaAccountDatas = DB::getArray("?:google_analytics_accounts_details", "gaID, gaUsername", "1");
	$gaDatas = DB::getArray("?:google_analytics_profiles", "gaID,gaSiteURL, gaProfileName, gaProfileID", "1");
	
	if(!empty($gaDatas) && !empty($gaAccountDatas)){
		foreach ($gaAccountDatas as $key => $gaAccounts) {
			foreach($gaDatas as $key => $gaData ){
				if ($gaAccounts['gaID'] == $gaData['gaID']) {
					$gaSiteURL = str_replace(array('http://', 'https://'), '', $gaData["gaSiteURL"]);
					$gaSiteURL = $gaSiteURL.(substr($gaSiteURL, -1) == '/' ? '' : '');
					$googleAnalyticsProfileTempData[] = array("gaSiteURL" => $gaSiteURL, "gaProfileName" => $gaData["gaProfileName"], "gaProfileID" => $gaData["gaProfileID"], "gaID" => $gaData['gaID']);
				}
			}
			if (!empty($googleAnalyticsProfileTempData)) {
				$googleAnalyticsProfileData[$gaAccounts['gaUsername']] = $googleAnalyticsProfileTempData;
			}
			else{
				$googleAnalyticsProfileData[$gaAccounts['gaUsername']] = array('1');
			}
			unset($googleAnalyticsProfileTempData);
		}
	}
	return $googleAnalyticsProfileData;
}

function googleAnalyticsGetProfileData($params){ //attribute $profileID, $view (month or week)
	
	try{
		$where = array(
	      			'query' =>  "siteID=':siteID'",
		      		'params' => array(
		               ':siteID'=>$params['siteID']
					)
				);
		$profiles = DB::getArray("?:google_analytics_profiles_sites", "gaID,gaProfileID", $where);
		$profileID = $profiles[0]['gaProfileID'];
		$where = array(
	      			'query' =>  "gaID=':gaID'",
		      		'params' => array(
		               ':gaID'=>$profiles[0]['gaID']
					)
				);
		$getAccessToken = DB::getField("?:google_analytics_accounts_details", "gaAccessToken", $where);
		$accessToken = unserialize($getAccessToken);
		googleAnalyticsHelper::setPathsAndKeys();
		if(!googleAnalyticsHelper::authAndSetToken($accessToken)){ return false; }
					
		//For client Report
		
		if(isset($params['clientReportAnalyticsDate']) && !empty($params['clientReportAnalyticsDate'])){
			$previousPeriod['startDate'] = $params['clientReportAnalyticsDate']['startDate'];
			$previousPeriod['endDate'] = $params['clientReportAnalyticsDate']['endDate'];
			
			$periods =  array($previous => $previousPeriod);
		} else if(isset($params['clientReportNewAnalyticsDate']) && !empty($params['clientReportNewAnalyticsDate'])) {
			$periodDays = $params['clientReportNewAnalyticsDate']['periodDays'];
			$current = 'currentPeriod';
			$previous = 'previousPeriod';
			
			$year = $params['clientReportNewAnalyticsDate']['date']['Y'];
			$month = $params['clientReportNewAnalyticsDate']['date']['m'];
			$day = $params['clientReportNewAnalyticsDate']['date']['d'];

			$previousPeriod['startDate']	= date('Y-m-d', mktime(0, 0, 0, $month, $day-($periodDays*2)+1, $year));
			$previousPeriod['endDate'] 		= date('Y-m-d', mktime(0, 0, 0, $month, $day-($periodDays*1), $year));
			$thisPeriod['startDate'] 		= date('Y-m-d', mktime(0, 0, 0, $month, $day-($periodDays*1)+1, $year));
			$thisPeriod['endDate'] 			= date('Y-m-d', mktime(0, 0, 0, $month, $day, $year));
			
			$periods =  array($previous => $previousPeriod, $current => $thisPeriod);			
		} else {
			if($params['view'] == 'month'){
				$periodDays = 30;
				$current = 'currentMonth';
				$previous = 'previousMonth';
			}
			else{ //week
				$periodDays = 7;
				$current = 'currentWeek';
				$previous = 'previousWeek';
			}
			
			$previousPeriod['startDate']	= date('Y-m-d', mktime(0, 0, 0, date("m"), date("d")-($periodDays*2)+1, date("Y")));
			$previousPeriod['endDate'] 		= date('Y-m-d', mktime(0, 0, 0, date("m"), date("d")-($periodDays*1), date("Y")));
			$thisPeriod['startDate'] 		= date('Y-m-d', mktime(0, 0, 0, date("m"), date("d")-($periodDays*1)+1, date("Y")));
			$thisPeriod['endDate'] 			= date('Y-m-d', mktime(0, 0, 0, date("m"), date("d"), date("Y")));
			
			$periods =  array($previous => $previousPeriod, $current => $thisPeriod);
		}
		
		$analytics = new Google_AnalyticsService(googleAnalyticsHelper::$client);
		    	
		foreach($periods as $period => $dates){
			$startDate = $dates['startDate'];
			$endDate = $dates['endDate'];
			
			$results = googleAnalyticsHelper::queryCoreReportingApi($analytics, 'ga:'.$profileID, $startDate, $endDate);
			
			//For client Report 
			if(isset($params['clientReportAnalyticsDate']) && !empty($params['clientReportAnalyticsDate'])){
				$totalsForAllResults = $results->totalsForAllResults;
				return $totalsForAllResults;
			}
			// 
			
			$totalsForAllResults[$period] = $results->totalsForAllResults;
			$columnHeader = $results->columnHeaders;
			
			$gaData[$period] = array();
			
			if(isset($params['clientReportNewAnalyticsDate']) && !empty($params['clientReportNewAnalyticsDate'])) {
				foreach($results->rows as $row){
					$gaData['visits'][$period][] = $row[2];
					$gaData['pageviews'][$period][] = $row[5];
					$gaData['pageviewsPerVisit'][$period][] = $row[6];
					$gaData['avgSessionDuration'][$period][] = $row[8];
					$gaData['percentNewVisits'][$period][] = $row[4];					
					$gaData['newVisits'][$period][] = $row[1];
					$gaData['visitors'][$period][] = $row[3];
					$gaData['bounceRate'][$period][] = $row[7];
					$gaData[$period]['pageviews'][] = $row[5];
					$gaData[$period]['pageviewsPerVisit'][] = $row[6];
					$gaData[$period]['avgSessionDuration'][] = $row[8];					
					$gaData[$period]['newVisits'][] = $row[1];
					$gaData[$period]['visitors'][] = $row[3];
					$gaData[$period]['percentNewVisits'][] = $row[4];
					$gaData[$period]['bounceRate'][] = $row[7];
				}
				$gaData['total'][$period] = $results->totalsForAllResults;
			} else {
				$test = array();
				
				foreach($columnHeader as $header){
					$test[] = $header->name;
				}
				
				$gaData[$period][] = $test;
				foreach($results->rows as $row){			
					$row[0] = date('M d, Y', strtotime($row[0]));
					array_push($gaData[$period], $row);
				}				
			}
		}
		
		if(isset($params['clientReportNewAnalyticsDate']) && !empty($params['clientReportNewAnalyticsDate'])) {
			return $gaData;
		}
		
		$gaData['visitsAvg'] = $totalsForAllResults[$current]['ga:visits'];
		$gaData['visitsPercent'] = differencePercent($totalsForAllResults[$current]['ga:visits'], $totalsForAllResults[$previous]['ga:visits']);
		 
		$gaData['uniqueVisitorAvg'] = $totalsForAllResults[$current]['ga:visitors'];
		$gaData['uniqueVisitorPercent'] = differencePercent($totalsForAllResults[$current]['ga:visitors'], $totalsForAllResults[$previous]['ga:visitors']);
		 
		$gaData['pageViewsAvg'] = round($totalsForAllResults[$current]['ga:pageviews'], 2);
		$gaData['pageViewsPercent'] = differencePercent($totalsForAllResults[$current]['ga:pageviews'], $totalsForAllResults[$previous]['ga:pageviews']);
		 
		$gaData['pageVisitsAvg'] = round($totalsForAllResults[$current]['ga:pageviewsPerVisit'], 2);
		$gaData['pageVisitsAvgPercent'] = differencePercent($totalsForAllResults[$current]['ga:pageviewsPerVisit'], $totalsForAllResults[$previous]['ga:pageviewsPerVisit']);
		 
		$gaData['visitDurationAvg'] = round($totalsForAllResults[$current]['ga:avgSessionDuration'], 2);
		$gaData['visitDurationPercent'] = differencePercent($totalsForAllResults[$current]['ga:avgSessionDuration'], $totalsForAllResults[$previous]['ga:avgSessionDuration']);
		 
		$gaData['bounceRateAvg'] = round($totalsForAllResults[$current]['ga:bounceRate'], 2);
		$gaData['bounceRatePercent'] = differencePercent($totalsForAllResults[$current]['ga:bounceRate'], $totalsForAllResults[$previous]['ga:bounceRate']);
		 
		$gaData['newVisitsAvg'] = round($totalsForAllResults[$current]['ga:percentNewVisits'], 2);
		$gaData['newVisitsPercent'] = differencePercent($totalsForAllResults[$current]['ga:percentNewVisits'], $totalsForAllResults[$previous]['ga:percentNewVisits']);
		 
		return $gaData;
	}catch(Google_ServiceException $e){
		$cd = $e->getCode();
		$errors = $e->getErrors();
		addNotification($type='E', $title='Google Analytics Service Exception (Error#'.$cd.')', $message=$errors[0]['message'], $state='U', $callbackOnClose='', $callbackReference='');
	}
	catch(Google_Exception $e){
		$cd = $e->getCode();
		$msg = $e->getMessage();
		addNotification($type='E', $title='Google Analytics Exception (Error#'.$cd.')', $message=$msg, $state='U', $callbackOnClose='', $callbackReference='');
	}
}


function differencePercent($current, $previous){
	$previous = (float)$previous;
	if($previous == 0){//fix me
		return round(-100, 2);
	}
	return @round(((($current / $previous) - 1) * 100), 2);
}

function googleAnalyticsRunOffBrowserLoad(){
	$userID = (isset($GLOBALS['userID']) && !empty($GLOBALS['userID']))?$GLOBALS['userID']:$_SESSION['userID'];
	if(empty($userID)){//fix for RunOffBrowserLoad in fsock mode
		$userID = DB::getField("?:users", "userID", "1 ORDER BY userID ASC LIMIT 1");
		if(version_compare(APP_VERSION, '2.4.0beta1') == -1){
			$_SESSION['userID'] = $userID;			
		} else {
			$GLOBALS['userID'] = $userID;			
		}
	}

	$googleAPIKeys = getOption('googleAPIKeys');
	$result = getOption('googleAnalyticsAccessStatus');
	if(!empty($googleAPIKeys)){
		$APIKeys = unserialize($googleAPIKeys);
	}
	if(empty($APIKeys['clientID']) || empty($APIKeys['clientSecretKey']) || $result != 'grant'){
		return false;
	}
	googleAnalyticsUpdateAllProfileData();
}

function googleAnalyticsRemoveSite($siteID){
	$where = array(
	      		'query' =>  "siteID=':siteID'",
	      		'params' => array(
	               ':siteID'=>$siteID
				)
			);
	DB::delete("?:google_analytics_profiles_sites", $where );
}

function googleAnalyticsGetConnectedAccounts(){
	$accountNames = DB::getArray("?:google_analytics_accounts_details", "gaUsername,gaID", '1');
	return $accountNames;
}
function googleAnalyticsRemoveAccount($data){
	if ($data) {
		updateOption('gaMapProfilesAndSitesInitialRun', "N");
		$where = array(
		      		'query' =>  "gaID=':gaID'",
		      		'params' => array(
		               ':gaID'=>$data
					)
				);
		$profileIDs = DB::getFields("?:google_analytics_profiles", "gaProfileID", $where);
		$getAccessToken = DB::getField("?:google_analytics_accounts_details", "gaAccessToken", $where);
		$GAAD  = DB::delete("?:google_analytics_accounts_details", $where);
		foreach ($profileIDs as $profileID ) {
			$where = array(
			      		'query' =>  "gaProfileID=':profileID' AND gaID=':gaID'",
			      		'params' => array(
			               ':profileID'=>$profileID,
			               ':gaID'=>$data
						)
					);
			DB::delete("?:google_analytics_profiles", $where);
			DB::update("?:google_analytics_profiles_sites", "gaProfileID = NULL, gaID= NULL", $where);
		}
		return unserialize($getAccessToken);
	}
}

class googleAnalyticsHelper{
	
	public static $client;
	public static $authHelper;
	public static $storage;
	private static $GAThisPage;
	private static $redirectURL;
	private static $isSetPathsAndKeysComplete = false;
	
	public static function setPathsAndKeys(){

		
		if(self::$isSetPathsAndKeysComplete) return true;
		
		include_once(APP_ROOT.'/lib/googleAPIs/src/Google_Client.php');
		include_once(APP_ROOT.'/lib/googleAPIs/src/contrib/Google_AnalyticsService.php');
		include_once(APP_ROOT.'/lib/googleAPIs/storage.php');
		include_once(APP_ROOT.'/lib/googleAPIs/authHelper.php');
		
		self::$GAThisPage = APP_URL.'addons/googleAnalytics/lib/googleAnalytics.php';
		self::$redirectURL = APP_URL.'addons/googleAnalytics/lib/googleAnalytics.php';
		

		$googleAnalyticsAPIKeys = getOption('googleAPIKeys');
		if(!empty($googleAnalyticsAPIKeys)){
			$googleAnalyticsAPIKeys = unserialize($googleAnalyticsAPIKeys);
		}
	
		// Build a new client object to work with authorization.
		self::$client = new Google_Client();
		self::$client->setClientId($googleAnalyticsAPIKeys['clientID']);
		self::$client->setClientSecret($googleAnalyticsAPIKeys['clientSecretKey']);
		self::$client->setRedirectUri(self::$redirectURL);
		self::$client->setApplicationName('InfiniteWP Google Analytics');
		self::$client->setScopes(array('https://www.googleapis.com/auth/analytics.readonly'));
		
		// Magic. Returns objects from the Analytics Service
		// instead of associative arrays.
		self::$client->setUseObjects(true);

		
		// Build a new storage object to handle and store tokens in sessions.
		// Create a new storage object to persist the tokens across sessions.
		self::$storage = new apiSessionStorage(); //googleAnalyticsStorageHelper();
		
		self::$authHelper = new AuthHelper(self::$client, self::$storage, self::$GAThisPage);
		
		self::$isSetPathsAndKeysComplete = true;


	}
	
	public static function authAndSetToken($accessToken){
		
		if (isset($accessToken)) {
		  self::$client->setAccessToken($accessToken);
		}
			
		return self::$authHelper->isAuthorized();
	}
	
	public static function getAccounts(&$accounts) {
		 $items = $accounts->getItems();
		 
		 $accDetail = array();
		if (count($items) > 0){
		  foreach($items as &$account) {
			  $accDetail[] = array('accID' => $account->getId(), 'kind' => $account->getKind(), 'selfLink' => $account->getSelfLink(), 'accName' => $account->getName(), 'created' => $account->getCreated(), 'updated' => $account->getUpdated());
		  }
		}
		return $accDetail;
  	}
	
	  public static function queryCoreReportingApi($analytics, $tableId,$startDate,$endDate) {
		  
		  $optParams = array('dimensions' => 'ga:date');
		  
		  return $analytics->data_ga->get(
			urldecode($tableId),
			$startDate,
			$endDate,
			'ga:newVisits,ga:visits,ga:visitors,ga:percentNewVisits,ga:pageviews,ga:pageviewsPerVisit,ga:bounceRate,ga:avgSessionDuration',
			$optParams);
	  }
}

/*class googleAnalyticsStorageHelper{//runOffBrowserLoad doesnt depend on session or cookie
  public function set($value) {
    //$_SESSION['access_token'] = $value;
	updateOption('googleAnalyticsAccessTokenSession', serialize($value));
  }

  public function get() {
    //return $_SESSION['access_token'];
	return unserialize(getOption('googleAnalyticsAccessTokenSession'));
  }

  public function delete() {
    //unset($_SESSION['access_token']);
	updateOption('googleAnalyticsAccessTokenSession', '');
  }
}*/

function googleAnalyticsHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('googleAnalytics');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/googleAnalytics/css/googleAnalytics.css')),
		array('tp' => array('HTML' => '<script type="text/javascript" src="https://www.google.com/jsapi"></script>')),
		array('js' => array('href' => 'addons/googleAnalytics/js/functions.js')),
		array('js' => array('href' => 'addons/googleAnalytics/js/init.js')),
		array('js' => array('href' => 'addons/googleAnalytics/js/load.js')),
	);
	$headFiles['googleAnalytics'] = $addonDetails;
}