<?php 
function googleSafeBrowsingAddonMenus(&$menus){
	//$menus[] = '<li><a class="navLinks optionSelect" page="malwareSecurity">Malware Scan</a></li>';
	$menus['protect']['subMenus'][] = array('page' => 'googleSafeBrowsing', 'displayName' => 'Google Safe Browsing');
}
function getGoogleSafeBrowsingPastHistory($args = false){
		$itemsPerPage = 20;
		$i = 0;
		$page = (isset($args['page']) && !empty($args['page'])) ? $args['page'] : 1;
		$total = DB::getField("?:google_safe_browsing","count(taskID)",1);
		$limitSQL = paginate($page, $total, $itemsPerPage);
		$result = DB::getArray("?:google_safe_browsing","taskID, no_of_scanned, no_of_affected,time" ,"taskID ORDER BY taskID DESC ".$limitSQL);
		$displayScanDetails =  array();
		$notAffectedSiteDetails =array();
		$affectedSiteDetails = array();
		$where2 = '';
		if (userStatus() != "admin") {
			$where = array(
		      		'query' =>  "userID = :userID",
		      		'params' => array(
		               ':userID'=>$GLOBALS['userID']
						)
				);
			$siteIDs = DB::getFields('?:user_access', 'siteID', $where);
			$where2 = "AND siteID IN (". implode(', ', DB::esc($siteIDs)) .")";
		}
		if ($result) {
			foreach ($result as $key ) {	
				$displayScanDetails [$i]['time'] = $key['time'];
				
				$where = array(
			      		'query' =>  "taskID = :taskID AND result != 'success' ".$where2." ORDER BY ID DESC",
			      		'params' => array(
			               ':taskID'=>$key['taskID']
							)
					);
				$affectedSiteDetails = DB::getArray("?:google_safe_browsing_additional_data","URL, result" ,$where);
				$displayScanDetails [$i]['affected_site_details'] = $affectedSiteDetails;
			
				$where = array(
			      		'query' =>  "taskID = :taskID AND result = 'success' ".$where2." ORDER BY ID DESC",
			      		'params' => array(
			               ':taskID'=>$key['taskID']
							)
					);
				$notAffectedSiteDetails = DB::getArray("?:google_safe_browsing_additional_data","URL" ,$where);
				$displayScanDetails [$i]['not_affected_site_details'] = $notAffectedSiteDetails;
				$affectedSitesCount = !empty($affectedSiteDetails)?count($affectedSiteDetails):0;
				$notAffectedSitesCount = !empty($notAffectedSiteDetails)?count($notAffectedSiteDetails):0;
				$displayScanDetails [$i]['no_of_scanned'] = $notAffectedSitesCount+$affectedSitesCount;
				$displayScanDetails [$i]['no_of_affected'] = $affectedSitesCount;
				$displayScanDetails [$i]['no_of_not_affected'] = $notAffectedSitesCount;
				if ($displayScanDetails[$i]['no_of_affected']==0 && $displayScanDetails [$i]['no_of_not_affected'] == 0) {
					unset( $displayScanDetails [$i]);
				}
				$i++;
			}
		}

		
		return $displayScanDetails;
	}
function googleSafeBrowsingGetPastResultHTML($args = false){
	$pastResults = 	getGoogleSafeBrowsingPastHistory($args);
	$HTML = TPL::get('/addons/googleSafeBrowsing/templates/googleSafeBrowsingView.tpl.php', array('pastResults' => $pastResults));
	
	return $HTML;
}

function googleSafeBrowsingScanAllSites(){
	$noOfSites = DB::getField("?:sites","count(siteID)" ,"type = 'normal'");
	$apiKey = getOption('googleSafeBrowsingAPIKey');
	if (empty($apiKey)) {
		addNotification($type='E', $title='YOUR SAFE BROWSING API SEEMS INVALID', $message='Please check your Google Safe Browsing API.<br><a class="googleSettingsClick">Go to Settings</a>', $state='U', $callbackOnClose='', $callbackReference='');
	}
	$loopCount = floor($noOfSites/500);
	$loopCount = $loopCount?$loopCount:1;
	$fromRow = 0;
	$timestamp = time();
	$toRow = 500;
	$lastCount = $noOfSites%500;
	$allSiteResult = array();
	$requestSiteURL = array();
	$noOfAffected = 0;
	$requestMalwareData = array('client' => array('clientId'=>'1013067990877', 'clientVersion' =>'V4'), 'threatInfo'=>array('threatTypes' => array('THREAT_TYPE_UNSPECIFIED', 'MALWARE', 'SOCIAL_ENGINEERING', 'UNWANTED_SOFTWARE', 'POTENTIALLY_HARMFUL_APPLICATION'),'platformTypes' => array('WINDOWS'), 'threatEntryTypes' => array('URL')) );

	for ($count=0; $count <=$loopCount; $count++) { 
		$sitesData = DB::getArray("?:sites","siteID, URL" ,"type = 'normal' ORDER BY siteID ASC LIMIT ".$fromRow." , ".$toRow);
		foreach ($sitesData as $key) {
			$requestSiteURL[]= array('url'=>$key['URL']);
		}
		$requestMalwareData['threatInfo']['threatEntries']=$requestSiteURL;
		$googleAPIFormatedData = $sitesURL;
		$googleAPIURL = "https://safebrowsing.googleapis.com/v4/threatMatches:find?key=".$apiKey; /*replace with your apiKey*/
		$request = jsonEncoder($requestMalwareData);
		$temp = googleSafeBrowsingAPIRequestCall($googleAPIURL, $request);
		list($results, $curlInfo) = $temp;
		$results = json_decode($results, true);
		if ($curlInfo['info']['http_code'] == 403) {
		addNotification($type='E', $title='YOUR SAFE BROWSING API SEEMS INVALID', $message='Please check your Google Safe Browsing API.<br><a class="googleSettingsClick">Go to Settings</a>', $state='U', $callbackOnClose='', $callbackReference='');
		return false;
		}
		$cURLErrors = new cURLErrors($curlInfo);
		if (!$cURLErrors->isOk()) {
			addNotification($type='E', $title='CONNECTION ERROR', $message=$cURLErrors->getErrorMsg(), $state='U', $callbackOnClose='', $callbackReference='');
			return false;
		}
		if ($cURLErrors->isOk()) {
			foreach ($sitesData as $site) {
				$isAffected = 0;
				if (!empty($results['matches'])) {
					foreach ($results['matches'] as $key => $match) {
						if ($match['threat']['url'] == $site['URL']) {
							$tempArray ['siteID']= $site['siteID'];
							$tempArray ['URL'] = $site['URL'];
							$tempArray ['time'] = $timestamp;
							$tempArray ['status'] = $match['threatType'];
							$tempArray ['rawResult'] = serialize($match);
							array_push($allSiteResult, $tempArray);
							$noOfAffected ++;
							$isAffected = 1;
						}
					}
				}
				if($isAffected !=1){
						$tempArray ['siteID']= $site['siteID'];
						$tempArray ['URL'] = $site['URL'];
						$tempArray ['time'] = $timestamp;
						$tempArray ['status'] = 'success';
						$tempArray ['rawResult'] = serialize($match);
						array_push($allSiteResult, $tempArray);
					}
			}
		}
		$fromRow = $toRow;
		$toRow =+ 500;

	}

	if (!empty($allSiteResult)) {
		$query = DB::insert("?:google_safe_browsing", array('time' => $timestamp, 'no_of_scanned' => $noOfSites ,'no_of_affected'=>$noOfAffected));
		foreach ($allSiteResult as $details) {
			DB::insert("?:google_safe_browsing_additional_data", array('taskID' => $query,'siteID' => $details['siteID'], 'URL' => $details['URL'], 'time' => $details['time'], 'result' => $details['status'], 'rawResult' => $details['rawResult']));
		}
	}
	return $query;
}

function googleSafeBrowsingAutoScan($data){
	if ($data['paused'] == 1) {
		$timestamp = strtotime('tomorrow midnight');
		updateOption('googleSafeBrowsingSheduled',$timestamp);
	}
	else{
		updateOption('googleSafeBrowsingSheduled','');
	}
	return $data;
}

function googleSafeBrowsingAPI($API){
	if ($API) {
		updateOption("googleSafeBrowsingAPIKey",$API);
		return $API;
	}
}

function googleSafeBrowsingcronRun(){
	$time = time();
	$timeInterval = getOption('googleSafeBrowsingSheduled');
	if (empty($timeInterval)) {
		return false;
	}
	if($timeInterval <= $time){
		$timestamp = strtotime('tomorrow midnight');
		updateOption('googleSafeBrowsingSheduled',$timestamp);
		$taskID = googleSafeBrowsingScanAllSites();
		if($taskID){
			googleSafeBrowsingEmailNotification($taskID);
		}
	}
	googleSafeBrowsingClearOldResult();
}
function googleSafeBrowsingEmailNotification($taskID){
	$googleSafeBrowsingTplPath = '/addons/googleSafeBrowsing/templates/googleSafeBrowsingEmailTemplate.tpl.php';
	$where = array(
      		'query' =>  "taskID = :taskID AND result != 'success'",
      		'params' => array(
               ':taskID'=>$taskID
				)
		);
	$result = DB::getFields("?:google_safe_browsing_additional_data","URL" , $where);
	if (empty($result)) {
		return false;
	}
	$emailHTMLDetails['no_of_affected'] = count($result);
	$emailHTMLDetails['time'] = time();
	$emailHTMLDetails['userID'] = $GLOBALS['userID'];
	$emailHTMLDetails['results'] = $result;
	if ($emailHTMLDetails['no_of_affected']) {
		sendAppMail($emailHTMLDetails,$googleSafeBrowsingTplPath);
	}
}

function googleSafeBrowsingClearOldResult(){
	$last = getOption('LastAutoDeleteGoogleScanLogTime');
	if(!empty($last)){
		$now = time();
		if(date("DDMMYY",$last) != date("DDMMYY",$now) && $last < $now){
			$days = 90;
			$till = $days*24*60*60;
			$toDelete = $now - $till;
			googleSafeBrowsingClearScanHistory($toDelete);
		}
		
	}else{
		updateOption('LastAutoDeleteGoogleScanLogTime', 1);
	}
}

function googleSafeBrowsingClearScanHistory($toDelete){
	if(!empty($toDelete)){
		DB::delete("?:google_safe_browsing", "time <='".$toDelete."'");
		DB::delete("?:google_safe_browsing_additional_data", "time <='".$toDelete."'");
		DB::doQuery("OPTIMIZE TABLE `?:google_safe_browsing`");
		DB::doQuery("OPTIMIZE TABLE `?:google_safe_browsing_additional_data`");
		updateOption('LastAutoDeleteGoogleScanLogTime', time());
	}
}

function googleSafeBrowsingAPIRequestCall($URL, $data){
	$HTTPCustomHeaders = array();
	$ch = curl_init($URL);
	curl_setopt($ch, CURLOPT_URL, $URL);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_MAXREDIRS, 2);
	curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
	curl_setopt($ch, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36');
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  false );
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_TIMEOUT, 60);
	curl_setopt($ch, CURLOPT_HEADER, true);
	$contentType = 'application/json';
	$HTTPCustomHeaders[] = 'Content-Type: '.trim($contentType);//before array('Content-Type: text/plain') //multipart/form-data
	
	curl_setopt($ch, CURLOPT_HTTPHEADER, $HTTPCustomHeaders);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
	$rawResponse = curl_exec($ch);
	$curlInfo = array();
	$curlInfo['info'] = curl_getinfo($ch);
	if(curl_errno($ch)){
		$curlInfo['errorNo'] = curl_errno($ch);
		$curlInfo['error'] = curl_error($ch);
	}
	       	
	curl_close($ch);
	list($responseHeader, $responseBody) = bifurcateResponse($rawResponse, $curlInfo);
	
	return array($responseBody, $curlInfo, $responseHeader);
}

function googleSafeBrowsingHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('googleSafeBrowsing');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/googleSafeBrowsing/css/googleSafeBrowsing.css')),
		array('js' => array('href' => 'addons/googleSafeBrowsing/js/init.js')),
		array('js' => array('href' => 'addons/googleSafeBrowsing/js/load.js')),
	);
	$headFiles['googleSafeBrowsing'] = $addonDetails;
	$isAdmin = userStatus()=="admin"?1:0;
	?>
	<script >
		var googleSafeBrowsingAPI='<?php echo getOption("googleSafeBrowsingAPIKey"); ?>';
		var googleSafeBrowsingSheduled = '<?php echo getOption("googleSafeBrowsingSheduled")?1:0; ?>';
		var googleSafeBrowsingIsAdmin = "<?php echo $isAdmin; ?>";
	</script>
	<?php
}