<?php

/*
slug: googleWebMasters
version: 1.1.6
*/


class addonGoogleWebMasters{
	
	private static $version = '1.1.6';

	public static function version(){
		return self::version;
	}

	public static function init(){
		require_once(APP_ROOT."/addons/googleWebMasters/controllers/func.php");	
		require_once(APP_ROOT."/addons/googleWebMasters/controllers/manageClientsGoogleWebMasters.php");	
		panelRequestManager::addFunctions('googleWebMastersActiveSites','googleWebMastersSaveAPIKeysAndRedirect','googleWebMastersGrantAccess','googleWebMastersGetAPIKeys','googleWebMastersMappedSites','googleWebMastersEditSiteOptions','googleWebMastersInstallPopulateSites','googleWebMastersFetchProfiles','googleWebMastersSetProfilesAndSites','googleWebMastersGetProfileData','googleWebMastersIgnoreValue','googleWebMastersRedirect','googleWebMastersBulkIgnores','googleWebMastersRedirectAgain','googleWebMastersRedirectedAgain','googleWebMastersReconsiderIssue', 'showGWApiUpdateNotes');
		regHooks('addonMenus','responseProcessors','postAddSite', 'runOffBrowserLoad', 'taskTitleTemplate','removeSite', 'headHTMLFiles');
	}	

	public static function install(){
		
		$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:google_webmasters_ignored` (
			  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
			  `crawl` varchar(80) NOT NULL,
			  `issue` varchar(255) NOT NULL,
			  `redirect` varchar(255) DEFAULT NULL,
			  PRIMARY KEY (`id`)
			)".DB::getSQLTableEnv().";");

		$Q2 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:google_webmasters_profiles` (
			  `gwtSiteURL` varchar(255) NOT NULL,
			  `gwtProfileID` varchar(70) DEFAULT NULL,
			  UNIQUE KEY `ga_profileID` (`gwtProfileID`)
			)".DB::getSQLTableEnv().";");

		$Q3 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:google_webmasters_profiles_sites` (
			  `siteID` int(10) unsigned DEFAULT NULL,
			  `gwtProfileID` varchar(70) DEFAULT NULL,
			  UNIQUE KEY `siteID` (`siteID`,`gwtProfileID`),
			  UNIQUE KEY `siteID_2` (`siteID`)
			)".DB::getSQLTableEnv().";");

		if($Q1 && $Q2 && $Q3){
			return true;	
		}
		return false;
	}

	public static function update(){
		
		if(version_compare(getOldAddonVersion('googleWebMasters'), '1.0.0', '<')){
			//from v1.0.0 Google API Lib is kept common in base app, so deleting common API files here
			$deleteFiles = array(
				'/addons/googleWebMasters/lib/authHelper.php' => array('type' => 'f'),
				'/addons/googleWebMasters/lib/storage.php' => array('type' => 'f'),
				'/addons/googleWebMasters/lib/src' => array('type' => 'd'),
				);
			fileSystemRemoveFiles($deleteFiles);
		}
		if(version_compare(getOldAddonVersion('googleWebMasters'), '1.0.8', '<')){
			DB::doQuery("DELETE FROM `?:google_webmasters_profiles_sites` WHERE siteID NOT IN (SELECT siteID FROM `?:sites`) ");
		}
		if(version_compare(getOldAddonVersion('googleWebMasters'), '1.1.0', '<')){
			$grantRevokeWMTData = getOption('googleWebMastersAccessStatus');
			deleteOption('googleWebMastersAccessToken');
			DB::delete("?:google_webmasters_profiles", "1");
			DB::delete("?:google_webmasters_profiles_sites", "1");
			updateOption('gwtMapProfilesAndSitesInitialRun', "N");
			updateOption('googleWebMastersAccessStatus', 'revoke');
			if ($grantRevokeWMTData == 'grant') {
				updateOption('showGWApiUpdateNotes', 1);
				addNotification($type='W', $title='NEED TO REAUTHENTICATE GOOGLE WEBMASTERS', $message="For the new update to take effect, we had to Revoke Access to your Google Webmasters account. <br><strong>Please Grant Access again</strong>.<br><br><a class='googleWTSettingsClick'>Go to Settings → Google</a>", $state='U', $callbackOnClose='', $callbackReference='', time()+60);
			}
		}
		if(version_compare(getOldAddonVersion('googleWebMasters'), '1.1.2beta1', '<')){
			$deleteFiles = array('/addons/googleWebMasters/initHTMLHead.php' => array('type' => 'f') );
			fileSystemRemoveFiles($deleteFiles);
		}
		return true;
	}
	

}