<?php

/*
slug: installClone
version: 2.3.0
*/

class addonInstallClone{
	
	private static $version = '2.3.0';
	
	public static function version(){
		return self::version;	
	}
	
	public static function init(){
		require_once(APP_ROOT."/addons/installClone/controllers/func.php");	
		require_once(APP_ROOT."/addons/installClone/controllers/manageClientsInstallClone.php");	
		panelRequestManager::addFunctions('cloneSiteBackupsHTML', 'installCloneSaveProfile', 'installCloneGetProfile', 'installCloneGetAllProfiles','installCloneDeleteProfile', 'getICTestConnectionResult', 'getMultiCallBackupStatus');
		regHooks('addonMenus', 'responseProcessors', 'taskTitleTemplate', 'updateCheck', 'headHTMLFiles');
	}	
	
	public static function install(){
		
		$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:install_clone_repository` (
  `installCloneProfileID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `profileName` varchar(255) DEFAULT NULL,
  `accountInfo` text,
  PRIMARY KEY (`installCloneProfileID`)
)".DB::getSQLTableEnv().";");
		if($Q1){
			return true;	
		}
		return false;
	}
	
	public static function update(){
		
		$oldVersion = getOldAddonVersion('installClone');
		
		if(version_compare($oldVersion, '1.1.0', '<')){
			$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:install_clone_repository` (
	  `installCloneProfileID` int(10) unsigned NOT NULL AUTO_INCREMENT,
	  `profileName` varchar(255) DEFAULT NULL,
	  `accountInfo` text,
	  PRIMARY KEY (`installCloneProfileID`)
	)".DB::getSQLTableEnv().";");
			if($Q1){
				return true;	
			}
			return false;
		}
		if(version_compare(getOldAddonVersion('installClone'), '2.1.0beta1', '<')){
			$deleteFiles = array(
				'/addons/installClone/initHTMLHead.php' => array('type' => 'f'),
				'/addons/installClone/bridge' => array('type' => 'd'),
				'/addons/installClone/lib' => array('type' => 'd'),
				);
			fileSystemRemoveFiles($deleteFiles);
		}
	return true;
	}
}