<?php

function installCloneAddonMenus(&$menus){
	//$menus[] = '<li><a class="navLinks optionSelect" page="installClone">Install / Clone WP</a></li>';
	$menus['tools']['subMenus'][] = array('page' => 'installClone', 'displayName' => 'Install / Clone WP');
}

function installCloneResponseProcessors(&$responseProcessor){
	$responseProcessor['installClone']['newSite'] = 'installCloneCommonNewSite';
	$responseProcessor['installClone']['existingSite'] = 'installCloneExistingSite'; 
	$responseProcessor['installClone']['installCloneBackupNow'] = 'installCloneBackupNow'; 
	$responseProcessor['installClone']['testConnection'] = 'installCloneCommonNewSite';
	$responseProcessor['installClone']['bridgeExtractMulticall'] = 'bridgeExtractMulticall';
	$responseProcessor['installClone']['newExistingSite'] = 'installCloneNewExistingSite';
	$responseProcessor['installClone']['uploadBridge'] = 'installCloneTriggerUploadBridge';
	$responseProcessor['installClone']['cloneRun'] = 'installCloneExistingSiteCloneRun';
	$responseProcessor['installClone']['cloneRunMulticall'] = 'cloneRunMulticall';
}

function cloneSiteBackupsHTML($siteID){
	$sitesBackups = panelRequestManager::getSitesBackups(array($siteID), true);
	$HTML = TPL::get('/addons/installClone/templates/cloneView.tpl.php', array('siteBackups' => reset($sitesBackups), 'siteID' => $siteID));
	return $HTML;
}

function installCloneTaskTitleTemplate(&$template){
	$template['installClone']['newSite'][''] = "Install WordPress in 1 site";
	$template['installClone']['newExistingSite'][''] = 'Install WordPress in 1 site';
	$template['installClone']['existingSite'][''] = "Clone 1 site";
	$template['installClone']['installCloneBackupNow'][''] = "Backup 1 site for cloning";
	$responseProcessor['installClone']['testConnection'] = 'Testing 1 site for cloning';
}

function installCloneUpdateCheck($result){
	
	if(!empty($result['WPInstallPackage'])){
		updateOption('WPInstallPackage', serialize($result['WPInstallPackage']));
	}
}

function installCloneSaveProfile($params){
	if(!empty($params)){
		if(!($params['installCloneProfileID'])){
			$save = DB::insert("?:install_clone_repository", array("profileName" => $params['profileName'], "accountInfo" => serialize($params['accountInfo'])));
			if($save){
				return true;
			}
		}
		else
		{
			$where = array(
			      		'query' =>  "installCloneProfileID = ':installCloneProfileID'",
			      		'params' => array(
			      		   ':installCloneProfileID' => $params['installCloneProfileID']
           				)
        			);
			$query = DB::update("?:install_clone_repository", array("profileName" => $params['profileName'], "accountInfo" => serialize($params['accountInfo'])), $where);
			
			if(!empty($query)){
				return $query;
			}
			else{
				return "Profile already exists.";
			}
		}
	}
}

function installCloneDeleteProfile($params){
	$where = array(
	      		'query' =>  "installCloneProfileID = ':installCloneProfileID'",
	      		'params' => array(
	      		   ':installCloneProfileID' => $params['installCloneProfileID']
   				)
			);
	return DB::delete("?:install_clone_repository", $where);
}

function installCloneGetAllProfiles(){
	$get = DB::getArray("?:install_clone_repository", "profileName, installCloneProfileID", "1 ORDER BY profileName ");
	return $get;
}

function installCloneGetProfile($params){
	if(!empty($params)){
		$where = array(
		      		'query' =>  "installCloneProfileID = ':installCloneProfileID'",
		      		'params' => array(
		      		   ':installCloneProfileID' => $params['profileID']
       				)
    			);
		$get = DB::getRow("?:install_clone_repository", "*", $where);
		$get['accountInfo'] = unserialize($get['accountInfo']);
	}
	
	return $get;
}

function getICTestConnectionResult(){
	$actionID = Reg::get('currentRequest.actionID');
	$where = array(
	      		'query' =>  "type = ':type' AND paramID = ':paramID'",
	      		'params' => array(
	      		   ':type' => 'getICTestConnection',
	      		   ':paramID' => $actionID
   				)
			);
	$datas = DB::getFields("?:temp_storage", "data", $where);
	DB::delete("?:temp_storage", $where);
	
	if(empty($datas)){
		return array();
	}
	$returnArray = unserialize($datas[0]);
	
	return $returnArray;
}

function getMultiCallBackupStatus($params){
	if( !empty($params['this_hisID']) && !empty($params['this_actionID']) && !empty($params['this_action']) && !empty($params['this_site_id'])){
		$historyData = getHistory($params['this_hisID']);
		return array('status' => $historyData['status'], 'cloneSiteBackupsHTML' => cloneSiteBackupsHTML($params['this_site_id']));
	}
	else{
		return array('status' => 'completed');
	}
}

function installCloneGetWPPackage($URLRequired=false){
	$WPInstallPackage = getOption('WPInstallPackage');
	$WPInstallPackage = unserialize($WPInstallPackage);
	
	if(empty($WPInstallPackage)){
		return false;	
	}
	$bridgePath = getWPFreshPackageFolder();
	$packagePath = $bridgePath . 'WP_custom.zip';
	if(!file_exists($packagePath)){
		$packagePath = $bridgePath . 'WP_'.$WPInstallPackage['version'].'.zip';
	}
	
	
	if(!$URLRequired){
		$finalPackage = $packagePath;
	}
	else{
		$appURL = APP_URL;
		$settings = Reg::get('settings');
		if(!empty($settings['httpAuth']['username'])){
			$appURL = str_replace('://', '://'.$settings['httpAuth']['username'].':'.$settings['httpAuth']['password'].'@', $appURL);
		}
		$finalPackage = str_replace(APP_ROOT.'/', $appURL, $packagePath);
	}
	
	if(file_exists($packagePath)){
		return $finalPackage;
	}
	else{
		if(installCloneDownloadWPPackage($WPInstallPackage)){
			return $finalPackage;
		}
	}
	return false;
}

function installCloneDownloadWPPackage($WPInstallPackage){
	$isDone = false;
	if(!empty($WPInstallPackage['downloadURL'])){
		//delete old one
		$lastVersion = getOption('lastWPInstallPackageDownloaded');
		$bridgePath = getWPFreshPackageFolder();
		if (!file_exists($bridgePath)) {
			$status = mkdir($bridgePath, 0755);
			if ($status == false) {
				addNotification($type='E', $title='WORDPRESS '.$WPInstallPackage['display_version'].' DOWNLOAD FAILED', $message='The latest WordPress '.$WPInstallPackage['display_version'].' package download failed. <br>Make sure '.$bridgePath.' is writable.', $state='U', $callbackOnClose='', $callbackReference='');
				return false;
			}
		}
		@unlink($bridgePath.'WP_'.$lastVersion.'.zip');

		//new download
		addNotification($type='N', $title='DOWNLOADING WORDPRESS '.$WPInstallPackage['display_version'], $message='The latest WordPress '.$WPInstallPackage['display_version'].' package is being downloaded.', $state='U', $callbackOnClose='', $callbackReference='');
		$isDone = downloadURL($WPInstallPackage['downloadURL'], $bridgePath.'WP_'.$WPInstallPackage['version'].'.zip');
		if($isDone && file_exists($bridgePath.'WP_'.$WPInstallPackage['version'].'.zip')){
			addNotification($type='N', $title='WORDPRESS '.$WPInstallPackage['display_version'].' DOWNLOAD COMPLETE', $message='The latest WordPress '.$WPInstallPackage['display_version'].' package has been downloaded. This will be used for all subsequent WordPress installations until an updated version is available.', $state='U', $callbackOnClose='', $callbackReference='');
			updateOption('lastWPInstallPackageDownloaded', $WPInstallPackage['version']);
		}
		else{
			addNotification($type='E', $title='WORDPRESS '.$WPInstallPackage['display_version'].' DOWNLOAD FAILED', $message='The latest WordPress '.$WPInstallPackage['display_version'].' package download failed. <br>Make sure '.$bridgePath.' is writable.', $state='U', $callbackOnClose='', $callbackReference='');	
		}
	}
	return $isDone;
}

function getWPFreshPackageFolder(){
	return APP_ROOT.'/uploads/WPFreshPackage/';
}

function installCloneHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('installClone');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/installClone/css/install_clone_styles.css')),
		array('js' => array('href' => 'addons/installClone/js/functions.js')),
		array('js' => array('href' => 'addons/installClone/js/init.js')),
		array('js' => array('href' => 'addons/installClone/js/load.js')),
	);
	$headFiles['installClone'] = $addonDetails;
}