<?php

include_once APP_ROOT.'/controllers/manageClientsInstallCloneCommon.php';

class manageClientsInstallClone{
	
	public static function installCloneExistingSiteProcessor($siteIDs, $params){
		
		$type = "installClone";
		$action = "existingSite";
		$requestAction = "restore";
		$timeout = (20 * 60);
		
		$maintainOldKey = false;
		
		$historyAdditionalData = array();
	    $historyAdditionalData[] = array('uniqueName' => 'existingSite', 'detailedAction' => $type);
		
		
		if($params['backupURL'] == 'localPackage'){//FreshWP to Existing site
			$params['backupURL'] = installCloneGetWPPackage(true);
			$oldUser = '';
			$params['iwpClone'] = '1';
                        $maintainOldKey = true;
		}
		elseif(!empty($params['cloneFromURL'])){//BackURL to Existing site
			$oldUser = '';
		}
		elseif(!empty($params['manualBackupFile'])){//BackURL to Existing site
			$oldUser = '';
		}
		else{//Site Backup to Existing site
			if(!empty($params['sourceSiteID'])){
				$sourceSiteData = getSiteData($params['sourceSiteID']);
				$oldUser = $sourceSiteData['adminUsername'];
				$maintainOldKey = true;
			}
			else{
				addNotification($type='E', $title='Install/Clone error', 'Param sourceSiteID missing.', $state='U', $callbackOnClose='', $callbackReference='');
				return;	
			}
		}
		
		if(!empty($oldUser)){
			$oldUser = serialize($oldUser);
		}
		/*if(!empty($params['newUserName'])){
			$params['newUserName'] = $params['newUserName'];
		}
		if(!empty($params['newUserName'])){
			$params['newUserPassword'] = $params['newUserPassword'];
		}*/
		
		foreach($siteIDs as $siteID){
			$siteData = getSiteData($siteID);
			
			$requestParams = array('backup_url' => $params['backupURL'], 'changeAdminCreds' => $params['changeAdminCreds'], 'manualBackupFile' => $params['manualBackupFile'], 'overwrite' => '1', 'new_user' => $params['newUserName'], 'new_password' => $params['newUserPassword'], 'old_user' => $oldUser, 'clone_from_url' => $params['cloneFromURL'], 'iwp_clone' => $params['iwpClone'], 'admin_email' => $params['adminEmail']);

			if($maintainOldKey){
				$requestParams['maintain_old_key'] = 1;
			}
			
			$events=1;
			$PRP = array();
			$PRP['requestAction'] 	= $requestAction;
			$PRP['requestParams'] 	= $requestParams;
			$PRP['siteData'] 		= $siteData;
			$PRP['type'] 			= $type;
			$PRP['action'] 			= $action;
			$PRP['events'] 			= $events;
			$PRP['historyAdditionalData'] 	= $historyAdditionalData;
			$PRP['timeout'] 		= $timeout;
			
		   prepareRequestAndAddHistory($PRP);
		}
	}
	
	public static function installCloneExistingSiteResponseProcessor($historyID, $responseData){
		
		if($responseData['success'] && empty($responseData['success'])){
			return false;
		}
		
		$where = array(
				'query' =>  "historyID = ':historyID'",
				'params' => array(
					':historyID' => $historyID,
				)
			);

		if(!empty($responseData['error'])){
			DB::update("?:history_additional_data", array('status' => 'error', 'errorMsg' => $responseData['error']), $where);
		}
		
		if(!empty($responseData['success'])){
			DB::update("?:history_additional_data", array('status' => 'success'), $where);
			
			if($responseData['success'] != 1){
				$historyData = DB::getRow("?:history", "*", $where);
				$siteID = $historyData['siteID'];
				$SiteIDWhere = array(
					'query' =>  "siteID = ':siteID'",
					'params' => array(
						':siteID' => $siteID,
					)
				);
				DB::update("?:sites", array('adminUsername' => $responseData['success']), $SiteIDWhere);
			}
		}
	}

	public static function installCloneNewExistingSiteProcessor($siteIDs, $params){
		$type = "installClone";
		$action = "newExistingSite";
		$requestAction = "file_editor_upload";
		$historyAdditionalData = array();
		$events=1;
		$file = APP_ROOT."/includes/bridge/bridge.php";
		$fileName = 'bridge.php';
		// $fileOrig = substr($file,0,-4);
		$ext = substr($file,strrpos($file, '.')+1);
		$fileContent = '';
		if(file_exists($file)){
			$fileHandler = fopen($file,r);
			if (!function_exists('gzdeflate')) {
				addNotification($type='E', $title='Gzip library missing', 'Gzip library functions are not available.', $state='U', $callbackOnClose='', $callbackReference='');
				return false;
	        }else{
				$fileContent = gzdeflate(fread($fileHandler, filesize($file)));
				$fileContentEncode = base64_encode($fileContent);
	        }
			fclose($fileHandler);
		}else{
			addNotification($type='E', $title='Uploaded file corrupt', 'Uploaded file is corrupt/missing.', $state='U', $callbackOnClose='', $callbackReference='');
			return false;
		}
		
		foreach ($siteIDs as $index => $siteID) {
			$siteData = getSiteData(intval($siteID));
			$historyAdditionalData[] = array('uniqueName' => 'existingSite', 'detailedAction' => $type, 'successMsg' => '<a href="'.$siteData['URL'].'/iwp-clone-log.txt" target="_blank">View log</a>');
			$requestParams = array('filePath'=>array('clone_controller', 'bridge.php'),'folderPath'=>'root','fileContent'=>$fileContentEncode,'ext'=>$ext, 'fileName'=> $fileName);
			$PRP = array();
			$siteData['connectURL'] = 'siteURL';
			$PRP['requestAction'] 	= $requestAction;
			$PRP['siteData'] 		= $siteData;
			$PRP['type'] 			= $type;
			$PRP['action'] 			= $action;
			$PRP['requestParams'] 	= $requestParams;
			$PRP['directExecute'] 	= false;
			$PRP['events'] 			= $events;
			$PRP['sendAfterAllLoad'] = true;
			$PRP['historyAdditionalData'] 	= $historyAdditionalData;
			$historyID = prepareRequestAndAddHistory($PRP);
		}
		DB::insert("?:temp_storage", array('type' => 'installCloneCommonNewSite', 'paramID' => $historyID, 'time' => time(), 'data' =>  serialize($params)));
	}

	public static function installCloneNewExistingSiteResponseProcessor($historyID, $responseData){
		responseDirectErrorHandler($historyID, $responseData);
		
		if(empty($responseData['success'])){
			return false;
		}
		$where = array(
      		'query' =>  "historyID=':historyID'",
      		'params' => array(
               ':historyID'=>$historyID
				)
		);
		
		$historyData = DB::getRow("?:history", "*", $where);
		$siteID = $historyData['siteID'];
		
		
		if(!empty($responseData['success']['error']) && is_string($responseData['success']['error'])){		
			$where = array(
	      		'query' =>  "historyID=:historyID",
	      		'params' => array(
	               ':historyID'=>$historyID
					)
			);
			DB::update("?:history_additional_data", array('status' => 'error', 'errorMsg' => strip_tags($responseData['success']['error']), 'error' => $responseData['success']['error_code']), $where);	
			return false;
		}
		else{
		
			$historyResponseStatus[$historyID] = "multiCallWaiting";
			Reg::set("historyResponseStatus", $historyResponseStatus);
			
			updateHistory(array('status' => "multiCallWaiting"), $historyID);
			self::installCloneTriggerUploadBridge($historyID, array('siteID' => $siteID, 'parentHistoryID' => $historyID));
			
		}
	}

	public static function installCloneTriggerUploadBridge($historyID, $params){
		$fileName = self::findNextFileToUpload($historyID);
		if ($fileName == false) {
			$allParams = array('action' => 'installCloneExistingSiteCloneRun', 'args' => array('params' => array('parentHistoryID' => $params['parentHistoryID']), 'siteIDs' => array($params['siteID'])));
		}else{
			$allParams = array('action' => 'installCloneTriggerUploadBridge', 'args' => array('params' => array('fileName' => $fileName, 'parentHistoryID' => $params['parentHistoryID']), 'siteIDs' => array($params['siteID'])));
		}
		panelRequestManager::handler($allParams);
	}

	public static function installCloneTriggerUploadBridgeProcessor($siteIDs, $params){
		$type = "installClone";
		$action = "uploadBridge";
		
		$fileName = $params['fileName'];
		$requestAction = "file_editor_upload";
		$parentHistoryID = $params['parentHistoryID'];
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => 'newSite', 'detailedAction' => $type);
		$events=1;
		$file = APP_ROOT."/includes/bridge/".$fileName;
		// $fileOrig = substr($file,0,-4);
		$ext = substr($file,strrpos($file, '.')+1);
		$fileContent = '';
		if(file_exists($file)){
			$fileHandler = fopen($file,r);
			if (!function_exists('gzdeflate')) {
				addNotification($type='E', $title='Gzip library missing', 'Gzip library functions are not available.', $state='U', $callbackOnClose='', $callbackReference='');
				return false;
	        }else{
				$fileContent = gzdeflate(fread($fileHandler, filesize($file)));
				$fileContentEncode = base64_encode($fileContent);
	        }
			fclose($fileHandler);
		}else{
			addNotification($type='E', $title='Uploaded file corrupt', 'Uploaded file is corrupt/missing.', $state='U', $callbackOnClose='', $callbackReference='');
			return false;
		}
		foreach ($siteIDs as $index => $siteID) {
			$siteData = getSiteData(intval($siteID));
			$requestParams = array('filePath'=>array('clone_controller', $fileName),'folderPath'=>'root','fileContent'=>$fileContentEncode,'ext'=>$ext, 'fileName'=> $fileName);
			$PRP = array();
			$siteData['connectURL'] = 'siteURL';
			$PRP['requestAction'] 	= $requestAction;
			$PRP['siteData'] 		= $siteData;
			$PRP['type'] 			= $type;
			$PRP['action'] 			= $action;
			$PRP['requestParams'] 	= $requestParams;
			$PRP['directExecute'] 	= false;
			$PRP['events'] 			= $events;
			$PRP['doNotShowUser'] 	= true;
			$PRP['sendAfterAllLoad'] = true;
			$PRP['parentHistoryID'] = $parentHistoryID;
			$PRP['historyAdditionalData'] 	= $historyAdditionalData;
			prepareRequestAndAddHistory($PRP);
		}
	}

	public static function installCloneTriggerUploadBridgeResponseProcessor($historyID, $responseData){
		responseDirectErrorHandler($historyID, $responseData);
		
		if(empty($responseData['success'])){
			return false;
		}
		$where = array(
      		'query' =>  "historyID=':historyID'",
      		'params' => array(
               ':historyID'=>$historyID
				)
		);
		
		$historyData = DB::getRow("?:history", "*", $where);
		$siteID = $historyData['siteID'];
		
		
		if(!empty($responseData['success']['error']) && is_string($responseData['success']['error'])){		
			$where = array(
	      		'query' =>  "historyID=:historyID",
	      		'params' => array(
	               ':historyID'=>$historyID
					)
			);
			DB::update("?:history_additional_data", array('status' => 'error', 'errorMsg' => strip_tags($responseData['success']['error']), 'error' => $responseData['success']['error_code']), $where);	
			return false;
		}
		else{
		
			DB::update("?:history_additional_data", array('status' => 'success'), $where);
			DB::update("?:history", array('status' => 'completed'), $where);
			self::installCloneTriggerUploadBridge($historyID, array('siteID' => $siteID, 'parentHistoryID' => $historyData['parentHistoryID']));
			
		}
	}

	public static function findNextFileToUpload($historyID){
		$where = array(
      		'query' =>  "historyID=':historyID'",
      		'params' => array(
               ':historyID'=>$historyID
				)
		);
		$fileName = false;
		$previousRequest = DB::getField("?:history_raw_details", "request", $where);
		$previousRequest = unserialize(base64_decode($previousRequest));
		$previousFileName = $previousRequest['params']['fileName'];
		if ($previousFileName == 'bridge.php') {
			$fileName = 'class-pclzip.php';
		}elseif ($previousFileName == 'class-pclzip.php') {
			$fileName = 'db.php';
		}elseif ($previousFileName == 'db.php') {
			$fileName = 'fileSystem.php';
		}
		return $fileName;
	}

	public static function installCloneExistingSiteCloneRunProcessor($siteIDs, $params){
		$type = "installClone";
		$action = "cloneRun";
		$where = array(
      		'query' =>  "paramID=':paramID'",
      		'params' => array(
               ':paramID'=>$params['parentHistoryID']
				)
		);
		$parentHistoryID = $params['parentHistoryID'];
		$panelRequest = DB::getField("?:temp_storage", 'data', $where);
		$params = unserialize($panelRequest);
		$siteData = getSiteData($siteIDs[0]);
		$destinationURL = trim($siteData['URL'], '/').'/clone_controller/bridge.php';
		$actionID = Reg::get('currentRequest.actionID');
		$newUserPassword = !empty($params['newUserPassword']) ? md5($params['newUserPassword']) : '';
		$excludeFromTarget = array();
		$oneShotdownlaod = false;
		if (defined('EXCLUDE_FROM_CLONE_TARGET_FOLDER') && is_array(EXCLUDE_FROM_CLONE_TARGET_FOLDER)) {
			$excludeFromTarget = EXCLUDE_FROM_CLONE_TARGET_FOLDER;
		}

		if (defined('IWP_CLONE_ONE_SHOT_DOWNLOAD') && IWP_CLONE_ONE_SHOT_DOWNLOAD) {
			$oneShotdownlaod = IWP_CLONE_ONE_SHOT_DOWNLOAD;
		}
		$requestParams = array('dbHost' => $params['dbHost'], 'dbUser' => $params['dbUser'], 'dbPassword' => $params['dbPassword'], 'dbName' => $params['dbName'], 'oldSite' => $params['oldURL'], 'oldUser' => $params['oldUser'], 'newSiteURL' => $siteData['URL'], 'newUser' => $params['newUserName'], 'newPassword' => $newUserPassword, 'admin_email' => $params['adminEmail'], 'memorySize' => '256', 'toIWP' => 1,'emptyTargetDir' => $params['emptyCloneDir'], 'backupURL' => $params['backupURL'], 'manualBackupFile' => $params['manualBackupFile'], 'db_table_prefix' => $params['dbPrefix'] , 
		'ftpHost' => $params['hostName'], 
		'ftpPort' => $params['hostPort'],
		'ftpUser' => $params['hostUserName'],
		'ftpPass' => $params['hostPassword'],		
		'ftpBase' => '/'.trim($params['remoteFolder'], '/'),
		'ftpSSL' => $params['hostSSL'],
		'ftpPassive' => $params['hostPassive'],
		'excludeFolder' => $excludeFromTarget,
		'isTestConnection' => (!empty($params['isTestConnection'])) ? 1 : 0,
		'extractParentHID' => $historyID,
		'isStaging' => $params['isStaging'],
		'isExistingSite' => $params['isExistingSite'],
		'oneShotdownlaod' => $oneShotdownlaod,
		'isSameServerStaging' => $params['isSameServerStaging'],
		/*, 'owner' => 'infinitewp.com'*/);
		//
		if(isset($params['use_sftp'])) {
			$requestParams['ftpUseSftp'] = $params['use_sftp'];
		}
		if($requestParams['backupURL'] == 'localPackage'){//FreshWP to Existing site
			$requestParams['backupURL'] = installCloneGetWPPackage(true);
		}
		if(!empty($params['manualBackupFile'])){
			//BackURL From Manual file, We removeing the ftp path, we send only the file name. Basicly the client side we have the http access only, 
			//so we need to place the backup file by root folder of install new site
			$requestParams['manualBackupFile'] = basename($requestParams['manualBackupFile']);
		}
		if(!empty($params['isDeleteStagingSite'])){
			$requestParams['isDeleteStagingSite'] = true;
		}

		$userID = (isset($GLOBALS['userID']) && !empty($GLOBALS['userID']))?$GLOBALS['userID']:$_SESSION['userID'];
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => 'cloneRun', 'detailedAction' => $type);

		$historyData = array('siteID' => $siteIDs[0], 'actionID' => $actionID, 'userID' => $userID, 'type' => $type, 'action' => $action, 'events' => 1, 'status' => 'pending',  'timeout' => 120, 'isPluginResponse' => '0', 'showUser' => 'N', 'parentHistoryID' => $params['parentHistoryID'], 'param1' => base64_encode(serialize($requestParams)), 'param2' => $params['newSiteURL'], 'URL' => $destinationURL, 'parentHistoryID'=> $parentHistoryID);
		$historyID = addHistory($historyData, $historyAdditionalData);
		$updateHistoryData = array('param1' => base64_encode(serialize($requestParams)), 'param2' => $params['newSiteURL'], 'URL' => $destinationURL);
		updateHistory($updateHistoryData, $parentHistoryID);
		DB::insert("?:history_raw_details", array('historyID' => $historyID, 'request' => base64_encode(serialize($requestParams)), 'panelRequest' => serialize($params)));

	}

	public static function installCloneExistingSiteCloneRunResponseProcessor($historyID, $responseData){
		$start = '#Status(';
		$end = ')#';
		
		$strBetArray = getStrBetAll($responseData,$start,$end);
		$statusData = unserializeBase64DecodeArray($strBetArray);
		
		$where = array(
			'query' =>   "historyID=':historyID'",
				'params' => array(
					':historyID' => $historyID,
				)
			);
		$parentHistoryID = DB::getField("?:history", 'parentHistoryID', $where);
		$where = array(
			'query' =>   "historyID=':historyID'",
				'params' => array(
					':historyID' => $parentHistoryID,
				)
			);
		$finalStateReached = false;
		$responseDataReadable = false;
		$setBreak = false;
		foreach($statusData as $d1){
			$responseDataReadable = true;
			if($setBreak){
				break;
			}
			foreach($d1 as $d2 => $d3){
				if($d2 == "error"){
					$finalStateReached = true;
					if(stripos($d3, "test-connection") !== false){
						$historyData = DB::getRow("?:history", "type, actionID, siteID", $where);
						$type = $historyData['type'];
						$actionID = $historyData['actionID'];
						DB::insert("?:temp_storage", array('type' => 'getICTestConnection', 'paramID' => $actionID, 'time' => time(), 'data' =>  serialize(array('error' => $d3))));
					}
					DB::update("?:history_additional_data", array('status' => 'error', 'error' => 'error', 'errorMsg' => $d3), $where);
					DB::update("?:history", array('status' => 'error'), $where);
				} else if($d2 == "success" && $d3 == "multicall"){
					$finalStateReached = true;
					$historyResponseStatus[$parentHistoryID] = "multiCallWaiting";
					Reg::set("historyResponseStatus", $historyResponseStatus);
					
					$multiCallResponse = array();
					$multiCallResponse = $d1['options'];
					$multiCallResponse['parentHistoryID'] = $parentHistoryID;
					// updateHistory(array('status' => "multiCallWaiting"), $where);
					self::triggerBridgeExtractMulticall($multiCallResponse, $siteID);
					$setBreak = true;
					break;
				} else if($d2 == "success" && (stripos($d3, "test-connection") !== false)){
				
					$historyData = DB::getRow("?:history", "type, actionID, siteID", "historyID=".$historyID);
					$type = $historyData['type'];
					$actionID = $historyData['actionID'];
					$siteID = $historyData['siteID'];
					
					$finalStateReached = true;
					DB::insert("?:temp_storage", array('type' => 'getICTestConnection', 'paramID' => $actionID, 'time' => time(), 'data' =>  serialize(array('success' => $d3))));
					DB::update("?:history_additional_data", array('status' => 'success'), $where);
					
					$allParams = array('action' => 'getStats', 'args' => array('siteIDs' => array($siteID), 'extras' => array('sendAfterAllLoad' => false, 'doNotShowUser' => true)));
					
					panelRequestManager::handler($allParams);
				} else if($d2 == "success" && $d3 == 'clone_completed'){
					$finalStateReached = true;
					DB::update("?:history_additional_data", array('status' => 'success'), $where);
				} else if($d2 == "options" && (!empty($d3))){
					$type = DB::getField("?:history","type", $where);
					$d3['isStaging'] = ($type == "staging") ? true : false;
		  			if( $type == 'staging'){
						self::triggerAddSite($historyID, $d3);
					}else{
						self::triggerAddSite('', $d3);

					}
					return;
				}	
			}
		}
		if($responseDataReadable === true && $finalStateReached === false){
			DB::update("?:history_additional_data", array('status' => 'error', 'error' => 'error', 'errorMsg' => 'An unknown error occured in Install/Clone process.'), $where);
		}
	}

	public static function triggerBridgeExtractMulticall($data, $siteID){
		$allParams = array('action' => 'cloneRunMulticall', 'args' => array('params' => array('responseData' => $data, 'extractParentHID' => $data['parentHistoryID']), 'siteIDs' => array($siteID)));
		panelRequestManager::handler($allParams);
		
	}
	
	public static function cloneRunMulticallProcessor($siteIDs, $params, $extras){
		$type = "installClone";
		$action = "cloneRunMulticall";
		$requestAction = "bridgeExtractMulticall";
		if ($param['responseData']['is_file_append']) {
			$timeout = 300;// File appending process happing in single call so timeout increased. This need to come in multical 
		}
		$timeout = 180;
		
		if(empty($params['extractParentHID'])){
			return;	
		}
		$where = array(
			'query' =>   "historyID=':historyID'",
				'params' => array(
					':historyID' => $params['extractParentHID'],
				)
			);
		$parentHistoryIDStatus = DB::getField("?:history", "status", $where);
	
		if(($parentHistoryIDStatus != 'multiCallWaiting')){
			return;
		}
		
		$getCount = DB::getField("?:history", "count(historyID)", "type='installClone' AND action = 'cloneRunMulticall' AND parentHistoryID = '".$params['extractParentHID']."'" );
		if($getCount >= 500){
			updateHistory(array('status' => 'error', 'error' => 'max_trigger_calls_reached'), $params['extractParentHID'], array('status' => 'error', 'error' => 'max_trigger_calls_reached', 'errorMsg' => 'Multi-call limit reached.'));
			return;
		}
		
		if(DB::getExists("?:history", "historyID", "type='installClone' AND action = 'cloneRunMulticall' AND parentHistoryID = '".$params['extractParentHID']."' AND status not IN('completed', 'error', 'netError')")){
			return;
			
		}
		
		$oldHistoryData = getHistory($params['extractParentHID'], true);
		
		$requestParams = array('mechanism' => 'multiCall','extractParentHID' => $params['extractParentHID'], 'responseData' => $params['responseData'], 'param1' => $oldHistoryData['param1']);
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => "cloneRunMulticall", 'detailedAction' => $action);
		
		$doNotShowUser = true;
		$siteData = getSiteData($oldHistoryData['siteID']);
		$siteData['connectURL'] = 'siteURL';
		$siteData['URL'] = trim($siteData['URL'], '/').'/clone_controller/bridge.php';
		$siteData['siteID'] = $oldHistoryData['siteID'];
				  		
		$events=1;
		$PRP = array();
		$PRP['requestAction'] 	= $requestAction;
		$PRP['requestParams'] 	= $requestParams;
		$PRP['siteData'] 		= $siteData;
		$PRP['type'] 			= $type;
		$PRP['action'] 			= $action;
		$PRP['events'] 			= $events;
		$PRP['historyAdditionalData'] 	= $historyAdditionalData;
		$PRP['timeout'] 		= $timeout;
		$PRP['doNotShowUser'] 	= $doNotShowUser;
		$PRP['parentHistoryID'] = $params['extractParentHID'];
		$PRP['isPluginResponse'] = 0;
			
		prepareRequestAndAddHistory($PRP);

	}
	
	public static function cloneRunMulticallResponseProcessor($historyID, $responseData){
		
		$start = '#Status(';
		$end = ')#';
		
		$strBetArray = getStrBetAll($responseData,$start,$end);
		$statusData = unserializeBase64DecodeArray($strBetArray);
		$finalStateReached = false;
		$responseDataReadable = false;
		$setBreak = false;
		
		$fullHistoryData = getHistory($historyID, true);
		
		$where = array(
			'query' =>   "historyID=':historyID'",
				'params' => array(
					':historyID' => $historyID,
				)
			);

		foreach($statusData as $d1){
			$responseDataReadable = true;
			if($setBreak){
				break;
			}
			foreach($d1 as $d2 => $d3){
				if($d2 == "error"){
					$finalStateReached = true;
					if(stripos($d3, "test-connection") !== false){
						$historyData = DB::getRow("?:history", "type, actionID, siteID", $where);
						$type = $historyData['type'];
						$actionID = $historyData['actionID'];
						DB::insert("?:temp_storage", array('type' => 'getICTestConnection', 'paramID' => $actionID, 'time' => time(), 'data' =>  serialize(array('error' => $d3))));
					}
					DB::update("?:history_additional_data", array('status' => 'error', 'error' => 'error', 'errorMsg' => $d3), $where);
					DB::update("?:history", array('status' => 'error'), $where);
					$updateWhere = array(
						'query' =>   "historyID=':historyID'",
							'params' => array(
								':historyID' => $fullHistoryData['parentHistoryID'],
							)
						);
					DB::update("?:history_additional_data", array('status' => 'error', 'error' => 'error', 'errorMsg' => $d3), $updateWhere);
					
					DB::update("?:history", array('status' => 'error'), $updateWhere);
				} else if($d2 == "success" && $d3 == "multicall"){
					$finalStateReached = true;
					DB::update("?:history_additional_data", array('status' => 'success'), $where);
					DB::update("?:history", array('status' => 'completed'), $where);
					
					$multiCallResponse = array();
					$multiCallResponse = $d1['options'];
					$multiCallResponse['parentHistoryID'] = (!empty($d1['options']['extractParentHID'])) ? $d1['options']['extractParentHID'] : $fullHistoryData['parentHistoryID'];
					self::triggerBridgeExtractMulticall($multiCallResponse, 0);
					$setBreak = true;
					break;
				} else if($d2 == "success" && (stripos($d3, "test-connection") !== false)){
				
					$historyData = DB::getRow("?:history", "type, actionID, siteID", "historyID=".$historyID);
					$type = $historyData['type'];
					$actionID = $historyData['actionID'];
					$siteID = $historyData['siteID'];
					
					$finalStateReached = true;
					DB::insert("?:temp_storage", array('type' => 'getICTestConnection', 'paramID' => $actionID, 'time' => time(), 'data' =>  serialize(array('success' => $d3))));
					DB::update("?:history_additional_data", array('status' => 'success'), $where);
					
					$allParams = array('action' => 'getStats', 'args' => array('siteIDs' => array($siteID), 'extras' => array('sendAfterAllLoad' => false, 'doNotShowUser' => true)));
					
					panelRequestManager::handler($allParams);
				} else if($d2 == "success" && (strpos($d3, "clone_completed") !== false)){
					$finalStateReached = true;
					DB::update("?:history_additional_data", array('status' => 'success'), $where);

					$updateWhere = array(
						'query' =>   "historyID=':historyID'",
							'params' => array(
								':historyID' => $fullHistoryData['parentHistoryID'],
							)
					
						);
					$type = DB::getField("?:history","type", $where);
					if ($type != 'staging') {
						$param1 = unserialize(base64_decode(DB::getField("?:history","param1", $updateWhere)));
						$URL = trim($param1['newSiteURL'],'/');
						addNotification($type='N', $title='CLONE COMPLETED', $message='You have successfully created the clone site.<br><a href="'.$URL.'/iwp-clone-log.txt" target="_blank">View log</a>', $state='U', $callbackOnClose='', $callbackReference='');
					}
					DB::update("?:history_additional_data", array('status' => 'success'), $updateWhere);
					
					DB::update("?:history", array('status' => 'completed'), $updateWhere);
				} else if($d2 == "options" && (!empty($d3))){
					$historyData = DB::getRow("?:history", "type, actionID, siteID, parentHistoryID", $where);
					$where = array(
						'query' =>   "historyID=':historyID'",
							'params' => array(
								':historyID' => $historyData['parentHistoryID'],
							)
						);
					$type = DB::getField("?:history","type", $where);
					$d3['isStaging'] = ($type == "staging") ? true : false;
		  			if( $type == 'staging'){
						self::triggerAddSite($historyData['parentHistoryID'], $d3);
					}else{
						self::triggerAddSite('', $d3);

					}
					return;
				}	
			}
		}
		
		if($responseDataReadable === true && $finalStateReached === false){
			DB::update("?:history_additional_data", array('status' => 'error', 'error' => 'error', 'errorMsg' => 'An unknown error occured in Install/Clone process.'), $where);
		}
	}

	public static function triggerAddSite($parentHistoryID, $siteOptions){
		//Add site Function.
		$thisUrl = trim($siteOptions['URL']);
		$thisUrl = $thisUrl.(substr($thisUrl, -1) == '/' ? '' : '/');
		$parentActionID = getActionIDByHistoryID($parentHistoryID);
		$where = array(
			'query' =>   "URL=':URL'",
				'params' => array(
					':URL' => $thisUrl,
				)
			);

		$siteAlreadyExists = DB::getRow("?:sites", "siteID", $where);
		if (!empty($siteOptions['isStaging'])) {
			$isStaging = 1;
		}
		if (!empty($siteOptions['userName']) && !empty($siteAlreadyExists['siteID'])) {
			DB::update("?:sites", array('adminUsername' => $siteOptions['userName']), $where);
		}
		$params = array('URL' => $siteOptions['URL'], 'username' => $siteOptions['userName'], 'activationKey' => $siteOptions['activationKey'], 'parentHistoryID' => $parentHistoryID, 'doNotShowUser' => self::isHideAddSiteProcessForStaging($siteOptions['isStaging']), 'actionID' => $parentActionID, 'isStaging' => $isStaging, 'iwp_admin_version' => '2.10.1');
		

		if($siteAlreadyExists && !empty($siteAlreadyExists['siteID'])){
			$_POST = array('action' => 'readdSite', 
				'args' => array(
				'params' => $params, 
				'siteIDs' => array( 0 => $siteAlreadyExists['siteID']), 
				)
			);
		} else{
			$_POST = array('action' => 'addSite', 
				'args' => array(
				'params' => $params, 
					'siteIDs' => array(),
				)
			);
		}
		panelRequestManager::handler($_POST);
		if(!empty($siteOptions['isStaging'])){
			addNotification($type='N', $title='STAGING COMPLETE', $message='You have successfully created the staging site.<br><a href="'.$siteOptions['URL'].'/iwp-clone-log.txt" target="_blank">View log</a>', $state='U', $callbackOnClose='', $callbackReference='');
			self::stagingInsertIntoFireQueue();
		} else {
			self::installCloneInsertIntoFireQueue();
		}
	}

	public static function isHideAddSiteProcessForStaging($isStaging = null){
		$hideSiteVar = false;
		if(!empty($isStaging)){
			$hideSiteVar = true;
		}
		return $hideSiteVar;
	}
	public static function stagingInsertIntoFireQueue(){
		$requiredData['stagingCompleted'] = array(
			'getSites' => '1',
			'stagingGetStagingBaseIDs' => '1'
		);
		panelRequestManager::insertFireQueue($requiredData);
	}
	public static function installCloneInsertIntoFireQueue(){
		$requiredData['installCloneCompleted'] = array(
			'getGroupsSites' => '1',
			'getSites' => '1',
			'getSitesList' => '1',
		);
		panelRequestManager::insertFireQueue($requiredData);
	}

	
}
manageClients::addClass('manageClientsInstallClone');