<?php 

function ithemesSecurityAddonMenus(&$menus){
	$menus['protect']['subMenus'][] = array('page' => 'ithemesSecurity', 'displayName' => 'iThemes Security');
}

function ithemesSecurityResponseProcessors(&$responseProcessor){
	// $responseProcessor[<<type>>][<<action>>] = <<initial_part_of_response_processor_function_in_func.php>>;
        $responseProcessor['ithemesSecurity']['load'] = 'ithemesSecurityLoad';

}

function ithemesSecurityTaskTitleTemplate(&$template){
	$template['ithemesSecurity']['load']['']	= "Loading security scan results from <#sitesCount#> site<#sitesCountPlural#>";
}

function ithemesSecurityLoad() {
	$actionID = Reg::get('currentRequest.actionID');
	$where = array(
				'query' =>  "type = ':type' AND paramID = ':paramID'",
				'params' => array(
					':type' => 'ithemesSecurity',
					':paramID' => $actionID

				)
			);
	$linksData = DB::getFields("?:temp_storage", "data", $where);

	
		
	DB::delete("?:temp_storage", $where);
		
	if(empty($linksData)){
		return array();
	}
	$refinedData = array();

	foreach($linksData as $data){
		$refinedData = array_merge_recursive($refinedData, (array)unserialize($data));	
	}
	arrayMergeRecursiveNumericKeyHackFix($refinedData);
	foreach($refinedData as $siteID => $links){
		$where = array(
					'query' =>  "siteID = ':siteID'",
					'params' => array(
						':siteID' => $siteID
					)
				);
		$siteData = DB::getRow("?:sites","URL",$where);

		
		$refinedData['siteURLs'][] = $siteData['URL'];
		$refinedData['siteIDs'][] = $siteID;
	}

        return $refinedData;
}

function ithemesSecurityHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('ithemesSecurity');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/ithemesSecurity/css/style.css')),
		array('js' => array('href' => 'addons/ithemesSecurity/js/functions.js')),
		array('js' => array('href' => 'addons/ithemesSecurity/js/init.js')),
		array('js' => array('href' => 'addons/ithemesSecurity/js/load.js')),
	);
	$headFiles['ithemesSecurity'] = $addonDetails;
}