<?php

/*
slug: multiUser
version: 1.1.7
*/

class addonMultiUser{
	
	private static $version = '1.1.7';
	
	public static function version(){
		return self::version;	
	}
	
	
	
	public static function init(){	
	
		require_once(APP_ROOT."/addons/multiUser/controllers/func.php");
		//require_once(APP_ROOT."/addons/multiUser/controllers/manageClientsMultiUser.php");	
		panelRequestManager::addFunctions("multiUserAddUpdateAdmin", "multiUserDeleteAdmin", "multiUserChangeAdminStatus", "multiUserAdminList", "multiUserGetAdmin", "multiUserAllowAccess", "multiUserPrivilegeSaveTemplate", "multiUserPrivilegeGetTemplate", "multiUserPrivilegeGetAllTemplates", "multiUserUserPrivilegeDeleteGroup", "multiUserPrivilegeAddons", "multiUserAdminsHTML", "multiUserAccess", "multiUserAllowAction", "multiUserRawSitesStats", "multiUserGetAllUsers", "multiUserGetSites", "multiUserPrivilegeDeleteTemplate", "multiUserStatus");
		
		regHooks('addonMenus', 'addonsRestrict', 'addSiteLimit', 'sitesList', 'groupsSites', 'historyHTML', 'headHTMLFiles');
	}

	public static function install(){
		
		$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:user_privilege_template` (
						  `privilegeTemplateID` int(10) unsigned NOT NULL AUTO_INCREMENT,
						  `userID` int(10) unsigned DEFAULT NULL,
						  `privilegeTemplateName` varchar(255) DEFAULT NULL,
						  `permissions` text,
						  PRIMARY KEY (`privilegeTemplateID`),
						  UNIQUE KEY `privilegeTemplateName` (`privilegeTemplateName`(191))
						)".DB::getSQLTableEnv().";");
						
		if($Q1){
			return true;
		}
		
		return false;
	}
	
	public static function update(){
		$where = array(
					'query' =>  "accessLevel = ':accessLevel'",
					'params' => array(
						':accessLevel' => 'manager'
					)
			);
		$userInfos = DB::getArray("?:users", "userId,permissions", $where);
		foreach($userInfos as $userInfo){
			if(isset($userInfo['permissions']) && $userInfo['permissions']!="") {
				$permissions = unserialize($userInfo['permissions']);
				if(!isset($permissions['access'])) $permissions['access'] = array();
				if(!isset($permissions['restrict'])) $permissions['restrict'] = array();
				$permissions = serialize($permissions);
			}
			$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $userInfo['userId']
					)
			);
			DB::update("?:users", array( 'permissions' => $permissions), $where);
		}
		if(version_compare(getOldAddonVersion('multiUser'), '1.1.3beta1', '<')){
			$deleteFiles = array('/addons/multiUser/initHTMLHead.php' => array('type' => 'f') );
			fileSystemRemoveFiles($deleteFiles);
		}
		if (version_compare(getOldAddonVersion('multiUser'), '1.1.5beta1.1', '<')) {
			DB::update("?:users",array('permissions'=>serialize(array('notifyLicense'=>'1'))), "accessLevel='admin' AND permissions IS NOT NULL");
		}
	}
	
}

?>