<?php

function multiUserAddonMenus(&$menus){
	if(userStatus() == "admin")
		//$menus['main']['mainMenus'][] = array('page' => 'iwpusers', 'displayName' => 'IWP Multi Users');
		$menus['manage']['subMenus'][] = array('page' => 'iwpusers', 'displayName' => 'InfiniteWP Users');
}

function multiUserAddUpdateAdmin($params){
	
	if(empty($params)){ return false; }
	$params['status']=1;
	
	if($params['accessLevel'] == 'admin'){
		$permissions = NULL;
		if (isset($params['permissions']['notifyLicense']) && $params['permissions']['notifyLicense']) {
			$permissions = serialize(array('notifyLicense'=>'1'));
		}
	}
	else{
		if(!isset($params['permissions']['access'])) $params['permissions']['access'] = array();
        if(!isset($params['permissions']['restrict'])) $params['permissions']['restrict'] = array();
		$permissions = serialize($params['permissions']);
	}
	
	if(!empty($params['userID'])){
		$userID = $params['userID'];
		
		if(empty($params['password'])){
			$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $params['userID']
					)
			);
			DB::update("?:users", array('email' => $params['email'], 'name' => $params['name'], 'permissions' => $permissions,/*'sites' => $params['sites'],*/ 'accessLevel' => $params['accessLevel'], 'status' => $params['status']), $where);
		}
		else{
			$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $params['userID']
					)
			);
			DB::update("?:users", array('email' => $params['email'], 'name' => $params['name'], 'password' => sha1($params['password']), 'permissions' => $permissions, /*'sites' => $params['sites'],*/ 'accessLevel' => $params['accessLevel'], 'status' => $params['status']), $where);
		}
	}
	else{
				$where = array(
					'query' =>  "email = ':email'",
					'params' => array(
						':email' => $params['email']
					)
				);
                $isExists = DB::getExists("?:users", "userID", $where);
                if($isExists){
                        return array('status' => 'error', 'errorMsg' => 'Given email already exists.');
                }
                $userID = DB::insert("?:users", array('email' => $params['email'], 'name' => $params['name'], 'password' => sha1($params['password']), /*'sites' => $params['sites'],*/ 'status' => $params['status'], 'accessLevel' => $params['accessLevel'], 'permissions' => $permissions, 'notifications' => 'a:1:{s:23:"updatesNotificationMail";a:5:{s:9:"frequency";s:5:"daily";s:11:"coreUpdates";s:1:"1";s:13:"pluginUpdates";s:1:"1";s:12:"themeUpdates";s:1:"1";s:18:"translationUpdates";s:1:"1";}}'));
		
		if($userID && $params['notifyManager']){
			//$sendMail = sendAppMail(array('params' => $params), '/addons/multiUser/templates/notifyMail.tpl.php');
			$mailContent = TPL::get('/addons/multiUser/templates/notifyMail.tpl.php', array('params' => $params));
			
			$content = explode("+-+-+-+-+-+-+-+-+-+-+-+-+-createUserNotifyMail+-+-+-+-+-+-+-+-+-+-+-", $mailContent);
			
			$mailParams['subject'] = $content[0];
			$mailParams['message'] = $content[1];
			
			$mailParams['toEmail'] = $params['email'];
			$mailParams['toName'] = $params['name'];
						
			sendUserCreatedNotifyMail($mailParams);
		}			
	}
		
	if(isset($params['siteIDs']) && !empty($params['siteIDs'])){
		$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $userID
					)
				);
		DB::delete("?:user_access", $where);
		foreach($params['siteIDs'] as $key => $siteID){
			$addUserAccessSites = DB::insert("?:user_access", array('siteID' => $siteID, 'userID' => $userID));
		}
		
	}
	else{
		$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $userID
					)
				);
		DB::delete("?:user_access", $where);
	}
	
}

function sendUserCreatedNotifyMail($params){
	
	if(empty($params)){ return false; }
	
	require_once(APP_ROOT.'/lib/phpmailer.php');

	$mail = new PHPMailer(); // defaults to using php "mail()"
	
	$body = $params['message'];
	
	$mail->SetFrom($GLOBALS['email'], $fromName);
	
	$toEmails = $params['toEmail'];
	
	$mail->AddAddress($params['toEmail'], $params['toName']);
		
	$mail->Subject = $params['subject'];
	
	if(!empty($attachment)){
		$mail->AddAttachment($attachment);
	}
	
	$mail->MsgHTML($body);
		
	if(!$mail->Send()) {
	  addNotification($type='E', $title='Mail Error', $message = $mail->ErrorInfo, $state='U');
	  return false;
	} else {
	  //echo "Message sent!";
	  return true;
	}
}

			
function multiUserDeleteAdmin($params){
        $userId=$GLOBALS['userID'];
	if(empty($params)){
		return false;
	}
		
		/* Delete user related properties from the table. */
        if($userId!=$params['userID']){  /*Avoid the user delete by own*/
        	$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $params['userID']
					)
				);
            DB::Delete("?:users", $where);
            DB::Delete("?:user_access", $where);
            DB::Delete("?:settings", $where);
            DB::Delete("?:groups", $where);
        }
        else {
            return false;
        }
}

function multiUserChangeAdminStatus($params){
	if(empty($params)){
		return false;
	}
	/* Delete user related properties from the table. */
	$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $params['userID']
					)
			);
	DB::update("?:users",  array('status' => $params['adminStatus']),$where);
	
}
	
function multiUserAdminList(){
	$allUsers = DB::getArray("?:users", "*", 1, "userID");
	
	foreach($allUsers as $userKey => $userVal){
		$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $userKey
					)
			);
		$userSiteCount = DB::getField("?:user_access", "count(userID) As userSiteCount", $where);
		
		$allUsers[$userKey]['userSiteCount'] = $userSiteCount;
	}
	return $allUsers;
}

function multiUserGetAdmin($params){
	
	if(empty($params)){
		return false;
	}
	$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $params['userID']
					)
			);
	$datas = DB::getRow("?:users", "email, name, userID, accessLevel, permissions, status", $where);

	$datas['siteAccess'] = DB::getFields("?:user_access", "siteID", $where);
	$datas['permissions'] = unserialize($datas['permissions']);
		
	return $datas;
}

function getManagersIDsBySiteID($siteID){
	$where = array(
		'query'  => "siteID = :siteID" ,
		'params' => array(
			':siteID' => $siteID,
			)
		);
	return DB::getFields('?:user_access', 'userID' ,$where);
}

/*function multiUserUserPermissionAndRestriction($action){ //$params = $action
	
	$restrictions = DB::getField("?:users", "restrictions", "userID = '".$_SESSION['userID']."' ");
	$restrictions = unserialize($restrictions);
	$restictedAction = array();
	if(!empty($restrictions))
	foreach($restrictions as $key => $type){
		if($type == 'updates') array_push($restictedAction, 'updateAll', 'updateClient');
		if($type == 'openAdmin') array_push($restictedAction, 'loadSite');
		if($type == 'addEditRemoveSite') array_push($restictedAction, 'addSite', 'removeSite');
		if($type == 'items') array_push($restictedAction, 'installPlugins', 'installThemes', 'managePlugins', 'manageThemes');
		if($type == 'createBackup') array_push($restictedAction, 'backup');
		if($type == 'restoreDeleteDownloadBackup') array_push($restictedAction, 'restoreBackup', 'removeBackup');
	}
	
	if(in_array($action, $restictedAction)){
		addNotification($type='E', $title='Message From Admin', $message='You can not done this action. You are resticted.', $state='U', $callbackOnClose='', $callbackReference='');
		exit;
	}
}
*/

//multiIserUserPermissionsAndRestriction => multiUserAllowAccess => multiUserAllowAction
function multiUserAllowAction($action){
	
	/*$access = DB::getField("?:users", "access", "userID = '".$_SESSION['userID']."' ");
	$access = unserialize($access);*/
	$permissions = multiUserAllowAccess();
	$access = $permissions['access'];
	$accessAction = array();
	if(!empty($access)){
		foreach($access as $key => $type){
			if($type == 'updates') array_push($accessAction, 'updateAll', 'updateClient');
			if($type == 'openAdmin') array_push($accessAction, 'loadSite');
			if($type == 'addEditRemoveSite') array_push($accessAction, 'addSite', 'removeSite');
			if($type == 'items') array_push($accessAction, 'installPlugins', 'installThemes', 'managePlugins', 'manageThemes');
			if($type == 'createBackup') array_push($accessAction, 'backup');
			if($type == 'restoreDeleteDownloadBackup') array_push($accessAction, 'restoreBackup', 'removeBackup');
		}
		
		if(in_array($action, $accessAction)){
			return true;
		}
	}
}
//multiUserAllowAccess => multiUserAllowAccess
function multiUserAllowAccess(){
	$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $GLOBALS['userID']
					)
			);
	$getPermissions = DB::getField("?:users", "permissions", $where);
	if (userStatus() == "admin") {
		return array();
	}
	if(!empty($getPermissions)){
		$permissions = unserialize($getPermissions);
		return $permissions;
	}
	return array();
}

function multiUserPrivilegeSaveTemplate($params){
	
	if(empty($params) || empty($params['privilegeTemplateName'])){
		return false;
	}
	
	$params['permissions']['siteIDs'] = $params['siteIDs'];
	$permissions = serialize($params['permissions']);
	
	if(empty($params['privilegeTemplateID'])){
		$query = DB::insert("?:user_privilege_template", array('privilegeTemplateName' => $params['privilegeTemplateName'], 'userID' => $GLOBALS['userID'], 'permissions' => $permissions));
		
		if(!$query){
			$where = array(
					'query' =>  "privilegeTemplateName = ':privilegeTemplateName'",
					'params' => array(
						':privilegeTemplateName' => $params['privilegeTemplateName']
					)
			);
			$isExists = DB::getExists("?:user_privilege_template", "privilegeTemplateID", $where);

			if($isExists){
				return array('status' => 'error', 'errorMsg' => 'Profile already exists.');
			}
			else{
				return array('status' => 'error', 'errorMsg' => 'Oops! Try again.');
			}
		}
		else{
			return array('status' => 'success');
		}
		
		/*if(!empty($query)){
			$data = array();
			$data['status'] = 'success';
			$data['privilegeTemplateID'] = $query;
			$data['privilegeTemplateName'] = DB::getField("?:user_privilege_template","privilegeTemplateName", "privilegeTemplateID='".$query."'"); 
			return $data;
		}
		else{
			return array('status' => 'error', 'errorMsg' => 'Oops! Try again.');
		}*/
	}
	
	/*else{
		$query = DB::insert("?:user_privilege_template", array('privilegeTemplateName' => $params['privilegeTemplateName'], 'userID' => $GLOBALS['userID'], 'permissions' => $permissions), "privilegeTemplateID='".$params['privilegeTemplateID']."'");
		if(!empty($query)){
			return $query;
		}
		else{
			return "Profile already exists.";
		}
	}*/
}

function multiUserPrivilegeGetTemplate($params){
	if(empty($params)){
		return false;
	}
	
	$datas = array();
	$where = array(
					'query' =>  "privilegeTemplateID = ':privilegeTemplateID'",
					'params' => array(
						':privilegeTemplateID' => $params['privilegeTemplateID']
					)
			);
	$data = DB::getRow("?:user_privilege_template", "*", $where);
	$datas = unserialize($data['permissions']);
	$datas['privilegeTemplateName'] = $data['privilegeTemplateName'];
	
	if(!empty($datas)){
		return $datas;
	}
	else{
		return false;
	}
}

function multiUserGetAllUsers($params){
	$managers = DB::getArray("?:users", "name, email, userID, accessLevel", "1");
	if(!empty($managers)){
		return $managers;
	}
	else{
		return false;
	}
}

function multiUserPrivilegeGetAllTemplates($params){
	$profiles = DB::getArray("?:user_privilege_template", "privilegeTemplateID, privilegeTemplateName","1");
	if(!empty($profiles)){
		return $profiles;
	}
	else{
		return false;
	}
}

function multiUserPrivilegeDeleteTemplate($params){
	$where = array(
					'query' =>  "privilegeTemplateID = ':privilegeTemplateID'",
					'params' => array(
						':privilegeTemplateID' => $params['privilegeTemplateID']
					)
			);
	return DB::delete("?:user_privilege_template", $where);
}

function multiUserPrivilegeAddons(){
	$allPurchasedAddonsNameAndSlug = Reg::get('allPurchasedAddonsNameAndSlug');
	unset($allPurchasedAddonsNameAndSlug['multiUser']);
	return $allPurchasedAddonsNameAndSlug;
}

function multiUserAdminsHTML(){
	$admins = multiUserAdminList();
	//$userPrivilegeAddons = multiUserPrivilegeAddons();
	//multiUserGetAdmin,multiUserPrivilegeAddons
	//$admins['userSiteCount'] = DB::getField("?:user_access", "count(userID)", "userID =".$_SESSION['userID']);
	$HTML = TPL::get('/addons/multiUser/templates/view.tpl.php', array('admins' => $admins/*, 'userPrivilegeAddons' => $userPrivilegeAddons*/));
	return $HTML;
}


function multiUserStatus($params=''){
    
        if(!empty($params)){
        	$where = array(
					'query' =>  "email = ':email' AND password = ':password'",
					'params' => array(
						':email' => trim($params['email']),
						':password' => sha1($params['password'])
					)
			);
            $userName = DB::getRow("?:users", "userID, accessLevel, email, status", $where );
            $isUserExists = !empty($userName["userID"]) ? true : false;
			if($isUserExists) $GLOBALS['userID'] = $userName["userID"];
        } else {
            $userID = !empty($GLOBALS['userID']) ? $GLOBALS['userID'] : '';
            if(!empty($userID)){
            	$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $userID
					)
			);
                $userName = DB::getRow("?:users", "userID,status", $where );
                $isUserExists = !empty($userName["userID"]) ? true : false;
            }
        }
	if(!$isUserExists){ return false; }
	
	if($userName['status'] == 0){
		manageCookies::cookieAllUnset();
		$errorMsg = "reactive"; //'User Inactive <a href="reactive.php">click to reactive.</a>';
		addLoginLog($params['email'], 'authNone', 'error', getLoginPageMsg($errorMsg));
		header('Location: login.php?errorMsg='.$errorMsg); //'Location: ' => reactive page ,. HTML
		exit;
	}
	return true;	
}

/*function multiUserAddonsRestrict(&$activeAddons){
	if($_SESSION["accessLevel"] != 'admin'){
		$restrictions = multiUserAllowAccess();
		if(!empty($restrictions) && is_array($restrictions)){
			foreach($restrictions as $key => $actionAndSlug){
				foreach($activeAddons as $activeAddonkey => $activeAddonsSlug){
					if($actionAndSlug == $activeAddonsSlug['slug']){
						unset($activeAddons[$activeAddonkey]);
					}
				}
			}
		}
	}
}$GLOBALS['userID']
*/

function multiUserAddSiteLimit(){
	$where = array(
					'query' =>  "userID = ':userID'",
					'params' => array(
						':userID' => $GLOBALS['userID']
					)
			);
	$userSiteCount = DB::getField("?:user_access", "count(siteID)", $where);
	$userSiteLimitCount = DB::getField("?:users", "sites", $where);
	
	if(!empty($userSiteCount) && $userSiteCount >= $userSiteLimitCount){			
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => $params['URL'], 'detailedAction' => $action);
		
		$historyData = array('siteID' => '0', 'actionID' => $actionID, 'userID' => $GLOBALS['userID'], 'type' => $type, 'status' => 'error', 'error' => 'limitReached', 'action' => $action, 'events' => $events, 'URL' => $params['URL'], 'timeout' => $timeout);	
		$historyID = addHistory($historyData, $historyAdditionalData);
		$where = array(
					'query' =>  "historyID = ':historyID'",
					'params' => array(
						':historyID' => $historyID
					)
			);
		DB::update("?:history_additional_data", array('status' => 'error', 'errorMsg' => 'Site Limit Reached!'), $where);
		return;
	}
}

function multiUserRawSitesStats(&$sitesStats, &$siteIDs, &$userID){
	
	$where = "";
	if(userStatus($userID) != "admin"){
		$userID = !empty($userID) ? $userID : $GLOBALS['userID'];
		if(!empty($siteIDs)){
			$where = " AND UA.siteID IN (". implode(',', DB::esc($siteIDs)) .") ";
		}
		$where2 = array(
					'query' =>  "UA.userID = ':userID'".$where."AND SS.siteID = UA.siteID",
					'params' => array(
						':userID' => $userID
					)
			);
		$sitesStats = DB::getArray("?:user_access UA, ?:site_stats SS", "SS.*, UA.siteID", $where2, "siteID");
	}
	else{
		if(!empty($siteIDs)){
			$where = " AND SS.siteID IN (". implode(',', DB::esc($siteIDs)) .")";
		}
		$ORDER = ' ORDER BY S.name';		
		$sitesStats = DB::getArray("?:site_stats SS, ?:sites S", "SS.*", "S.siteID = SS.siteID AND S.type = 'normal' AND SS.stats IS NOT NULL ".$where.$ORDER, "siteID");
	}
}

function multiUserSitesList(&$sitesData){
	
	if(userStatus() != "admin"){
		$where = array(
					'query' =>  "UA.userID = ':userID' AND S.siteID = UA.siteID AND S.type = 'normal' ORDER BY S.name ",
					'params' => array(
						':userID' => $GLOBALS['userID']
					)
			);
		$sitesData= DB::getArray("?:sites as S, ?:user_access as UA", "S.siteID, S.URL, S.adminURL, S.name, S.IP, S.adminUsername, S.isOpenSSLActive, S.network, S.parent, S.httpAuth, S.callOpt", $where, "siteID");
	}
	else{
		//siteID, URL, adminURL, name, IP, adminUsername, isOpenSSLActive, network, parent, httpAuth, callOpt, connectURL
		$sitesData = DB::getArray("?:sites", "siteID, URL, adminURL, name, IP, adminUsername, isOpenSSLActive, network, parent", "type = 'normal' ORDER BY name", "siteID");
	}
}

function multiUserGroupsSites(&$groups, &$groupsSites){
	if(userStatus() != "admin"){
		
		$where = "AND G.userID='".$GLOBALS['userID']."'";
		$where2 = "userID='".$GLOBALS['userID']."'";
	
		$groupsSites = DB::getArray("?:groups_sites GS, ?:groups G", "GS.siteID, GS.groupID", "GS.groupID =  G.groupID ".$where);
		$groups = DB::getArray("?:groups", "groupID, name", $where2." ORDER BY groupID", "groupID");
	}
}
//multiUserSites => multiUserGetSites
function multiUserGetSites(&$sitesData){
	if(userStatus() != "admin"){
		$where = array(
					'query' =>  "UA.userID = ':userID' AND S.siteID = UA.siteID AND S.type = 'normal' ORDER BY name",
					'params' => array(
						':userID' => $GLOBALS['userID']
					)
			);
		$sitesData = DB::getArray("?:sites as S, ?:user_access as UA", "S.siteID, S.URL, S.adminURL, S.name, S.IP, S.WPVersion, S.adminUsername, S.isOpenSSLActive, S.network, S.parent, S.httpAuth, S.callOpt, S.connectURL, S.connectionStatus, S.links, S.notes, S.favicon, S.lastFaviconUpdate, S.stagingFtpDetails, S.ftpDetails", $where, "siteID");
	}
	else{
		$sitesData = DB::getArray("?:sites", "siteID, URL, adminURL, name, IP, WPVersion, adminUsername, isOpenSSLActive, network, parent, httpAuth, callOpt, connectURL, connectionStatus, links, notes, favicon, lastFaviconUpdate, stagingFtpDetails, ftpDetails", "type = 'normal'  ORDER BY name", "siteID");
		$ua = DB::getArray("?:user_access", "*", "1");
		if(!empty($ua)){
			foreach($ua as $value){
				if(!empty($sitesData[$value['siteID']])){
					$sitesData[$value['siteID']]['managerIDs'][] = $value['userID'];
				}
			}
		}
	}
}

function multiUserHistoryHTML(&$where){
	if(userStatus() != "admin"){
		$where = "userID = ".$GLOBALS['userID']." AND " ;
	}
}

function multiUserAccess($siteIDs){
		$count = count($siteIDs);
		$where = array(
					'query' =>  "userID = ':userID' AND siteID IN (':siteID')",
					'params' => array(
						':userID' => $GLOBALS['userID'],
						':siteID' => implode(',', $siteIDs)
					)
			);
		$accessSitesCount = DB::getfield("?:user_access", "count(siteID)", $where );
		if($accessSitesCount == $count && $count > 0){
			return true;
		}		
		return false;
	}
        
function userRestrictChecking($userData='',$requestData=''){ // Checking the Rights of user
    
    $uPermissions=unserialize($userData['permissions']);   
    if(!empty($uPermissions['restrict']))
    {
        $Restrictions=$uPermissions['restrict'];
        $Actions=RestrictActionsGeneration($Restrictions);
    }
    if(array_key_exists('action',$requestData))
    {
        if($Actions!=null&&in_array($requestData['action'],$Actions))
        {
             addNotification($type='E', $title='Access Denied', $message='You dont have permission to do this action ', $state='U', $callbackOnClose='', $callbackReference='');
             return TRUE;
        }
        else
        {
            return FALSE;
        }
    }
     return FALSE;
    
}

function RestrictActionsGeneration($ResData){  // Create the list of restricted actions by user permissions 
    $ResArr=array();
    foreach($ResData as $key=>$value){
        switch ($value)
        {
            case 'updates':
                array_push($ResArr, 'updateAll', 'updateClient');
                break;
            case 'openAdmin':
                array_push($ResArr, 'loadSite');
                break;
            case 'addEditRemoveSite':
                array_push($ResArr, 'addSite', 'removeSite');
                break;
            case 'items':
                array_push($ResArr, 'installPlugins', 'installThemes', 'managePlugins', 'manageThemes');
                break;
            case 'createBackup':
                array_push($ResArr, 'backup');
                break;
            case 'restoreDeleteDownloadBackup':
                array_push($ResArr, 'restoreBackup', 'removeBackup');
                break;
        }
    }
    return $ResArr;
}

function multiUserHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('multiUser');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/multiUser/css/multi_user_styles.css')),
		array('js' => array('href' => 'addons/multiUser/js/functions.js')),
		array('js' => array('href' => 'addons/multiUser/js/init.js')),
		array('js' => array('href' => 'addons/multiUser/js/load.js')),
	);
	$headFiles['multiUser'] = $addonDetails;
}

function updateUserAccessOnSiteEdit($siteID,$managerIDs){
	if(!empty($siteID)){
		$where = array(
					'query' =>  "siteID = ':siteID'",
					'params' => array(
								':siteID'=>$siteID
								)
				);
		$success_dboperation = true;
		DB::delete("?:user_access", $where);
		DB::insert("?:user_access", array('userID' => $GLOBALS['userID'], 'siteID' => $siteID));
		if(is_array($managerIDs) && count($managerIDs) > 0){
			foreach($managerIDs as $key => $managerID){
				$addUserAccessSites = DB::insert("?:user_access", array('siteID' => $siteID, 'userID' => $managerID));
				if(!$addUserAccessSites){
					$success_dboperation = false;
				}
			}
		}
		return $success_dboperation;
	}
	return false;
}