<?php

/*
slug: scheduleBackup
version: 1.5.2
*/

class addonScheduleBackup{
	
	private static $version = '1.5.2';
	
	public static function version(){
		return self::version;	
	}
	
	public static function init(){	
		require_once(APP_ROOT."/addons/scheduleBackup/controllers/func.php");
		require_once(APP_ROOT."/addons/scheduleBackup/controllers/manageClientsScheduleBackup.php");	
		panelRequestManager::addFunctions('scheduleBackupPause', 'scheduleBackupEdit', 'scheduleBackupGetBackupsHTML', 'scheduleBackupCreate', 'scheduledBackupProcessEmailSetting', 'scheduledBackupGetEmailSetting');
		regHooks('responseProcessors', 'cronRun', 'taskTitleTemplate', 'removeSite', 'cronRequiredAlert', 'getNextSchedule', 'getSiteBackups', 'headHTMLFiles');
	}
	
	
	public static function install(){
		self::enableSBFailedEmailNotification();
		$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:backup_schedules` (
  `scheduleID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `userID` int(10) unsigned NOT NULL,
  `backupName` varchar(50) NOT NULL,
  `type` varchar(15) NOT NULL,
  `schedule` varchar(15) NOT NULL,
  `scheduleKey` varchar(255) NOT NULL DEFAULT '',
  `additionalDatas` text,
  `nextSchedule` bigint(20) unsigned DEFAULT NULL,
  `scheduleStatus` varchar(50) NOT NULL DEFAULT '',
  `lastRun` int(10) unsigned DEFAULT NULL,
  `paused` enum('0','1') NOT NULL DEFAULT '0',
  `what` varchar(25) NOT NULL DEFAULT '',
  `repository` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`scheduleID`)
)".DB::getSQLTableEnv().";");

	$Q2 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:backup_schedules_link` (
  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `siteID` int(10) unsigned NOT NULL,
  `scheduleID` int(10) unsigned DEFAULT NULL,
  `nextSchedule` bigint(20) DEFAULT NULL,
  `delayedTime` int(10) unsigned DEFAULT '1',
  `finalTime` bigint(20) DEFAULT NULL,
  `status` varchar(50) NOT NULL,
  PRIMARY KEY (`ID`)
)".DB::getSQLTableEnv().";");
		if($Q1 && $Q2){
			return true;	
		}
		return false;
	}

	
	public static function update(){
		
		if(version_compare(getOldAddonVersion('scheduleBackup'), '1.0.4', '<')){
			echo '<br><br><div style="font-weight:bold;">Please reschedule all your scheduled backups.</div>';
		}
		if(version_compare(getOldAddonVersion('scheduleBackup'), '1.3.0', '<')){
			$ok = true;
			$backupSchedules = DB::getArray("?:backup_schedules", "scheduleID, additionalDatas", "1");
			if(!empty($backupSchedules)){
				foreach($backupSchedules as $backupSchedule){
					$additionalDatas = unserialize($backupSchedule['additionalDatas']);
					$additionalDatas['mechanism'] = 'singleCall';
					$where = array(
					      		'query' =>   "scheduleID=':scheduleID'",
					      		'params' => array(
					               ':scheduleID'=>$backupSchedule['scheduleID']
		           				)
		        			);

					$isUpdated = DB::update("?:backup_schedules", array('additionalDatas' => serialize($additionalDatas)), $where);
					if(!$isUpdated) $ok = false;
				}
			}
			if(!$ok) return false;
		}
		if(version_compare(getOldAddonVersion('scheduleBackup'), '1.3.0beta3', '<')){
			DB::update("?:history", array('status' => 'error', 'error' => 'bugFix'), "type = 'scheduleBackup' AND action = 'runTask' AND status = 'multiCallWaiting'");//this where condition shouldn't hv occured, so fixing it, by marking it as error
		}
		if(version_compare(getOldAddonVersion('scheduleBackup'), '1.3.0beta5', '<')){
			
			$schedules = DB::getArray("?:backup_schedules", "additionalDatas, scheduleID", 1);
			
			if(!empty($schedules)){
			
				foreach($schedules as $key => $backupDatas){
				$isChange = false;
				
				$additionalDatas = unserialize($backupDatas['additionalDatas']);
				
				if(isset($additionalDatas['args']) && $additionalDatas['mechanism'] == 'undefined'){
					$additionalDatas['mechanism'] = "singleCall";
					$isChange = true;
				}
				if(!isset($additionalDatas['args'])){
					
					
					 $exclude = explode(',', $additionalDatas['exclude']);
					 $include = explode(',', $additionalDatas['include']);	
					 array_walk($exclude, 'trimValue');
					 array_walk($include, 'trimValue');
					 
					 $mechanism = ($additionalDatas['mechanism'] == 'undefined' || empty($additionalDatas['mechanism'])) ? 'singleCall' : $additionalDatas['mechanism'];
					 
					 $additionalDatas['args']['type'] = 'scheduleBackup';
					 $additionalDatas['args']['action'] = 'schedule';
					 
					 $additionalDatas['secure'] = array('account_info' => array($additionalDatas['accountInfo']['type'] => $additionalDatas['accountInfo']));
					 unset($additionalDatas['accountInfo']);
					 
					 $additionalDatas = array('task_name' => $additionalDatas['taskName'],'mechanism' => $mechanism, 'args' => array('type' => 'scheduleBackup', 'action' => 'schedule', 'what' => $additionalDatas['what'], 'optimize_tables' => $additionalDatas['optimizeDB'], 'exclude' => $exclude, 'include' => $include, 'del_host_file' => $additionalDatas['delHostFile'], 'disable_comp' => $additionalDatas['disableCompression'], 'fail_safe_db' => $additionalDatas['failSafeDB'], 'fail_safe_files' => $additionalDatas['failSafeFiles'], 'limit' => $additionalDatas['limit'], 'backup_name' => $additionalDatas['backupName']), 'secure' => $additionalDatas['secure']);
					 
					 $isChange = true;
					 
				}
				
				if($isChange){
					$where = array(
					      		'query' =>   "scheduleID=':scheduleID'",
					      		'params' => array(
					               ':scheduleID'=>$backupDatas['scheduleID']
		           				)
		        			);

					DB::update("?:backup_schedules", array('additionalDatas' => serialize($additionalDatas)), $where);
				}
			}
			
			}
		}
		
		if(version_compare(getOldAddonVersion('scheduleBackup'), '1.3.0', '<')){
			
			$schedules = DB::getArray("?:backup_schedules", "additionalDatas, scheduleID", 1);

			if(!empty($schedules)){

				foreach($schedules as $key => $backupDatas){
				
					$isChange = false;

					$additionalDatas = unserialize($backupDatas['additionalDatas']);
					
					if(!empty($additionalDatas['secure']['account_info']))
					{
						foreach($additionalDatas['secure']['account_info'] as $key => $value){
							if(empty($key) || empty($value))
							{
								$additionalDatas['secure']['account_info'] = null;
							}
							$isChange = true;
						}
					}
					
					if($isChange){
						$where = array(
						      		'query' =>   "scheduleID=':scheduleID'",
						      		'params' => array(
						               ':scheduleID'=>$backupDatas['scheduleID']
			           				)
			        			);

						DB::update("?:backup_schedules", array('additionalDatas' => serialize($additionalDatas)), $where);
					}
				}
			
			}
		}

		if(version_compare(getOldAddonVersion('scheduleBackup'), '1.4.0beta1', '<')){
			if(!DB::getExists("SHOW COLUMNS FROM `?:backup_schedules` WHERE Field = 'userID'")){
				$sql =  "ALTER TABLE `?:backup_schedules` ADD `userID` int(10) unsigned NOT NULL AFTER `scheduleID`";
				$isDone = DB::doQuery($sql);
				if (!$isDone) {
					die('<br>SQL Error: update failed.');
				}
			}
		}

		if(version_compare(getOldAddonVersion('scheduleBackup'), '1.4.0beta2', '<')){
			self::enableSBFailedEmailNotification();
		}
		if(version_compare(getOldAddonVersion('scheduleBackup'), '1.4.1beta1', '<')){
			$deleteFiles = array('/addons/scheduleBackup/initHTMLHead.php' => array('type' => 'f') );
			fileSystemRemoveFiles($deleteFiles);
		}
		return true;
	}

	public static function enableSBFailedEmailNotification(){
		$currentState = getOption('scheduledBackupEmailSetting');
		if ($currentState === false || $currentState === NULL) {
			updateOption('scheduledBackupEmailSetting', 1);
		}
	}
}



?>