<?php

function scheduleBackupGetNextSchedule(&$nextScheduleTime){

	$nextTime = DB::getField("?:backup_schedules", "MIN(nextSchedule)", "paused='0' ");
	if(!empty($nextTime)){
		$nextScheduleTime[] = $nextTime;
	}
}

function scheduleBackupCreate($datas){
	
	$result = manageClientsScheduleBackup::scheduleBackupProcessor($datas['siteIDs'], $datas['params']);
	
	if($result){
		return true;
	}
	
	return false;
}


function scheduledBackupProcessEmailSetting($params){
	$requiredData = array('0', '1');
	if (!in_array($params['emailSetting'], $requiredData)){
		return false;
	}
	scheduledBackupSaveEmailSetting($params['emailSetting']);
	return scheduledBackupGetEmailSetting();
}

function scheduledBackupSaveEmailSetting($data){
	updateOption('scheduledBackupEmailSetting', $data);
}

function scheduledBackupGetEmailSetting(){
	return getOption('scheduledBackupEmailSetting');
}

function scheduleBackupFailedNotify(){
	include_once(APP_ROOT.'/addons/scheduleBackup/controllers/scheduleBackupFailedNotification.php');
	new scheduleBackupFailedNotification();
}

function scheduleBackupCronRun(){
	$where = array(
	      		'query' =>  "nextSchedule <= ':time' AND paused='0'",
	      		'params' => array(
	               ':time'=>time()
				)
			);

	$settings = DB::getArray("?:backup_schedules", "*", $where);
	if(!empty($settings)){
		foreach($settings as $key => $value){
			$where = array(
			      		'query' =>  "scheduleID=':scheduleID'",
			      		'params' => array(
			               ':scheduleID'=>$value['scheduleID']
						)
					);
			$sites = DB::getFields("?:backup_schedules_link", "siteID", $where);
			if(empty($sites)){ continue; }
			
			//----------------------------------------------------decide a task need to run now or not---------------------------------------------------------
			$tempAdditionalDatas = unserialize($value['additionalDatas']);
			$mechanism = $tempAdditionalDatas['mechanism'];

			if(CRON_MODE == 'easyCronTask' && $mechanism == 'singleCall'){
				if(getSystemCronRunningFrequency() == 0){
					$mechanism = 'multiCall';
					addNotification($type='E', $title='Schedule Backup Method Changed', '<strong>'.$value['backupName'].'</strong> schedule task method has been temporarily changed to MultiCall because system cron was not trigger for last 90 mins.', $state='U');//FINALISE ERROR MESSAGE
				}
				else{
					continue;//systemCron is active, lets wait for it to trigger this singleCall Backup
				}
			}
			elseif(CRON_MODE == 'systemCronDefault' && $mechanism == 'multiCall'){
				if(!manageEasyCron::isActive()){
					$mechanism = 'singleCall';
					addNotification($type='E', $title='Schedule Backup Method Changed', '<strong>'.$value['backupName'].'</strong> schedule task method has been temporarily changed to old method because easyCron was not active.', $state='U');//FINALISE ERROR MESSAGE
				}
				else{
					continue;//easyCron is active, lets wait for it to trigger this multiCall Backup
				}
			}
			//----------------------------------------------------decide a task need to run now or not------------ENDS HERE-------------------------------
			
			$next = scheduleBackupScheduleNext($value['type'], $value['schedule']);	
			$where = array(
			      		'query' =>  "scheduleID=':scheduleID' AND scheduleKey = ':scheduleKey'",
			      		'params' => array(
			               ':scheduleID'=>$value['scheduleID'],
			               ':scheduleKey'=>$value['scheduleKey']
						)
					);
			DB::update("?:backup_schedules", array('nextSchedule' => $next), $where);
			
			$data = array(	'action' => 'scheduleBackupRunTask', 
							'args' => array(
								'params' => array('backupName' => $value['backupName'], 'scheduleKey' => $value['scheduleKey'], 'timeScheduled' => $value['nextSchedule'], 'scheduleType' => 'cron', 'mechanism' => $mechanism), 
								'siteIDs' => $sites
							)
						);
			panelRequestManager::handler($data);
		}
	}
}

function scheduleBackupPause($params){ //panelRequestManager
	if(empty($params)){
			return false;
	}
	else{
		$where = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey'=>$params['scheduleKey']
					)
				);
		DB::update("?:backup_schedules", array('paused' => $params['value']), $where);
	}
}

function scheduleBackupEdit($params){
	if(empty($params)){
		return false;
	}
	else{
		$data = array();
		$where = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey'=>$params['scheduleKey']
					)
				);
		$data['scheduleData'] = DB::getRow("?:backup_schedules", "scheduleID, backupName, type, schedule, scheduleKey, additionalDatas, paused, repository", $where);
		$data['scheduleData']['additionalDatas'] = unserialize($data['scheduleData']['additionalDatas']);
		if ($data['scheduleData']['additionalDatas']['mechanism'] == 'advancedBackup') {
			$data['scheduleData']['additionalDatas']['args']['exclude'] = $data['scheduleData']['additionalDatas']['args']['exclude'];
		}else{
			$data['scheduleData']['additionalDatas']['args']['exclude'] = @implode(',', $data['scheduleData']['additionalDatas']['args']['exclude']);
		}
		$data['scheduleData']['additionalDatas']['args']['include'] = @implode(',', $data['scheduleData']['additionalDatas']['args']['include']);
		$where = array(
      		'query' =>  "scheduleID=':scheduleID'",
      		'params' => array(
               ':scheduleID'=>$data['scheduleData']['scheduleID']
				)
		);
		$data['scheduleData']['siteName']['siteIDs'] = $siteIDs = DB::getFields("?:backup_schedules_link", "siteID", $where);
	
		if($data['scheduleData']['type'] == 'daily'){
			$data['scheduleData']['time'] = $data['scheduleData']['schedule'];
			unset($data['scheduleData']['schedule']);
		}
		
		if($data['scheduleData']['type'] == 'weekly' || $data['scheduleData']['type'] == 'monthly'){
			$a = explode("|", $data['scheduleData']['schedule']);
			$data['scheduleData']['time'] = $a[0];
			$data['scheduleData']['day'] = $a[1];
			unset($data['scheduleData']['schedule']);		
		}
		if ( $data['scheduleData']['type'] == 'fortnightly') {
			$scheduleDetails = explode("|", $data['scheduleData']['schedule']);
			$data['scheduleData']['time'] = $scheduleDetails[0];
			$data['scheduleData']['day1'] = $scheduleDetails[1];
			$data['scheduleData']['day2'] = $scheduleDetails[2];
			unset($data['scheduleData']['schedule']);
		}
				
		Reg::tplSet('sitesData', panelRequestManager::getSites());
        $sitesData = Reg::tplGet('sitesData'); 
		foreach($siteIDs as $siteID){
			$data['scheduleData']['siteName'][$siteID] = $sitesData[$siteID]['name'];
		}
	}
	return $data;
}

function scheduleBackupScheduleNext($type, $schedule){
	$schedule = explode("|", $schedule);
	if (empty($schedule))
		return false;
	switch ($type) {
		
		case 'daily':
			
			if (isset($schedule[1]) && $schedule[1]) {
				$delay_time = $schedule[1] * 60;
			}
			
			$current_hour  = date("H");
			$schedule_hour = $schedule[0];
			if ($current_hour >= $schedule_hour){
				$time = mktime($schedule_hour, 0, 0, date("m"), date("d") + 1, date("Y"));
			}
			else{
				$time = mktime($schedule_hour, 0, 0, date("m"), date("d"), date("Y"));
			}
					
			break;
		
		
		case 'weekly':
			if (isset($schedule[2]) && $schedule[2]) {
				$delay_time = $schedule[2] * 60;
			}
			$current_weekday  = date('w');
			$schedule_weekday = $schedule[1];
			$current_hour     = date("H");
			$schedule_hour    = $schedule[0];
			
			if ($current_weekday > $schedule_weekday)
				$weekday_offset = 7 - ($current_weekday - $schedule_weekday);
			else
				$weekday_offset = $schedule_weekday - $current_weekday;
			
			
			if (!$weekday_offset) { //today is scheduled weekday
				if ($current_hour >= $schedule_hour)
					$time = mktime($schedule_hour, 0, 0, date("m"), date("d") + 7, date("Y"));
				else
					$time = mktime($schedule_hour, 0, 0, date("m"), date("d"), date("Y"));
			} else {
				$time = mktime($schedule_hour, 0, 0, date("m"), date("d") + $weekday_offset, date("Y"));
			}
			
			break;
		
		case 'monthly':
			if (isset($schedule[2]) && $schedule[2]) {
				$delay_time = $schedule[2] * 60;
			}
			$current_monthday  = date('j');
			$schedule_monthday = $schedule[1];
			$current_hour      = date("H");
			$schedule_hour     = $schedule[0];
			
			if ($current_monthday > $schedule_monthday) {
				$time = mktime($schedule_hour, 0, 0, date("m") + 1, $schedule_monthday, date("Y"));
			} else if ($current_monthday < $schedule_monthday) {
				$time = mktime($schedule_hour, 0, 0, date("m"), $schedule_monthday, date("Y"));
			} else if ($current_monthday == $schedule_monthday) {
				if ($current_hour >= $schedule_hour)
					$time = mktime($schedule_hour, 0, 0, date("m") + 1, $schedule_monthday, date("Y"));
				else
					$time = mktime($schedule_hour, 0, 0, date("m"), $schedule_monthday, date("Y"));
				break;
			}
			
			break;
		case 'fortnightly':
			if ((isset($schedule[2]) && $schedule[2]) && (isset($schedule[3]) && $schedule[3])) {
				$delay_time = $schedule[2] * 60;
			}
			$currentDay  = date('j');
			$firstDay = $schedule[1];
			$secondDay = $schedule[2];
			$currentHour      = date("G");
			$scheduleHour     = $schedule[0];

			if(($currentDay > $firstDay) && ($currentDay >= $secondDay)){
				if ($currentDay == $secondDay && $currentHour < $scheduleHour)
					$time = mktime($scheduleHour, 0, 0, date("m"), $secondDay, date("Y"));
				else
					$time = mktime($scheduleHour, 0, 0, date("m") + 1, $firstDay, date("Y"));

			} elseif (($currentDay < $firstDay)) {
				$time = mktime($scheduleHour, 0, 0, date("m"), $firstDay, date("Y"));
			} elseif (($currentDay < $secondDay) || ($currentDay == $firstDay && $currentDay < $secondDay)) {
				if ($currentDay == $firstDay && $currentHour < $scheduleHour)
					$time = mktime($scheduleHour, 0, 0, date("m"), $firstDay, date("Y"));
				else
					$time = mktime($scheduleHour, 0, 0, date("m"), $secondDay, date("Y"));
			} 
			break;
		default:
			break;
	}
	
	if (isset($delay_time) && $delay_time) {
		$time += $delay_time;
	}
	
	return $time;
}


function scheduleBackupGetBackups($requiredSiteID = NULL){
	$schedules = DB::getArray("?:backup_schedules", "*","1 ORDER BY backupName");
	if(!empty($schedules)){						
		foreach($schedules as $key => $value){
			$where = array(
	      		'query' =>  "scheduleID=':scheduleID'",
	      		'params' => array(
	               ':scheduleID'=>$value['scheduleID']
					)
			);
			$sites = DB::getArray("?:backup_schedules_link", "siteID", $where);
			foreach($sites as $site){
				$sIDs[] = $site['siteID'];
			}
			$backupNames[] = $value['scheduleKey'];
		}
	}

		if (empty($requiredSiteID)) {
			if(!empty($sIDs))
			$siteIDs = array_unique($sIDs);
			$sitesStats = panelRequestManager::getRawSitesStats($siteIDs);
		} else{
			$sitesStats = panelRequestManager::getRawSitesStats(array($requiredSiteID));
		}

		$sitesBackups = array();
		$sitesBackupsNew = array();
			
		foreach($sitesStats as $siteID => $siteStats){

			if(!empty($backupNames))

			foreach($backupNames as $backupName){
				$where = array(
				      		'query' =>  "scheduleKey=':scheduleKey'",
				      		'params' => array(
				               ':scheduleKey'=>$backupName
							)
						);
				$sitesBackups[$backupName]['data'] = DB::getRow("?:backup_schedules", "*",$where);
				$where = array(
				      		'query' =>  "scheduleID=':scheduleID'",
				      		'params' => array(
				               ':scheduleID'=>$sitesBackups[$backupName]['data']['scheduleID']
							)
						);
				$sitesBackups[$backupName]['data']['count'] = $count= DB::getField("?:backup_schedules_link", "count(DISTINCT siteID)", $where);
				
				if(empty($siteStats['stats']['iwp_backups'][$backupName])) { 
					if (empty($siteStats['stats']['iwp_new_backups'][$backupName])) {
						continue;
					}
				 }
				if (!empty($siteStats['stats']['iwp_new_backups'])) {
					$siteBackupsTemp = $siteStats['stats']['iwp_new_backups'][$backupName];
					if (!empty($siteBackupsTemp)) {
						$siteBackups[$siteID] = array();
						foreach ($siteBackupsTemp as $referenceKey => $siteBackupTemp) {
							$otherParts = '';
							$newBackupMethod = true;
							$backupURLs  = false;
							if ($siteBackupTemp['service'][0] == 'ftp') {
								$otherParts = 'ftp';
								$repo = "FTP";
							}
							if ($siteBackupTemp['service'][0] == 's3') {
								$otherParts = 's3';
								$repo = "Amazon S3";
							}
							if ($siteBackupTemp['service'][0] == 'dropbox') {
								$otherParts = 'dropbox';
								$repo = "Dropbox";
							}
							if ($siteBackupTemp['service'][0] == 'googledrive') {
								$otherParts = 'googledrive';
								$repo = "G Drive";
							}
							if ($siteBackupTemp['service'][0] == 'sftp') {
								$otherParts = 'sftp';
								$repo = "SFTP";
							}
							if ($siteBackupTemp['service'][0] == 'none') {
								$otherParts = 'sftp';
								$repo = "Server";
								$backupContentURL = $siteBackupTemp['wp_content_url'].'/infinitewp/backups/';
								$backupURLs = getBackupURL($siteBackupTemp);
								foreach ($backupURLs as $k => $v) {
									$backupURLs[$k] = $backupContentURL.$v;
								}
								$backupURLs['backup_file_basename'] = $siteBackupTemp['wp_content_url'].'/infinitewp/backups/'.$siteBackupTemp['backup_file_basename'];
							}
							$fileURLParts = '';
							if (!empty($siteBackupTemp['plugins']) && !empty($siteBackupTemp['db'])) {
								$what = 'full';
								$size+= getSizeOfBackup($siteBackupTemp['plugins'], 'plugins', $siteBackupTemp);
								$size+= getSizeOfBackup($siteBackupTemp['themes'], 'themes', $siteBackupTemp);
								$size+= getSizeOfBackup($siteBackupTemp['uploads'], 'uploads', $siteBackupTemp);
								$size+= getSizeOfBackup($siteBackupTemp['more'], 'more', $siteBackupTemp);
								$size+= getSizeOfBackup($siteBackupTemp['others'], 'others', $siteBackupTemp);
								$size+= $siteBackupTemp['db-size'];
							}elseif (!empty($siteBackupTemp['db']) && empty($siteBackupTemp['plugins'])) {
								$what = 'db';
								$size = $siteBackupTemp['db-size'];
							}else{
								$what = 'files';
								$size+= getSizeOfBackup($siteBackupTemp['plugins'], 'plugins', $siteBackupTemp);
								$size+= getSizeOfBackup($siteBackupTemp['themes'], 'themes', $siteBackupTemp);
								$size+= getSizeOfBackup($siteBackupTemp['uploads'], 'uploads', $siteBackupTemp);
								$size+= getSizeOfBackup($siteBackupTemp['more'], 'more', $siteBackupTemp);
								$size+= getSizeOfBackup($siteBackupTemp['others'], 'others', $siteBackupTemp);
							}
							if (round($size / (1024*1024), 2) > 1) {
							    $size = round($size / (1024*1024), 2) . " MB";//Modified by IWP //Mb => MB
							} elseif(round($size / (1024), 2)>1) {
							    $size = round($size / (1024), 2) . ' KB';//Modified by IWP //Kb => KB
							}else{
								$size =  $size .' B';
							}
							$backupFileBasename = $siteBackupTemp['wp_content_path'].'/infinitewp/backups/'.$siteBackupTemp['backup_file_basename'];
							$sitesBackups[$backupName]['data']['repo'] = $repo;
							$sitesBackups[$backupName]['sites'][$siteID][$referenceKey] = array('backupName' 	=> $siteBackupTemp['backup_name'],
																								'sitesCount'	=> $count,
																								'backupFileBasename'	=> $backupFileBasename,
																								'what'			=> $what,
																								'time' 			=> $referenceKey,
																								'downloadURL' 	=> $backupURLs,
																								'size' 			=> $size,
																								'referenceKey' 	=> $referenceKey,
																								'newBackupMethod' 	=> $newBackupMethod,
																								'siteID' 		=> $siteID,
																								'task_name' 		=> $backupName,
																								'repo' 			=> $repo);
						}
					}

				}
				if (!empty($siteStats['stats']['iwp_backups'][$backupName])){
					$siteBackupsTemp = $siteStats['stats']['iwp_backups'][$backupName];
					$siteBackups[$siteID] = array();
					krsort( $siteBackupsTemp );
					
					foreach($siteBackupsTemp as $referenceKey => $siteBackupTemp){
						if(!empty($siteBackupTemp['error']) || isFailedBackup($siteBackupTemp) === true ){ continue; }

						$otherParts = '';
						if(empty($siteBackupTemp['server']['file_url']) && !empty($siteBackupTemp['ftp'])){
							$otherParts = $siteBackupTemp['ftp'];
						}
						if(empty($siteBackupTemp['server']['file_url']) && !empty($siteBackupTemp['amazons3'])){
							$otherParts = $siteBackupTemp['amazons3'];
						}
						if(empty($siteBackupTemp['server']['file_url']) && !empty($siteBackupTemp['dropbox'])){
							$otherParts = $siteBackupTemp['dropbox'];
						}
						if(empty($siteBackupTemp['server']['file_url']) && !empty($siteBackupTemp['gDriveOrgFileName'])){
							$otherParts = $siteBackupTemp['gDriveOrgFileName'];
						}
						
						if((is_array($siteBackupTemp['server']['file_url']))||(is_array($otherParts)))
						{
							$fileURLParts = explode('/', $siteBackupTemp['server']['file_url'][0] ? $siteBackupTemp['server']['file_url'][0] : $otherParts[0]);
						}
						else
						{
							$fileURLParts = explode('/', $siteBackupTemp['server']['file_url'] ? $siteBackupTemp['server']['file_url'] : $otherParts);
						}
						
						$fileName = array_pop($fileURLParts);
						$fileNameParts = explode('_', $fileName);
						$what = $fileNameParts[2];
						
						$repo = '';
						if(array_key_exists('server', $siteBackupTemp)){
							$repo = "Server";
						}
						if(array_key_exists('ftp', $siteBackupTemp)){
							$repo = "FTP";
						}
						if(array_key_exists('amazons3', $siteBackupTemp)){
							$repo = "Amazon S3";
						}
						if(array_key_exists('dropbox', $siteBackupTemp)){
							$repo = "Dropbox";
						}
						if(array_key_exists('gDriveOrgFileName', $siteBackupTemp)){
							$repo = "G Drive";
						}
						
						$sitesBackups[$backupName]['data']['repo'] = $repo;
						$sitesBackups[$backupName]['sites'][$siteID][$referenceKey] = array('backupName' 	=> $siteBackupTemp['backup_name'],
																							'sitesCount'	=> $count,
																							'what'			=> $what,
																							'time' 			=> $siteBackupTemp['time'],
																							'downloadURL' 	=> $siteBackupTemp['server']['file_url'],
																							'size' 			=> $siteBackupTemp['size'],
																							'referenceKey' 	=> $referenceKey,
																							'siteID' 		=> $siteID,
																							'task_name' 		=> $backupName,
																							'repo' 			=> $repo);
					}
				}
			}

		}
	return $sitesBackups;
}
	
function scheduleBackupGetBackupsHTML(){
	$scheduleBackups = scheduleBackupGetBackups();
	$HTML = TPL::get('/addons/scheduleBackup/templates/view.tpl.php', array('scheduleBackups' => $scheduleBackups));
	return $HTML;
}

function scheduleBackupResponseProcessors(&$responseProcessor){
	$responseProcessor['scheduleBackup']['schedule'] = 'scheduleBackup';
	$responseProcessor['scheduleBackup']['runTask'] = 'scheduleBackupRunTask';
	$responseProcessor['scheduleBackup']['multiCallRunTask'] = 'scheduleBackupRunTask';
	$responseProcessor['scheduleBackup']['deleteTask'] = 'scheduleBackupDeleteTask';
}

function scheduleBackupFailedNotification($historyID){
	//to show notification if it run by cron then offline notification	
	$where = array(
	      		'query' =>  "historyID=:historyID",
	      		'params' => array(
	               ':historyID'=>$historyID
				)
			);
	$HAD = DB::getRow("?:history_additional_data", "*", $where);
	if($HAD['status'] == 'error' || $HAD['status'] == 'netError'){
		$where2 = array(
      		'query' =>  "scheduleKey=':scheduleKey'",
      		'params' => array(
               ':scheduleKey'=>$HAD['uniqueName']
				)
		);
		$backupTask = DB::getRow("?:backup_schedules", "*", $where2);
		$siteID = DB::getField("?:history", "siteID", $where);
		$siteData = getSiteData($siteID, 'true');
		
		$hr = '';
		if($backupTask['schedule'] == 0){
			$hr = '12 am';
		}
		elseif($backupTask['schedule'] >= 12){
			if($backupTask['schedule'] > 12){
				$hr = ($backupTask['schedule'] - 11).' pm';
			}
			else{
				$hr = '12 pm';
			}
		}
		else{
			$hr = $backupTask['schedule'].' am';
		}
		
		$message = $backupTask['backupName'].' '.$backupTask['type'].' @'.$hr.' Error:'.$HAD['errorMsg'].' for '.$siteData['name'];
		addNotification($type='E', $title='Schedule Backup Failed', $message, $state='U', $callbackOnClose='', $callbackReference='');
	}
}

function scheduleBackupTaskTitleTemplate(&$template){
	$template['scheduleBackup']['schedule']['']	= "Schedule backup in <#sitesCount#> site<#sitesCountPlural#>";
	$template['scheduleBackup']['runTask']['']	= "Run backup schedule in <#sitesCount#> site<#sitesCountPlural#>";
	$template['scheduleBackup']['deleteTask']['']	= "Delete backup schedule with <#sitesCount#> site<#sitesCountPlural#>";
	$template['scheduleBackup']['multiCallRunTask'][''] = "Run backup schedule in <#sitesCount#> site<#sitesCountPlural#>";
}

function scheduleBackupRemoveSite($siteID){
	$where = array(
	      		'query' =>  "siteID=':siteID'",
	      		'params' => array(
	               ':siteID'=>$siteID
				)
			);
	$scheduleIDs = DB::getFields("?:backup_schedules_link", "scheduleID", $where);			
	DB::delete("?:backup_schedules_link", $where );
	
	if(!empty($scheduleIDs)){
		foreach($scheduleIDs as $scheduleID){
			$where = array(
			      		'query' =>  "scheduleID=':scheduleID'",
			      		'params' => array(
			               ':scheduleID'=>$scheduleID
						)
					);
			$scheduleIDExists = DB::getExists("?:backup_schedules_link", "scheduleID", $where);
			if(!$scheduleIDExists){
				DB::delete("?:backup_schedules", $where );
			}
		}
	}
}

function scheduleBackupCronRequiredAlert($requiredFor){
	$requiredFor[] = 'Schedule Backups';
}

function scheduleBackupGetSiteBackups(&$siteBackups, $siteID){
	$siteData = scheduleBackupGetBackups($siteID);
	if (!empty($siteData) && is_array($siteData)) {
		foreach ($siteData as  $backupsData) {
			if (!empty($backupsData['sites']) && is_array($backupsData['sites'])) {
				foreach ($backupsData['sites'] as  $scheduleBackupsData) {
					if (!empty($scheduleBackupsData) && is_array($scheduleBackupsData)) {
						foreach ($scheduleBackupsData as  $requiredBackupsData) {
							$siteBackups['scheduleBackups'][] = $requiredBackupsData;
						}
					}
				}
			}
		}
	}
	if(empty($siteBackups['scheduleBackups']) && !isset($siteBackups['scheduleBackups'])){
		$siteBackups['scheduleBackups'] = 'No backups';
	}
}

function scheduleBackupHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('scheduleBackup');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/scheduleBackup/css/scheduled_backups_styles.css')),
		array('js' => array('href' => 'addons/scheduleBackup/js/functions.js')),
		array('js' => array('href' => 'addons/scheduleBackup/js/load.js')),
		array('js' => array('href' => 'addons/scheduleBackup/js/init.js')),
	);
	$headFiles['scheduleBackup'] = $addonDetails;
	$GLOBALS['scheduledBackupEmailSetting'] =  panelRequestManager::requiredData(array('scheduledBackupGetEmailSetting' => 1));
	?>
	<script>
	var scheduledBackupEmailSetting = <?php echo empty($GLOBALS['scheduledBackupEmailSetting']['scheduledBackupGetEmailSetting']) ? '0' : $GLOBALS['scheduledBackupEmailSetting']['scheduledBackupGetEmailSetting']; ?>;
	</script>
	 <?php
}