<?php
class manageClientsScheduleBackup{
	
	public static function scheduleBackupProcessor($siteIDs, $params){
		$accountInfo = array('account_info' => $params['accountInfo']);
		if((!empty($accountInfo['account_info']['iwp_gdrive'])))
		{
			//$accountInfo['account_info']['iwp_gdrive']['gDriveEmail'] = unserialize(getOption('googleDriveAccessToken'));
			$repoID = $accountInfo['account_info']['iwp_gdrive']['gDriveEmail'];
			if(function_exists('backupRepositorySetGoogleDriveArgs')){
				$accountInfo['account_info']['iwp_gdrive'] = backupRepositorySetGoogleDriveArgs($accountInfo['account_info']['iwp_gdrive']);
			}else{
				addNotification($type='E', $title='Cloud backup Addon Missing', $message="Check if cloud backup addon exists and is active", $state='U', $callbackOnClose='', $callbackReference='');
				return false;
			}
		}
		$config = $params['config'];
	
		if($config['mechanism'] == 'undefined'){ $config['mechanism'] = 'singleCall'; }
		
		self::scheduleBackup($siteIDs, array('accountInfo' => $accountInfo, 'config' => $config, 'scheduleKey' => $params['schedulekey'], 'action' => 'schedule') );
		
	}
		
	  private static function scheduleBackup($siteIDs, $params){
		  $accountInfo = $params['accountInfo'];
		  $config = $params['config'];
		  $scheduleKey = $params['scheduleKey'];
		  $timeout = (20 * 60);
		  
		  $type = "scheduleBackup";
		  $action = $params['action'];
		  $requestAction = "scheduled_backup";
	  	  if ($params['config']['mechanism'] == 'advancedBackup') {
		  	$requestAction = "new_scheduled_backup";
	  	  }
		  
		  //$config['taskName'] = $config['backupName'];
		  foreach($params['accountInfo'] as $accInfo => $info){
			  if(!empty($info) && is_array($info)){
				  foreach($info as $accType => $infotype){
					  $info = $infotype;
					  $info['type'] = $accType;
				  }
			  }
		  }
		  if ($params['config']['mechanism'] == 'advancedBackup') {
		  	$exclude = $config['exclude'];
		  }else{
		  	$exclude = explode(',', $config['exclude']);	
		  }
		  $include = explode(',', $config['include']);	
		  // array_walk($exclude, 'trimValue');
		  array_walk($include, 'trimValue');
		
		
		  $additionalDatas = array('task_name' => $config['taskName'],'mechanism' => $config['mechanism'], 'args' => array('type' => $type, 'action' => $action, 'what' => $config['what'], 'optimize_tables' => $config['optimizeDB'], 'exclude' => $exclude, 'exclude_file_size' => (int)$config['excludeFileSize'], 'exclude_extensions' => $config['excludeExtensions'], 'include' => $include, 'del_host_file' => $config['delHostFile'], 'disable_comp' => $config['disableCompression'], 'fail_safe_db' => $config['failSafeDB'], 'fail_safe_files' => $config['failSafeFiles'], 'limit' => $config['limit'], 'backup_name' => $config['backupName']), 'secure' => $accountInfo);
			
			// The following lines are used for client side activities log
			if(isset($config['backup_repo_type'])) {
				$requestParams['args']['backup_repo_type'] = $config['backup_repo_type'];
			}			
			if(isset($config['type'])) {
				$requestParams['args']['when'] = $config['type'];
			}
			if(isset($config['scheduleHR'])) {
				$requestParams['args']['at'] = $config['scheduleHR'];
			}		  
			// The above lines are used for client side activities log
			
		  $additionalDatas = serialize($additionalDatas);
		   
		   if(empty($scheduleKey)){
			    $scheduleID = DB::insert("?:backup_schedules", array("userID" => $GLOBALS['userID'], "backupName" => $config['backupName'], "type" => $config['type'], "schedule" => $config['scheduleHR'], "what" => $config['what'], "additionalDatas" => $additionalDatas));
			    $key = md5($scheduleID.$siteID.microtime()); 
			    $where = array(
				      		'query' =>  "scheduleID=':scheduleID'",
				      		'params' => array(
				               ':scheduleID'=>$scheduleID
							)
						);
				DB::update("?:backup_schedules", "scheduleKey = '".$key."'", $where);
		   }
		   
		   if(!empty($scheduleKey)){
		   		$where = array(
				      		'query' =>  "scheduleKey=':scheduleKey'",
				      		'params' => array(
				               ':scheduleKey'=>$scheduleKey
							)
						);
			   $scheduleID = DB::getField("?:backup_schedules", "scheduleID", $where);
			   DB::update("?:backup_schedules", array("userID" => $GLOBALS['userID'], "backupName" => $config['backupName'], "type" => $config['type'], "schedule" => $config['scheduleHR'], "what" => $config['what'], "additionalDatas" => $additionalDatas), $where);
			   $key = $scheduleKey;	
			   $where = array(
				      		'query' =>  "scheduleID=':scheduleID'",
				      		'params' => array(
				               ':scheduleID'=>$scheduleID
							)
						); 
			   DB::delete("?:backup_schedules_link", $where);
		   }
			
			$nextSchedule = scheduleBackupScheduleNext($config['type'], $config['scheduleHR']);
			$where = array(
			      		'query' =>   "scheduleKey=':scheduleKey'",
			      		'params' => array(
			               ':scheduleKey'=>$key
           				)
        			);

			DB::update("?:backup_schedules", array('scheduleStatus'=>'scheduled' ,'nextSchedule'=>$nextSchedule), $where);
			
			foreach($siteIDs as $siteID){			
				$scheduled = DB::insert("?:backup_schedules_link", array('siteID' => $siteID ,'scheduleID'=>$scheduleID ,'nextSchedule'=>$nextSchedule, 'status'=>'scheduled'));
			}

			return $scheduled;
	}
	
	public static function scheduleBackupResponseProcessor($historyID, $responseData){
		
		responseDirectErrorHandler($historyID, $responseData);
		
		if(empty($responseData['success'])){
			return false;
		}
		$where = array(
		      		'query' =>  "historyID=:historyID",
		      		'params' => array(
		               ':historyID'=>$historyID
					)
				);
		if(!empty($responseData['success']['error'])){
			DB::update("?:history_additional_data", "status='error' ,errorMsg = '".$responseData['success']['error']."'", $where);	
			return false;
		}
		
		$args = $responseData['success']['task_args'];
		$historyData = DB::getRow("?:history", "*", $where);
		$siteID = DB::getField("?:history", "siteID", $where);
		$where2 = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey'=>$args['key']
					)
				);
		$scheduleData = DB::getRow("?:backup_schedules", "*", $where2);
								
		if(!empty($args) && $historyData['action'] == 'schedule' && !empty($scheduleData)){
			DB::update("?:history_additional_data", "status='success'", $where);
			
			if($scheduleData['scheduleKey'] == $args['key']){
				$nextSchedule = scheduleBackupScheduleNext($args['type'], $args['schedule']);
				
				DB::update("?:backup_schedules", array('scheduleStatus'=>'scheduled' ,'nextSchedule'=>$nextSchedule), $where2);			
				DB::insert("?:backup_schedules_link", array('siteID'=>$args['site_id'] ,'scheduleID'=>$scheduleData['scheduleID'] ,'nextSchedule'=>$nextSchedule, 'status'=>'scheduled'));
			}
		}
		
		//---------------------------post process------------------------>
			
		$allParams = array('action' => 'getStats', 'args' => array('siteIDs' => array($siteID), 'extras' => array('sendAfterAllLoad' => false, 'doNotShowUser' => true)));		
		panelRequestManager::handler($allParams);
	}	
	
	public static function scheduleBackupRunTaskProcessor($siteIDs=array(), $params){
		$type = "scheduleBackup";
		
		$requestAction = "run_task";
		$timeout = (20 * 60);
		$where = array(
		      		'query' =>  "BL.scheduleID=BS.scheduleID AND scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey'=>$params['scheduleKey']
					)
				);
		$siteIDs = DB::getFields("?:backup_schedules as BS, ?:backup_schedules_link as BL", "BL.siteID", $where);
		$where = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey'=>$params['scheduleKey']
					)
				);
		$additionalDatas = DB::getField("?:backup_schedules", "additionalDatas", $where);
				
		$requestParams = unserialize($additionalDatas);
		$requestParams['task_name'] = $params['scheduleKey'];
		
		$requestParams['mechanism'] = (!empty($params['mechanism']) ? $params['mechanism'] : $requestParams['mechanism']);
		$action = ($requestParams['mechanism'] == 'multiCall' || $requestParams['mechanism'] == 'advancedBackup') ? "multiCallRunTask" : "runTask";
		if ($requestParams['mechanism'] == 'advancedBackup') {
			$requestAction = "new_run_task";
		}
		if($action == "multiCallRunTask")
		{
			$timeout = (1 * 60);
			//this function set the multicall options value from config.php if available
			setMultiCallOptions($requestParams);
		}
		if ($requestParams['mechanism'] == 'advancedBackup') {
			$requestParams['backup_nounce'] = backup_time_nonce();
		}
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => $params['scheduleKey'], 'detailedAction' => $action);
		
		$incTime = 10 * 60;//10 mins		
		$i = 0;
		$lastHistoryID = '';
		if(empty($params['timeScheduled'])){ $params['timeScheduled'] = time(); }
		foreach($siteIDs as $siteID){
			$siteData = getSiteData($siteID);
			
			$events=1;
			
			$PRP = array();
			$PRP['requestAction'] 	= $requestAction;
			$PRP['requestParams'] 	= $requestParams;
			$PRP['siteData'] 		= $siteData;
			$PRP['type'] 			= $type;
			$PRP['action'] 			= $action;
			$PRP['events'] 			= $events;
			$PRP['historyAdditionalData'] 	= $historyAdditionalData;
			$PRP['timeout'] 		= $timeout;
			$PRP['status'] 			= 'pending';
			$PRP['notifyFailed']	= 'pending';
			

			$PRP['timeScheduled'] = $params['timeScheduled'];
			
						
			if($lastHistoryID){
				$runCondition = 	array();
				$runCondition['satisfyType'] = 'OR';
				$runCondition['query'] = array('table' => "history_additional_data", 'select' => 'historyID', 'where' => "historyID = ".$lastHistoryID." AND status IN('success', 'error', 'netError')");
				//$runCondition['maxWaitTime'] = $params['timeScheduled'] + $incTime * $i;
				$PRP['runCondition'] = serialize($runCondition);
				$PRP['status'] = 'scheduled';
			}
				
			$lastHistoryID = prepareRequestAndAddHistory($PRP);
			$i++;
		}
	}
	
	public static function scheduleBackupRunTaskResponseProcessor($historyID, $responseData){
		
		responseDirectErrorHandler($historyID, $responseData);
		
		if(empty($responseData['success'])){
			return false;
		}
		$where = array(
		      		'query' =>  "historyID=:historyID",
		      		'params' => array(
		               ':historyID'=>$historyID
					)
				);
		$historyData = DB::getRow("?:history", "*", $where);
		$siteID = $historyData['siteID'];
		
		if(!empty($responseData['success']['error']) && is_string($responseData['success']['error'])){		
			DB::update("?:history_additional_data", array('status' => 'error', 'errorMsg' => $responseData['success']['error']), $where);	
			return false;
		}
		
		else{
			if($historyData['type'] == 'scheduleBackup' && $historyData['action'] == 'multiCallRunTask'){
				$historyResponseStatus[$historyID] = "multiCallWaiting";
				Reg::set("historyResponseStatus", $historyResponseStatus);
				
				updateHistory(array('status' => "multiCallWaiting"), $historyID);
				if (!empty($responseData['success']['wp_content_url'])) {
					$wp_content_url = $responseData['success']['wp_content_url'];
					$log = $responseData['success']['backup_id'];
					DB::update("?:history_additional_data", array('successMsg' => "<a class='view_on_site' href='".rtrim($wp_content_url,'/')."/infinitewp/backups/log.".$log.".txt' target='_blank' > View log</a>"), $where);
				}
				manageClientsBackup::triggerRecheck($responseData, $siteID);
				
			}else{
			
				DB::update("?:history_additional_data", array('status' => 'success'), $where);

				//---------------------------post process------------------------>
				$siteID = DB::getField("?:history", "siteID", $where);
			
				$allParams = array('action' => 'getStats', 'args' => array('siteIDs' => array($siteID), 'extras' => array('sendAfterAllLoad' => false, 'doNotShowUser' => true)));
				
				panelRequestManager::handler($allParams);
			}
		}	
	}
	public static function scheduleBackupRunTaskPreProcessor($historyID){
		$where = array(
			'query' =>  "historyID = ':historyID'",
			'params' => array(
				':historyID' => $historyID
			)
		);
		$siteDetails = DB::getArray("?:history", "siteID, timeScheduled", $where);
		$currentScheduleKey = DB::getField("?:history_additional_data", "uniqueName", $where);
		include_once(APP_ROOT.'/addons/scheduleBackup/controllers/scheduleBackupPreCheck.php');
		$scheduleBackupPreCheck = new scheduleBackupPreCheck();
		$runningDetails = $scheduleBackupPreCheck->runningBackupsBySiteID($siteDetails[0]['siteID'], $historyID);

		$isManualBackupRunning   = !empty($runningDetails['manualRunningCount']);
		$isScheduleBackupRunning = !empty($runningDetails['scheduleRunningCount']);
		$isScheduleBackupWaiting = !empty($runningDetails['scheduleWaitingCount']);
		$scheduleWaitingPriorityID = $runningDetails['scheduleWaitingPriorityID'];
		$scheduleWaitingData = $runningDetails['scheduleWaitingData'];

		if(!$isManualBackupRunning && !$isScheduleBackupRunning && !$isScheduleBackupWaiting){
			return $scheduleBackupPreCheck->initiateScheduleBackup($historyID);
		}
		if($isManualBackupRunning){
			return  $scheduleBackupPreCheck->postponeCurrentScheduleBackup($historyID);
		}

		if($isScheduleBackupRunning || $isScheduleBackupWaiting){
			$isAnotherBackupScheduledInSameSchedule = $anotherBackupHistoryIDs =  $scheduleBackupPreCheck->getAnotherBackupScheduledInSameScheduleKey($scheduleWaitingData, $currentScheduleKey);
			if(!empty($isAnotherBackupScheduledInSameSchedule) && is_array($isAnotherBackupScheduledInSameSchedule)){
				return  $scheduleBackupPreCheck->killOldAndPostPoneCurrentScheduleBackup($anotherBackupHistoryIDs, $historyID);
			}

			if ($isScheduleBackupRunning) {
				return  $scheduleBackupPreCheck->postponeCurrentScheduleBackup($historyID);
			}

			if ($isScheduleBackupWaiting) {
				return $scheduleBackupPreCheck->initiateScheduleBackup($scheduleWaitingPriorityID, $historyID);
			}

		}

	}
	
	public static function scheduleBackupDeleteTaskProcessor($siteIDs=array(), $params){
		
		$type = "scheduleBackup";
		$action = "deleteTask";
		if ($params['isNewBackup']) {
			$requestAction = "delete_backup_new";
		}else{
			$requestAction = "delete_schedule_task";
		}
		$timeout = (20 * 60);
		$where = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey'=>$params['scheduleKey']
					)
				);
		$schedule = DB::getRow("?:backup_schedules", "scheduleID,backupName", $where);
		$where1 = array(
		      		'query' =>  "scheduleID=':scheduleID'",
		      		'params' => array(
		               ':scheduleID'=>$schedule['scheduleID']
					)
				);
		$sites = DB::getArray("?:backup_schedules_link", "siteID", $where1);
		
		$requestParams = array('task_name' => $params['scheduleKey']);
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => $schedule['backupName'], 'detailedAction' => $action);
		
		//if(empty($sites)){
			$scheduleID = DB::getField("?:backup_schedules", "scheduleID", $where);
			DB::delete("?:backup_schedules_link", $where1);
			DB::delete("?:backup_schedules", $where);
		//}
		
		foreach($sites as $site){
			$sIDs[] = $site['siteID'];
		}
		
		foreach($sIDs as $siteID){
			$siteData = getSiteData($siteID);		
			
			$events=1;
			
			$PRP = array();
			$PRP['requestAction'] 	= $requestAction;
			$PRP['requestParams'] 	= $requestParams;
			$PRP['siteData'] 		= $siteData;
			$PRP['type'] 			= $type;
			$PRP['action'] 			= $action;
			$PRP['events'] 			= $events;
			$PRP['historyAdditionalData'] 	= $historyAdditionalData;
			$PRP['timeout'] 		= $timeout;
			
			if($params['scheduleType'] == 'cron'){
				$PRP['scheduleTime'] 		= $params['scheduleTime'];
			}
				
			prepareRequestAndAddHistory($PRP);
		}
	}
	
	public static function scheduleBackupDeleteTaskResponseProcessor($historyID, $responseData){
		$where = array(
		      		'query' =>  "historyID=:historyID",
		      		'params' => array(
		               ':historyID'=>$historyID
					)
				);
		if(!empty($responseData['error'])){
			DB::update("?:history_additional_data", "status='error' ,errorMsg = '".$responseData['success']['error']."'", $where);	
		}
		
		if(!empty($responseData['success'])){
			DB::update("?:history_additional_data", "status='success'", $where);
			$where2 = array(
			      		'query' =>  "scheduleKey=':scheduleKey'",
			      		'params' => array(
			               ':scheduleKey'=>$responseData['success']
						)
					);
			$scheduleID = DB::getField("?:backup_schedules", "scheduleID", $where2);
			$where3 = array(
			      		'query' =>  "scheduleID=:scheduleID",
			      		'params' => array(
			               ':scheduleID'=>$scheduleID
						)
					);
			DB::delete("?:backup_schedules_link", $where3);
			DB::delete("?:backup_schedules", $where2);
		}
		//---------------------------post process------------------------>
		$siteID = DB::getField("?:history", "siteID", $where);	
		$allParams = array('action' => 'getStats', 'args' => array('siteIDs' => array($siteID), 'extras' => array('sendAfterAllLoad' => false, 'doNotShowUser' => true)));		
		panelRequestManager::handler($allParams);
	}	
}

manageClients::addClass('manageClientsScheduleBackup');
?>