<?php

function stagingResponseProcessors(&$responseProcessor){
	$responseProcessor['staging']['newSite'] = 'installCloneCommonNewSite';
	$responseProcessor['staging']['existingSite'] = 'stagingInstallCloneExistingSite'; 
	$responseProcessor['staging']['installCloneBackupNow'] = 'installCloneBackupNow'; 
	$responseProcessor['staging']['testConnection'] = 'installCloneCommonNewSite';
	$responseProcessor['installClone']['bridgeExtractMulticall'] = 'bridgeExtractMulticall';
	$responseProcessor['staging']['deleteSite'] = 'stagingDeleteSite';
}

function stagingTaskTitleTemplate(&$template){
	$template['staging']['newSite'][''] = "Stage 1 site";
	$template['staging']['installCloneBackupNow'][''] = "Backup 1 site for staging";
	$template['staging']['deleteSite'][''] = "Delete 1 Staging site";
}

function stagingGetICTestConnectionResult(){
	$actionID = Reg::get('currentRequest.actionID');
	$where = array(
			'query' =>   "type='getICTestConnection' AND paramID=':actionID'",
			'params' => array(
				':actionID' => $actionID,
			)
		);
	$datas = DB::getFields("?:temp_storage", "data", $where);
	DB::delete("?:temp_storage", $where);
	
	if(empty($datas)){
		return array();
	}

	$returnArray = unserialize($datas[0]);
	return $returnArray;
}

function stagingSaveMainStagingFtpDetails($params){
	if(empty($params)){
		return false;
	}
	$updateResult = updateOption("mainStagingFtpDetails", serialize($params));
	return $updateResult;
}

function saveStagingFtpDetails($params){
	if(empty($params)){
		return false;
	}
	foreach($params as $k => $v){
		if(!empty($v['siteID'])){
			$siteData = array("stagingFtpDetails" => serialize($params));
			$where = array(
				'query' =>   "siteID=':siteID'",
					'params' => array(
						':siteID' => $v['siteID'],
					)
				);
			$updateResult = DB::update("?:sites", $siteData, $where);
		}
	}
	return $updateResult;
}

function stagingGetMainStagingFtpDetails(){
	$getResult = getOption("mainStagingFtpDetails");
	if($getResult === false){
		return $getResult;
	}
	return unserialize($getResult);
}

function stagingGetStagingFtpDetails($params){
	if(empty($params['siteID'])){
		return false;
	}
	$where = array(
		'query' =>   "siteID=':siteID'",
			'params' => array(
				':siteID' => $params['siteID'],
			)
		);
	$getResult = DB::getRow("?:sites", "stagingFtpDetails", $where);
	if($getResult === false){
		return $getResult;
	}
	return unserialize($getResult['stagingFtpDetails']);
}

function stagingPostAddStagingSite($siteID, $historyID){
	$where = array(
		'query' =>   "historyID=':historyID'",
			'params' => array(
				':historyID' => $historyID,
			)
		);
	$thisHistoryData = DB::getRow("?:history", "parentHistoryID", $where);
	$parentHisID = $thisHistoryData['parentHistoryID'];
	$parentHisIDWhere = array(
		'query' =>   "historyID=':historyID'",
			'params' => array(
				':historyID' => $parentHisID,
			)
		);
	$parentHistoryReqData = DB::getRow("?:history_raw_details", "panelRequest", $parentHisIDWhere);
	$parentHistoryReqData = unserialize($parentHistoryReqData['panelRequest']);
	if (!empty($parentHistoryReqData['args']['params']['isFromBackup'])) {
		$where = array(
		'query' =>   "siteID=':siteID'",
			'params' => array(
				':siteID' => $siteID,
			)
		);
		DB::update('?:sites', array('stagingBaseSiteID'=>$parentHistoryReqData['args']['params']['siteID']), $where);
	}else{
		$baseParentHisID =  DB::getField("?:history", "parentHistoryID", $parentHisIDWhere);
		stagingMapParentSiteToStagingSite($baseParentHisID, $siteID);
		$parentHisIDWhere = array(
			'query' =>   "historyID=':historyID'",
				'params' => array(
					':historyID' => $baseParentHisID,
				)
			);
		$parentHistoryReqData = DB::getRow("?:history_raw_details", "panelRequest", $parentHisIDWhere);
		$parentHistoryReqData = unserialize($parentHistoryReqData['panelRequest']);
	}
	if(!empty($parentHistoryReqData['args']['params']['toBeUpdated'])){
		$toBeUpdatedData = $parentHistoryReqData['args']['params']['toBeUpdated'];
		
		$oldSiteUpdateData = $toBeUpdatedData['args']['params'];
		unset($toBeUpdatedData['args']['params']);
		$newSiteUpdateData = array();
		
		foreach($oldSiteUpdateData as $key => $value){
			$newSiteUpdateData[$siteID] = $value;
		}
		$parentActionID = DB::getField('?:history', 'actionID', $parentHisIDWhere);
		$newSiteUpdateData[$siteID]['parentActionID'] = $parentActionID;
		$newSiteUpdateData[$siteID]['parentHistoryID'] = $parentHisID;
		$toBeUpdatedData['args']['params'] = $newSiteUpdateData;
		
		panelRequestManager::handler($toBeUpdatedData);
	} else if(!empty($parentHistoryReqData) && !empty($parentHistoryReqData['args']['params']['isStaging'])){
		//manageClientsSites::removeSiteProcessor(array( 0 => $siteID), array('iwpPluginDeactivate' => 1, 'doNotShowUser' => true));
	}
}

function stagingPostReaddStagingSite($siteID, $historyID){
	stagingPostAddStagingSite($siteID, $historyID);
}

function stagingProcessUpdateInStagingSwitchSettings($params){
	$requiredData = array('0', '1');
	if (!in_array($params['activeStatus'], $requiredData)){
		return false;
	}
	stagingSaveUpdateInStagingSwitchSettings($params['activeStatus']);
	return stagingGetUpdateInStagingSwitchSettings();
}

function stagingSaveUpdateInStagingSwitchSettings($status){
	updateOption('updateInStagingSwitchSettings', $status);
}
function stagingGetUpdateInStagingSwitchSettings(){
	return getOption('updateInStagingSwitchSettings');
}
function stagingGetStagingBaseIDs(){
	$sitesData = DB::getArray("?:sites", "siteID,stagingBaseSiteID,URL", "type = 'staging'", "stagingBaseSiteID");
	return $sitesData;
}
function stagingUpdateInExistingStaging($updateDetails){
	$siteID = key($updateDetails['updateItems']);
	$stagingDetails = stagingGetStagingFtpDetails(array('siteID'=> $siteID));
	foreach ($stagingDetails as $key => $value) {
		$newURL = addTrailingSlash($stagingDetails[$key]['newSiteURL']);
	}
	$where = array(
		'query' =>   "URL=':URL'",
			'params' => array(
				':URL' => $newURL,
			)
		);
	$stagingSiteID = DB::getField("?:sites", "siteID", $where);
	$finalUpdateDetails[$stagingSiteID] = $updateDetails['updateItems'][$siteID];
	$result['stagingSite'] = $finalUpdateDetails;
	$result['mainSite'] = $updateDetails['updateItems'];
	$result['stagingSiteID'] = $stagingSiteID;
	return $result;
}

function stagingHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('staging');
	$allAddons = Reg::get('addonDetails');
	if (!empty($allAddons['installClone']['isLoaded'])) {
		$addonDetails['files'] = array(
			array('css' => array('href' => 'addons/staging/css/staging_styles.css')),
			array('js' => array('href' => 'addons/staging/js/load.js')),
			array('js' => array('href' => 'addons/staging/js/init.js')),
			array('js' => array('href' => 'addons/staging/js/functions.js')),
		);
	} else {
			$addonDetails['files'] = array(
			array('css' => array('href' => 'addons/staging/css/staging_styles.css')),
			array('js' => array('href' => 'addons/staging/js/load.js')),
			array('js' => array('href' => 'addons/staging/js/init.js')),
			array('js' => array('href' => 'addons/staging/js/functions.js')),
		);
	}

	$headFiles['staging'] = $addonDetails;
	$stagingUpdateInStagingSetting =  panelRequestManager::requiredData(array("stagingGetUpdateInStagingSwitchSettings"=>1));
	$stagingSites =  panelRequestManager::requiredData(array("stagingGetStagingBaseIDs"=>1));
	$stagingSites = jsonEncoder($stagingSites['stagingGetStagingBaseIDs']);
	
 ?>
 <script>
 var stagingUpdateInStagingSetting = <?php echo empty($stagingUpdateInStagingSetting['stagingGetUpdateInStagingSwitchSettings']) ? '0' : $stagingUpdateInStagingSetting['stagingGetUpdateInStagingSwitchSettings']; ?>;
 var stagingSites = <?php echo $stagingSites; ?>;
 </script>
 <?php }

function stagingGetStagingSiteData($stagingSiteID){
  	if (is_array($stagingSiteID)) {
		$where = "siteID IN (". implode(', ', DB::esc($stagingSiteID)) .")";
  	}else{
 		$where = array(
		      		'query' =>  "siteID=':siteID'",
			      	'params' => array(
		               ':siteID'=>$stagingSiteID
					)
				);
  	}
	$parentSiteDetails = DB::getArray("?:sites", "*", $where, 'siteID');

	if (empty($parentSiteDetails)) {
		return false;
	}
	foreach ($parentSiteDetails as $key => $data) {
		$parentSiteID = $data['stagingBaseSiteID'];
	}
	$where = array(

	      		'query' =>  "UA.userID =':userID' AND  UA.siteID IN (:siteID) AND S.siteID=UA.siteID",

	      		'params' => array(

	               ':userID'=>$GLOBALS['userID'],

	               ':siteID'=>$parentSiteID

					)

			);

	$result = DB::getRow("?:user_access UA, ?:sites S", "S.*, UA.siteID", $where);
	if (!$result) {
		return false;
	}
	return $parentSiteDetails;

 }
  function stagingMapParentSiteToStagingSite($parentHistoryID, $siteID){
 	$where = array(
		'query' =>   "historyID=':historyID'",
			'params' => array(
				':historyID' => $parentHistoryID,
			)
		);
	$parentSiteID =  DB::getField("?:history", "siteID", $where);
	$where = array(
		'query' =>   "siteID=':siteID'",
			'params' => array(
				':siteID' => $siteID,
			)
		);
	DB::update('?:sites', "stagingBaseSiteID='".$parentSiteID."'", $where);

 }
function stagingGetStagingSiteID($baseSiteID){
	$where = array(
		'query' =>   "stagingBaseSiteID=':stagingBaseSiteID'",
			'params' => array(
				':stagingBaseSiteID' => $baseSiteID,
			)
		);
	$stagingSiteID = DB::getField('?:sites', 'siteID', $where);
	return $stagingSiteID;
}

function stagingSaveExistingStaging($params){
	if (!empty($params)) {
		$params['createdTime'] = time();
	}
	saveStagingFtpDetails(array('stagingCustomServer' => $params));
}

function stagingRemoveSite($siteID){
	$baseSiteID = stagingGetStagingSiteID($siteID);
	$where = array(
		      		'query' =>  "siteID = ':siteID'",
		      		'params' => array(
		               ':siteID'=>$baseSiteID
       				)
    			);
	DB::delete("?:sites", $where);
	DB::delete("?:site_stats", $where );
}

function stagingBackupList($siteID){
	$sitesBackups = panelRequestManager::getSitesBackups($siteID, true);
	$HTML = TPL::get('/addons/staging/templates/stagingBackupSelectionView.tpl.php', array('siteBackups' => reset($sitesBackups), 'siteID' => $siteID[0]));
	return $HTML;
}