<?php

include_once APP_ROOT.'/controllers/manageClientsInstallCloneCommon.php';

class manageClientsStaging{
	
	public static function stagingDeleteSiteProcessor($siteIDs=array(), $params){
		$type = "staging";
		$action = "deleteSite";
		
		if(empty($params['siteID'])){
			$params['siteID'] = $siteIDs;
		}
		
		$thisSiteOldStagingSettings = stagingGetStagingFtpDetails($params);
		if($thisSiteOldStagingSettings && !array_key_exists('error', $thisSiteOldStagingSettings)){
			foreach($thisSiteOldStagingSettings as $k => $v){
				$params = array_merge($params, $v);
			}
		} else{
			addNotification($type='E', $title='Staging error', 'No settings.', $state='U', $callbackOnClose='', $callbackReference='');
			return $thisSiteOldStagingSettings;
		}
		$userID = (isset($GLOBALS['userID']) && !empty($GLOBALS['userID']))?$GLOBALS['userID']:$_SESSION['userID'];
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => 'deleteSite', 'detailedAction' => $type);
		$historyData = array('siteID' => $siteIDs, 'actionID' => Reg::get('currentRequest.actionID'), 'userID' => $userID, 'type' => $type, 'action' => $action, 'events' => 1, 'status' => 'pending', 'URL' => $params['newSiteURL'], 'timeout' => 1200, 'isPluginResponse' => '0', 'showUser' => 'Y', 'parentHistoryID' => $params['parentHistoryID']);
		
		$historyID = addHistory($historyData, $historyAdditionalData);
		
		$compactVars = compact('params');
		DB::insert("?:temp_storage", array('type' => 'stagingDeleteSite', 'paramID' => $historyID, 'time' => time(), 'data' =>  serialize($compactVars)));
		//rest of functionality will happen in method installCloneCommonNewSitePreProcessor()
		Reg::set('currentRequest.sendAfterAllLoad', true);
	}
	
	public static function stagingDeleteSitePreProcessor($historyID){

		$where = array(
			'query' =>   "type=':type' AND paramID=':paramID'",
				'params' => array(
					':type'=> 'stagingDeleteSite',
					':paramID' => $historyID,
				)
			);

		$compactVars = DB::getField("?:temp_storage", "data", $where);
		DB::delete("?:temp_storage", $where);
		
		$compactVars = unserialize($compactVars);
		extract($compactVars);
		
		if(isset($params['use_sftp']) && $params['use_sftp'] == 1){
			$conResult = manageClientsInstallCloneCommon::initIWPSftpConn($historyID, $params, $sftp);
			if(!$conResult || !$conResult){
				addNotification($type='E', $title='Staging Error', 'SFTP connection failed.', $state='U', $callbackOnClose='', $callbackReference='');
				return false;
			}
			
			$return = manageClientsInstallCloneCommon::createSftpCloneDirectory($cloneTempPath, $params, $conResult, $historyID);
			if(!$return){
				addNotification($type='E', $title='Staging error', 'Creating staging directory error.', $state='U', $callbackOnClose='', $callbackReference='');
				return false;
			}
		} else{
			$conResult = manageClientsInstallCloneCommon::initIWPFtpConn($historyID, $params, $connection);
			if(!$connection || !$conResult){
				addNotification($type='E', $title='Connection didnt happen', 'FTP connection failed.', $state='U', $callbackOnClose='', $callbackReference='');
				return false; //array('error' => 'Error creating the directory'); 
			}
			$uploadPath = '/'.trim($params['remoteFolder'], '/').'/clone_controller';
			$cloneTempPath = $uploadPath.'/clone_temp';
			
			$return = manageClientsInstallCloneCommon::createCloneDirectory($cloneTempPath, $connection, $historyID, array());
			if(!$return){
				addNotification($type='E', $title='Staging error', 'Creating staging directory error.', $state='U', $callbackOnClose='', $callbackReference='');
				return false;
			}
			
			$file_bridge 		= "/bridge.php";  
			$file_fileSystem 	= "/fileSystem.php";
			$file_pclzip 		= "/class-pclzip.php";
			$file_db            = "/db.php";
			
			$bridge_path = manageClientsInstallCloneCommon::getCloneBridgePath();
			
			$uploadBridge 	= @ftp_put($connection, $uploadPath.$file_bridge, $bridge_path.$file_bridge, FTP_ASCII);
			$uploadFS 		= @ftp_put($connection, $uploadPath.$file_fileSystem, $bridge_path.$file_fileSystem, FTP_ASCII);
			$uploadPCL 		= @ftp_put($connection, $uploadPath.$file_pclzip, $bridge_path.$file_pclzip, FTP_ASCII);
			$uploadDB 		= @ftp_put($connection, $uploadPath.$file_db, $bridge_path.$file_db, FTP_ASCII);
			
			if (!$uploadBridge || !$uploadFS || !$uploadPCL || !$uploadDB){
				updateHistory(array('status' => 'error'), $historyID);
				$historyIDWhere = array(
					'query' =>   "historyID=':historyID'",
					'params' => array(
						':historyID' => $historyID,
					)
				);
				DB::update("?:history_additional_data", array('status' => 'error', 'errorMsg' => 'FTP upload failed.'), $historyIDWhere);
				return false; //array('error' => 'FTP upload failed!'); 
			}
			@ftp_close($connection);
			
		}
		
		$destinationURL = removeTrailingSlash($params['newSiteURL'])."/clone_controller/bridge.php";
		
		$params['isDeleteStagingSite'] = true;
		manageClientsInstallCloneCommon::prepareBridgeRequest($historyID, $destinationURL, $params);
	}
	
	public static function stagingDeleteSiteResponseProcessor($historyID, $responseData){
		$where = array(
			'query' =>   "type=':type' AND paramID=':paramID'",
				'params' => array(
					':type'=> 'stagingDeleteSite',
					':paramID' => $historyID,
				)
			);

		DB::delete("?:temp_storage", $where);
		
		$start = '#Status(';
		$end = ')#';
		
		$strBetArray = getStrBetAll($responseData,$start,$end);
		$statusData = unserializeBase64DecodeArray($strBetArray);
		$historyIDWhere = array(
					'query' =>   "historyID=':historyID'",
					'params' => array(
						':historyID' => $historyID,
					)
				);
		$finalStateReached = false;
		$responseDataReadable = false;
		$setBreak = false;
		foreach($statusData as $d1){
			$responseDataReadable = true;
			if($setBreak){
				break;
			}
			foreach($d1 as $d2 => $d3){
				if($d2 == "error"){
					$finalStateReached = true;
					DB::update("?:history_additional_data", array('status' => 'error', 'error' => 'error', 'errorMsg' => $d3), $historyIDWhere);
				} else if($d2 == "success" && $d3 == 'delete_completed'){
					$finalStateReached = true;
					DB::update("?:history_additional_data", array('status' => 'success'), $historyIDWhere);
					DB::update("?:history", array('status' => 'completed'), $historyIDWhere);
					$siteID = DB::getField("?:history", "siteID", $historyIDWhere);
					$siteIDWhere = array(
						'query' =>   "siteID=':siteID'",
						'params' => array(
							':siteID' => $siteID,
						)
					);
					$stagingDetails = @unserialize(DB::getField("?:sites", "stagingFtpDetails", $siteIDWhere));
					$stagingSiteURL = $stagingDetails[key($stagingDetails)]['newSiteURL'];
					$URLWhere = array(
						'query' =>   "URL=':URL'",
						'params' => array(
							':URL' => addTrailingSlash($stagingSiteURL),
						)
					);
					DB::delete("?:sites", $URLWhere);
					$result = DB::update("?:sites", "stagingFtpDetails= NULL", $siteIDWhere);
					addNotification($type='N', $title='STAGING COMPLETE', $message='Staging site has been deleted.', $state='U', $callbackOnClose='', $callbackReference='');
				}	
			}
		}
		if($responseDataReadable === true && $finalStateReached === false){
			DB::update("?:history_additional_data", array('status' => 'error', 'error' => 'error', 'errorMsg' => 'An unknown error occured in Install/Clone process.'), $historyIDWhere);
		}
	}
	
}
manageClients::addClass('manageClientsStaging');