<?php

function uptimeMonitorUptimeRobotAddonMenus(&$menus){
	//$menus[] = '<li><a class="navLinks optionSelect" page="upTimeMonitor">Uptime Monitor</a></li>';
	$menus['tools']['subMenus'][] = array('page' => 'upTimeMonitor', 'displayName' => 'Uptime Monitor');
}

function uptimeMonitorUptimeRobotSaveApiKey($params){
	if(!empty($params)){
		$saveApiKey = updateOption("uptimeRobotApiKey", serialize(trim($params['uptimeRobotApiKey'])));
		if($saveApiKey){
			return trim($params['uptimeRobotApiKey']);
		}
		return false;
	}
}

function uptimeMonitorUptimeRobotAddNewEmail($params){
	$apiKey = uptimeMonitorUptimeRobotGetApiKey();
	$alertContactValue = $params['newEmail'];
	$timeStamp=time();
	$postRequest = array(
							"URL" => "https://api.uptimerobot.com/v2/newAlertContact",
							"data"=> "api_key=".$apiKey."&type=2&value=".$alertContactValue."&friendly_name=".$alertContactValue."&format=json&timestamp=".$timeStamp
						);
	return uptimeMonitorUptimeRobotApiCallAndResponse($postRequest);
}


function uptimeMonitorUptimeRobotGetApiKey(){
	$getApiKey = getOption("uptimeRobotApiKey");
	if(!empty($getApiKey)){
		$apiKey = unserialize($getApiKey);
		if($apiKey){
			return $apiKey;
		}
	}
	return false;
}

function uptimeMonitorUptimeRobotGetAllEmailIDs(){
	$apiKey = uptimeMonitorUptimeRobotGetApiKey();
	$timeStamp=time();
	$postRequest = array(
							"URL" => "https://api.uptimerobot.com/v2/getAlertContacts",
							"data"=> "api_key=".$apiKey."&format=json&timestamp=".$timeStamp
						);
	return  uptimeMonitorUptimeRobotApiCallAndResponse($postRequest);
}

//new monitor.
function uptimeMonitorUptimeRobotAddMonitor($params){
	$apiKey = uptimeMonitorUptimeRobotGetApiKey();
	
	if(empty($apiKey)){ return false; }
	
		if(!empty($params)){
			$monitorName = urlencode($params['monitorName']);
			if(!empty($params['emailAlerts'])){
				$alertContactID = "&alert_contacts=".$params['emailAlerts'];
			}
			$postRequest = array(
							"URL" => "https://api.uptimerobot.com/v2/getAccountDetails",
							"data"=> "api_key=".$apiKey."&format=json"
						);
			$getAccountDetails = uptimeMonitorUptimeRobotApiCallAndResponse($postRequest);
			$monitorInterval   = $getAccountDetails->account->monitor_interval*60;
			$monitorInterval   = "&interval=".$monitorInterval;
			$decodedData = array();
			foreach($params['siteIDs'] as $siteIDs => $siteID){
				$where = array(
				      		'query' =>  "siteID=:siteID",
				      		'params' => array(
				               ':siteID'=>$siteID
							)
						);
				$siteData = DB::getRow("?:sites", "URL, httpAuth", $where);
				$monitorHttpAuth = '';
				if(!empty($siteData['httpAuth'])){
					$siteHttpAuth = unserialize($siteData['httpAuth']);
					$monitorHttpAuth = "&http_username=".$siteHttpAuth['username']."&http_password=".$siteHttpAuth['password']."";
				}
				switch($params['type']){
					case 'http':
							$postRequest = array(
												"URL" => "https://api.uptimerobot.com/v2/newMonitor",
												"data"=> "api_key=".$apiKey."&friendly_name=".$monitorName."&url=".$siteData['URL']."&type=1&format=json".$alertContactID.$monitorHttpAuth.$monitorInterval
											);
						break;
						
					case 'keywordChecking':
							$postRequest = array(
												"URL" => "https://api.uptimerobot.com/v2/newMonitor",
												"data"=> "api_key=".$apiKey."&friendly_name=".$monitorName."&url=".$siteData['URL']."&type=2&keyword_type=".$params['keywordChecking']['alertWhen']."&keyword_value=".$params['keywordChecking']['keyword']."&format=json".$alertContactID.$monitorHttpAuth.$monitorInterval
											);
						break;
						
					case 'ping':
							$postRequest = array(
												"URL" => "https://api.uptimerobot.com/v2/newMonitor",
												"data"=> "api_key=".$apiKey."&friendly_name=".$monitorName."&url=".$siteData['URL']."&type=3&format=json".$alertContactID.$monitorHttpAuth.$monitorInterval
											);
							$upTimeMonitorAddURL = "https://api.uptimerobot.com/newMonitor?apiKey=".$apiKey."&monitorFriendlyName=".$monitorName."&monitorURL=".$siteData['URL']."&monitorType=3&format=json".$alertContactID.$monitorHttpAuth;
						break;
						
					case 'TCP':
							$postRequest = array(
												"URL" => "https://api.uptimerobot.com/v2/newMonitor",
												"data"=> "api_key=".$apiKey."&friendly_name=".$monitorName."&url=".$siteData['URL']."&type=3&sub_type=".$params['TCP']['port']."&port=".$params['TCP']['customPortValue']."&format=json".$alertContactID.$monitorHttpAuth.$monitorInterval
											);
						break;
				}
				$decodedData[$siteID] = uptimeMonitorUptimeRobotApiCallAndResponse($postRequest);				
			}
		}
		return $decodedData;
}

function uptimeMonitorUptimeRobotGetMonitor(){
	
	$apiKey = uptimeMonitorUptimeRobotGetApiKey();
	if(empty($apiKey)){ return false; }

	$logType[1]  = 'down';
	$logType[2]  = 'up';
	$logType[99] = 'pause';
	$logType[98] = 'started';

	$offset 	= 0 ;
	$resultData = array();
	$isTotalMonitorChecked  = 0;
	$upTimeMonitorLimit 	= 50;
	do {
		$postRequest = array(
							"URL" => "https://api.uptimerobot.com/v2/getMonitors",
							"data"=> "api_key=".$apiKey."&logs=1&timezone=1&all_time_uptime_ratio=1&custom_uptime_ratios=1&format=json&offset=".$offset
						);

		$decodedData = uptimeMonitorUptimeRobotApiCallAndResponse($postRequest);	
		if ($isTotalMonitorChecked == 0) {
			$totalMonitors = $decodedData->pagination->total;
			$isTotalMonitorChecked = 1;
			$totalCallrequired = ( floor($totalMonitors / $upTimeMonitorLimit) + (($totalMonitors % $upTimeMonitorLimit == 0) ? 0 : 1) ) -1;	
		}
		if($decodedData->stat == 'fail' || empty($decodedData->monitors)){
				return array('stat' => 'fail', 'message' => $decodedData->message);
		}else{
			uptimeMonitorUptimeRobotMergeMonitors($resultData, $decodedData);			
		}
		$offset += $upTimeMonitorLimit;
		// $totalCallrequired = 1;
	} while ($totalCallrequired--);

		
	return $resultData;
}

function uptimeMonitorUptimeRobotMergeMonitors(&$resultData, $decodedData){
	$monitors = $decodedData->monitors;
	$current_default_zone = date_default_timezone_get();
	if(!empty($monitors) && is_array($monitors)){
		foreach($monitors as $monitor){
			$logsData = array();
			if(!empty($monitor->logs)){
				$i = 1;
				foreach($monitor->logs as $key => $logs){
					if(date_default_timezone_get()!=$current_default_zone) date_default_timezone_set($current_default_zone);
					$monitorTimeStamp = $logs->datetime;
					$monitorTime = date('H.is', $monitorTimeStamp);
					$monitorDate = date('m/d/Y H:i:s', $monitorTimeStamp);
					
					@date_default_timezone_set('GMT'); //gmdate(time());
					$gmt = time();
					
					$currentTimeStamp = strtotime($decodedData->timezone."minutes", $gmt);
					$currentTime = date('m/d/Y H:i:s', $currentTimeStamp);
				
					$todayStartHourTimeStamp = strtotime("-24 hours", $currentTimeStamp);
					$todayStartHour =  date('H', $todayStartHourTimeStamp);
					
					$diff = ($currentTimeStamp - $todayStartHourTimeStamp)/60/60;
					if($monitorTimeStamp >= $todayStartHourTimeStamp){
						$logsData[] = array('time' => $monitorDate, 'type' => $logType[$logs->type], 'hour' => $monitorTime, 'currentTime' => $currentTime, 'less24' => 'yes', 'todayStartHour' => $todayStartHour, 'diff' => $diff);
					}
					else{
						if(empty($logsData) || $i == 1){
							$logsData[] = array('time' => $monitorDate, 'type' => (($logs->type == 1) ? 'down' : 'up'), 'hour' => $monitorTime, 'currentTime' => $currentTime, 'less24' => 'no', 'todayStartHour' => $todayStartHour, 'diff' => $diff);
							$i = 0;
							continue;
						}
					}
				}
			}
			$resultData[$monitor->friendly_name][] = array('stat' => $decodedData->stat, 'playPauseStatus' => $monitor->status, 'monitorID' => $monitor->id, 'monitorURL' => $monitor->url, 'currentTime' => date('H.i', strtotime($decodedData->timezone."minutes")), 'monitorName' => $monitor->friendly_name, 'alltimeuptimeratio' => $monitor->all_time_uptime_ratio, 'customUpTimeRatio' => $monitor->custom_uptime_ratio, 'logs' => $logsData);
		}	
	}
}

function uptimeMonitorUptimeRobotDeleteMonitor($params){
	$apiKey = uptimeMonitorUptimeRobotGetApiKey();
	
	if(empty($apiKey)){ return false; }
	
	if(is_array($params['monitorIDs'])){
		$upTimeMonitorDeleteResult = array();
		foreach($params['monitorIDs'] as $key => $monitorID){
			$postRequest = array(
						"URL" => "https://api.uptimerobot.com/v2/deleteMonitor",
						"data"=> "api_key=".$apiKey."&id=".$monitorID."&format=json"
					);
			$upTimeMonitorDeleteResult[] = uptimeMonitorUptimeRobotApiCallAndResponse($postRequest);
		}
		
	}
		
	return $upTimeMonitorDeleteResult;
}

function uptimeMonitorUptimeRobotChangeStatus($params){
	
	$apiKey = uptimeMonitorUptimeRobotGetApiKey();
	if(empty($apiKey)){ return false; }
	
	$postRequest = array(
						"URL" => "https://api.uptimerobot.com/v2/editMonitor",
						"data"=> "api_key=".$apiKey."&id=".$params['monitorID']."&status=".$params['status']."&format=json"
					);
	$resultDecodedData = uptimeMonitorUptimeRobotApiCallAndResponse($postRequest);
	
	return $resultDecodedData;
}

function uptimeMonitorUptimeRobotApiCallAndResponse($postRequest){
	$URL = $postRequest['URL'];
	$data = $postRequest['data'];
	$response   = uptimeMonitorDoAPICall($URL, $data, '');

	if (strpos($response[0],'jsonUptimeRobotApi') !== false) {
		return json_decode(substr ($response[0], strlen($json_encap) - 1, strlen ($response[0]) - strlen($json_encap)));
    }
	else {
		return json_decode($response[0]);
	}
}
	
function uptimeMonitorUptimeRobotHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('uptimeMonitorUptimeRobot');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/uptimeMonitorUptimeRobot/css/uptimeMonitorUptimeRobot.css')),
		array('js' => array('href' => 'addons/uptimeMonitorUptimeRobot/js/functions.js')),
		array('js' => array('href' => 'addons/uptimeMonitorUptimeRobot/js/init.js')),
		array('js' => array('href' => 'addons/uptimeMonitorUptimeRobot/js/load.js')),
	);
	$headFiles['uptimeMonitorUptimeRobot'] = $addonDetails;
}
function uptimeMonitorGetCutomRatio($params){
	if (empty($params['siteID'])) {
		return false;
	}
	$siteID = $params['siteID'];
	$where = array(
      		'query' =>  "siteID=':siteID'",
      		'params' => array(
               ':siteID'=>$siteID
				)
		);
	$URL = DB::getField('?:sites', 'URL', $where);
	$totalRatio=0;
	$customuptimeratio=array();
	$resultData = uptimeMonitorUptimeRobotCutomRatio($URL, $params);
	if (empty($resultData) || $resultData->stat == 'fail') {
		return false;
	}
	$monitors = $resultData->monitors;
	foreach ($monitors as $monitor) {
		if (trim(str_replace(array('www.','https://','http://'),'',$monitor->url),'/') == trim(str_replace(array('www.','https://','http://'),'',$URL),'/')) {
			$customuptimeratio []=$monitor->custom_uptime_ranges;
			$totalRatio+=$monitor->custom_uptime_ranges;
		}
	}
	if (empty($customuptimeratio)) {
		return false;
	}elseif (!empty($customuptimeratio) && $totalRatio == 0) {
		return 0;
	}

	$averageRatio = $totalRatio/count($customuptimeratio);
	return $averageRatio;
}

function uptimeMonitorUptimeRobotCutomRatio($URL, $params){
	$apiKey = uptimeMonitorUptimeRobotGetApiKey();
	if(empty($apiKey) || empty($URL)){ return false; }
	$extras = '';
	if (!empty($params['fromDate'])) {
		$extras = '&custom_uptime_ranges='.$params['fromDate'].'_'.$params['toDate'];
	}else{
		$extras = '&custom_uptime_ratios=30';
	}
	$postRequest = array(
						"URL" => "https://api.uptimerobot.com/v2/getMonitors",
						"data"=> "api_key=".$apiKey."&format=json&search=".removeTrailingSlash(trim(str_replace(array('www.','https://','http://'),'',$URL),'/')).$extras
					);
	$decodedData = uptimeMonitorUptimeRobotApiCallAndResponse($postRequest);	
	return $decodedData;
}

function uptimeMonitorDoAPICall($URL, $data, $timeout=60, $options=array()){
	$URL = trim($URL);	
	$HTTPCustomHeaders = array(
						    "cache-control: no-cache",
						    "content-type: application/x-www-form-urlencoded"
						  );

	$ch = curl_init($URL);
	curl_setopt($ch, CURLOPT_URL, $URL);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_MAXREDIRS, 10);
	curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_1);
	curl_setopt($ch, CURLOPT_ENCODING, '');
	curl_setopt($ch, CURLOPT_TIMEOUT, $timeout);
	curl_setopt($ch, CURLOPT_HEADER, true);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $HTTPCustomHeaders);

	if (!ini_get('safe_mode') && !ini_get('open_basedir')){
		@curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	}
	
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
	
	$microtimeStarted 	= microtime(true);
	$rawResponse 			= curl_exec($ch);
	$microtimeEnded 	= microtime(true);
	
	$curlInfo = array();
	$curlInfo['info'] = curl_getinfo($ch);
	if(curl_errno($ch)){
		$curlInfo['errorNo'] = curl_errno($ch);
		$curlInfo['error'] = curl_error($ch);
	}
        	
	curl_close($ch);

	list($responseHeader, $responseBody) = bifurcateResponse($rawResponse, $curlInfo);
	
	return array($responseBody, $microtimeStarted, $microtimeEnded, $curlInfo, $responseHeader);
}