<?php

/*
slug: wpOptimize
version: 2.2.0
*/

class addonWpOptimize{
	
	private static $version = '2.2.0';

	public static function version(){
		return self::version;	
	}
	
	public static function init(){
		require_once(APP_ROOT."/addons/wpOptimize/controllers/func.php");	
		require_once(APP_ROOT."/addons/wpOptimize/controllers/manageClientsWpOptimize.php");
		panelRequestManager::addFunctions('wpOptimizeResult', 'wpOptimizeSchedule', 'wpOptimizeGetSchedulesHTML', 'getOptimizeScheduleEditData', 'wpOptimizeDeleteSchedule', 'scheduleOptimizePause');
		regHooks('addonMenus', 'responseProcessors', 'cronRun', 'taskTitleTemplate', 'cronRequiredAlert', 'getNextSchedule', 'removeSite', 'headHTMLFiles');
	}

	public static function install(){
	
		$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:wp_optimize_schedules` (
		  `scheduleID` int(10) NOT NULL AUTO_INCREMENT,
		  `scheduleName` varchar(50) NOT NULL,
		  `type` varchar(15) NOT NULL,
		  `schedule` varchar(15) NOT NULL,
		  `scheduleKey` varchar(255) NOT NULL DEFAULT '''''',
		  `optimizeActions` text NOT NULL,
		  `scheduleStatus` varchar(50) NOT NULL DEFAULT '''''',
		  `nextSchedule` bigint(20) unsigned DEFAULT NULL,
		  `lastRun` int(10) unsigned DEFAULT NULL,
		  `paused` enum('0','1') NOT NULL DEFAULT '0',
		  PRIMARY KEY (`scheduleID`)
		)".DB::getSQLTableEnv().";");

		$Q2 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:wp_optimize_schedules_link` (
		  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  `siteID` int(10) unsigned NOT NULL,
		  `scheduleID` int(10) unsigned DEFAULT NULL,
		  `nextSchedule` bigint(20) DEFAULT NULL,
		  `delayedTime` int(10) unsigned DEFAULT '1',
		  `finalTime` bigint(20) DEFAULT NULL,
		  `status` varchar(50) NOT NULL,
		  PRIMARY KEY (`ID`)
		)".DB::getSQLTableEnv().";");
		
		$Q3 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:wp_optimize_schedules_result` (
		  `ID` int(20) NOT NULL AUTO_INCREMENT,
		  `siteID` int(20) DEFAULT NULL,
		  `scheduleKey` varchar(120) DEFAULT NULL,
		  `time` varchar(50) DEFAULT NULL,
		  `data` text,
		  PRIMARY KEY (`ID`)
		)".DB::getSQLTableEnv().";");
		
		if($Q1 && $Q2 && Q3){
			return true;	
		}
		return false;
	}
	
	public static function update(){
		
		$oldVersion = getOldAddonVersion('wpOptimize');
		
		if(version_compare($oldVersion, '2.0.0beta1', '<')){
				$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:wp_optimize_schedules` (
		  `scheduleID` int(10) NOT NULL AUTO_INCREMENT,
		  `scheduleName` varchar(50) NOT NULL,
		  `type` varchar(15) NOT NULL,
		  `schedule` varchar(15) NOT NULL,
		  `scheduleKey` varchar(255) NOT NULL DEFAULT '''''',
		  `optimizeActions` text NOT NULL,
		  `scheduleStatus` varchar(50) NOT NULL DEFAULT '''''',
		  `nextSchedule` bigint(20) unsigned DEFAULT NULL,
		  `lastRun` int(10) unsigned DEFAULT NULL,
		  `paused` enum('0','1') NOT NULL DEFAULT '0',
		  PRIMARY KEY (`scheduleID`)
		)".DB::getSQLTableEnv().";");

		$Q2 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:wp_optimize_schedules_link` (
		  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  `siteID` int(10) unsigned NOT NULL,
		  `scheduleID` int(10) unsigned DEFAULT NULL,
		  `nextSchedule` bigint(20) DEFAULT NULL,
		  `delayedTime` int(10) unsigned DEFAULT '1',
		  `finalTime` bigint(20) DEFAULT NULL,
		  `status` varchar(50) NOT NULL,
		  PRIMARY KEY (`ID`)
		)".DB::getSQLTableEnv().";");
		
		$Q3 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:wp_optimize_schedules_result` (
		  `ID` int(20) NOT NULL AUTO_INCREMENT,
		  `siteID` int(20) DEFAULT NULL,
		  `scheduleKey` varchar(120) DEFAULT NULL,
		  `time` varchar(50) DEFAULT NULL,
		  `data` text,
		  PRIMARY KEY (`ID`)
		)".DB::getSQLTableEnv().";");
		
		if(version_compare(getOldAddonVersion('wpOptimize'), '2.1.3beta1', '<')){
			$deleteFiles = array('/addons/wpOptimize/initHTMLHead.php' => array('type' => 'f') );
			fileSystemRemoveFiles($deleteFiles);
		}
		if($Q1 && $Q2 && Q3){
			return true;	
		}
		return false;
		}
		return true;
	}
	
}
?>