<?php

function wpOptimizeGetNextSchedule(&$nextScheduleTime){

	$nextTime = DB::getField("?:wp_optimize_schedules", "MIN(nextSchedule)", "paused='0' ");
	if(!empty($nextTime)){
		$nextScheduleTime[] = $nextTime;
	}
}

function wpOptimizeAddonMenus(&$menus){
	//$menus[] = '<li><a class="navLinks optionSelect" page="wpOptimize">WP Optimize</a></li>';
	$menus['maintain']['subMenus'][] = array('page' => 'wpOptimize', 'displayName' => 'WP Maintenance');
}

function wpOptimizeResponseProcessors(&$responseProcessor){
	$responseProcessor['wp']['optimize'] = 'wpOptimize';
	$responseProcessor['wp']['wpClearCache'] = 'wpClearCache';
}

function wpOptimizeResult(){
	
	
	$actionID = Reg::get('currentRequest.actionID');
	$where = array(
		          'query' => "type = ':type' AND paramID = ':paramID'",
		          'params' => array(
		               ':type'=>'wpOptimize',
		               ':paramID'=>$actionID
		           )
		        );
	$getDatas = DB::getFields("?:temp_storage", "data", $where);
	DB::delete("?:temp_storage", $where);
		
	if(empty($getDatas)){
		return array();
	}
	$finalData = array();
	foreach($getDatas as $data){
		$finalData = array_merge_recursive($finalData, (array)unserialize($data));	
	}
	arrayMergeRecursiveNumericKeyHackFix($finalData);
		
	return $finalData;
}


function wpOptimizeTaskTitleTemplate(&$template){
	$template['wp']['optimize']['']	= "Perform maintenance in <#sitesCount#> site<#sitesCountPlural#> ";
	$template['wp']['wpClearCache']['']	= "Clear cache in <#sitesCount#> site<#sitesCountPlural#> ";
}

function scheduleOptimizeScheduleNext($type, $schedule){
	$schedule = explode("|", $schedule);
	if (empty($schedule))
		return false;
	switch ($type) {
		
		case 'daily':
			
			if (isset($schedule[1]) && $schedule[1]) {
				$delay_time = $schedule[1] * 60;
			}
			
			$current_hour  = date("H");
			$schedule_hour = $schedule[0];
			if ($current_hour >= $schedule_hour){
				$time = mktime($schedule_hour, 0, 0, date("m"), date("d") + 1, date("Y"));
			}
			else{
				$time = mktime($schedule_hour, 0, 0, date("m"), date("d"), date("Y"));
			}
					
			break;
		
		
		case 'weekly':
			if (isset($schedule[2]) && $schedule[2]) {
				$delay_time = $schedule[2] * 60;
			}
			$current_weekday  = date('w');
			$schedule_weekday = $schedule[1];
			$current_hour     = date("H");
			$schedule_hour    = $schedule[0];
			
			if ($current_weekday > $schedule_weekday)
				$weekday_offset = 7 - ($current_weekday - $schedule_weekday);
			else
				$weekday_offset = $schedule_weekday - $current_weekday;
			
			
			if (!$weekday_offset) { //today is scheduled weekday
				if ($current_hour >= $schedule_hour)
					$time = mktime($schedule_hour, 0, 0, date("m"), date("d") + 7, date("Y"));
				else
					$time = mktime($schedule_hour, 0, 0, date("m"), date("d"), date("Y"));
			} else {
				$time = mktime($schedule_hour, 0, 0, date("m"), date("d") + $weekday_offset, date("Y"));
			}
			
			break;
		
		case 'monthly':
			if (isset($schedule[2]) && $schedule[2]) {
				$delay_time = $schedule[2] * 60;
			}
			$current_monthday  = date('j');
			$schedule_monthday = $schedule[1];
			$current_hour      = date("H");
			$schedule_hour     = $schedule[0];
			
			if ($current_monthday > $schedule_monthday) {
				$time = mktime($schedule_hour, 0, 0, date("m") + 1, $schedule_monthday, date("Y"));
			} else if ($current_monthday < $schedule_monthday) {
				$time = mktime($schedule_hour, 0, 0, date("m"), $schedule_monthday, date("Y"));
			} else if ($current_monthday == $schedule_monthday) {
				if ($current_hour >= $schedule_hour)
					$time = mktime($schedule_hour, 0, 0, date("m") + 1, $schedule_monthday, date("Y"));
				else
					$time = mktime($schedule_hour, 0, 0, date("m"), $schedule_monthday, date("Y"));
				break;
			}
			
			break;
		default:
			break;
	}
	
	if (isset($delay_time) && $delay_time) {
		$time += $delay_time;
	}
	
	return $time;
}

function wpOptimizeSchedule($params){
	//for creating the schedule
	if(empty($params['scheduleKey'])){
		$scheduleID = DB::insert("?:wp_optimize_schedules", array("scheduleName" => $params['scheduleName'], "type" => $params['type'], "schedule" => $params['scheduleHR'], "optimizeActions" => serialize($params['optimizeActions']) ));
		$key = md5($scheduleID.microtime()); 
		$where = array(
		      		'query' =>  "scheduleID = ':scheduleID'",
		      		'params' => array(
		               ':scheduleID'=>$scheduleID
       				)
    			);
		DB::update("?:wp_optimize_schedules", "scheduleKey = '".$key."'", $where);
	}
	
	if(!empty($params['scheduleKey'])){
		$where = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey'=>$params['scheduleKey']
       				)
    			);
	   $scheduleID = DB::getField("?:wp_optimize_schedules", "scheduleID", $where);
	   DB::update("?:wp_optimize_schedules", array("scheduleName" => $params['scheduleName'], "type" => $params['type'], "schedule" => $params['scheduleHR'], "optimizeActions" => serialize($params['optimizeActions'])), $where);
	   $key = $params['scheduleKey'];
	   $where = array(
		      		'query' =>  "scheduleID = ':scheduleID'",
		      		'params' => array(
		               ':scheduleID'=>$scheduleID
       				)
    			);
	   DB::delete("?:wp_optimize_schedules_link", $where);
	}

	$nextSchedule = scheduleOptimizeScheduleNext($params['type'], $params['scheduleHR']);
	$where = array(
	      		'query' =>  "scheduleKey = ':scheduleKey'",
	      		'params' => array(
	               ':scheduleKey' => $key
				)
			);	
	DB::update("?:wp_optimize_schedules", array('scheduleStatus'=>'scheduled' ,'nextSchedule'=>$nextSchedule), $where);
	
	if(!empty($params['siteIDs'])){
		foreach($params['siteIDs'] as $siteID){
			$scheduled = DB::insert("?:wp_optimize_schedules_link", array('siteID' => $siteID ,'scheduleID'=>$scheduleID ,'nextSchedule'=>$nextSchedule, 'status'=>'scheduled'));
		}
	}

	return $scheduled;
}

function wpOptimizeGetSchedulesHTML(){
	$optimizeSchedules = wpOptimizeGetSchedules();
	$HTML = TPL::get('/addons/wpOptimize/templates/view.tpl.php', array('optimizeSchedules' => $optimizeSchedules));
	return $HTML;
	//return $scheduleBackups;
}

function wpOptimizeGetSchedules(){
        if(userStatus() == "admin") {
            $whereSiteIn = "";
        } else {
            setHook('sitesList', $siteList);
            $siteIDs = array();
            foreach($siteList as $siteInfo) {
                array_push($siteIDs, $siteInfo['siteID']);
            }
            $siteIDs = implode(', ', $siteIDs);
            $whereSiteIn = " and siteID in (".$siteIDs.")";
        }
        
	$schedules = DB::getArray("?:wp_optimize_schedules", "*","1");
	if(!empty($schedules)){					
		foreach($schedules as $key => $value){
			$where = array(
			      		'query' =>  "scheduleID=':scheduleID'" . $whereSiteIn,
			      		'params' => array(
			               ':scheduleID' => $value['scheduleID']
						)
					);	
			$sites = DB::getArray("?:wp_optimize_schedules_link", "siteID", $where);
			
                        echo DB::getLastQuery();
                        echo "<br>";
			foreach($sites as $site){
				$sIDs[] = $site['siteID'];
			}
			$scheduleNames[] = $value['scheduleKey'];
		}
	}
		if(!empty($sIDs))
		$siteIDs = array_unique($sIDs);
		$sitesStats = panelRequestManager::getRawSitesStats($siteIDs);
		$sitesBackups = array();
			
		foreach($sitesStats as $siteID => $siteStats){
			if(!empty($scheduleNames))
			foreach($scheduleNames as $backupName){
				$where = array(
				      		'query' =>  "scheduleKey=':scheduleKey'",
				      		'params' => array(
				               ':scheduleKey' => $backupName
							)
						);	
				$sitesBackups[$backupName]['data'] = DB::getRow("?:wp_optimize_schedules", "*", $where);
				$where = array(
				      		'query' =>  "scheduleID=':scheduleID'". $whereSiteIn,
				      		'params' => array(
				               ':scheduleID' => $sitesBackups[$backupName]['data']['scheduleID']
							)
						);
				$sitesBackups[$backupName]['data']['count'] = $count= DB::getField("?:wp_optimize_schedules_link", "count(DISTINCT siteID)", $where);
                                $sitesBackups[$backupName]['data']['where'] = $whereSiteIn;
			}
		}
	return $sitesBackups;
	
}

function getOptimizeScheduleEditData($params){
	if(empty($params)){
		return false;
	}
	else{
		$data = array();
		$where = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey' => $params['scheduleKey']
					)
				);	
		$data['scheduleData'] = DB::getRow("?:wp_optimize_schedules", "scheduleID, scheduleName, type, schedule, scheduleKey, optimizeActions, paused ", $where);
		$data['scheduleData']['optimizeActions'] = unserialize($data['scheduleData']['optimizeActions']);
		
		$where = array(
		      		'query' =>  "scheduleID=':scheduleID'",
		      		'params' => array(
		               ':scheduleID' => $data['scheduleData']['scheduleID']
					)
				);	
		$data['scheduleData']['siteName']['siteIDs'] = $siteIDs = DB::getFields("?:wp_optimize_schedules_link", "siteID", $where);
	
		if($data['scheduleData']['type'] == 'daily'){
			$data['scheduleData']['time'] = $data['scheduleData']['schedule'];
			unset($data['scheduleData']['schedule']);
		}
		
		if($data['scheduleData']['type'] == 'weekly' || $data['scheduleData']['type'] == 'monthly'){
			$a = explode("|", $data['scheduleData']['schedule']);
			$data['scheduleData']['time'] = $a[0];
			$data['scheduleData']['day'] = $a[1];
			unset($data['scheduleData']['schedule']);		
		}
				
		foreach($siteIDs as $siteID){
			Reg::tplSet('sitesData', panelRequestManager::getSites());
            $sitesData = Reg::tplGet('sitesData'); 
			$data['scheduleData']['siteName'][$siteID] = $sitesData[$siteID]['name'];
		}
	}
	return $data;
}

function wpOptimizeCronRun(){
	$settings = DB::getArray("?:wp_optimize_schedules", "*", "nextSchedule <= '".time()."' AND paused='0'");
	if(!empty($settings)){
		foreach($settings as $key => $value){
			$where = array(
		      		'query' =>  "scheduleID=':scheduleID'",
		      		'params' => array(
		               ':scheduleID' => $value['scheduleID']
					)
				);	
			$sites = DB::getFields("?:wp_optimize_schedules_link", "siteID", $where);
			if(empty($sites)){ continue; }
			
			//----------------------------------------------------decide a task need to run now or not---------------------------------------------------------
			$optimizeActions = unserialize($value['optimizeActions']);

			if(CRON_MODE == 'easyCronTask'){
				if(getSystemCronRunningFrequency() == 0){
					addNotification($type='E', $title='Schedule Maintainance Method Changed', '<strong>'.$value['backupName'].'</strong> schedule task method has been temporarily changed to MultiCall because system cron was not trigger for last 90 mins.', $state='U');//FINALISE ERROR MESSAGE
				}
				else{
					continue;//systemCron is active, lets wait for it to trigger this singleCall Backup
				}
			}
			elseif(CRON_MODE == 'systemCronDefault'){
				if(!manageEasyCron::isActive()){
					addNotification($type='E', $title='Schedule Maintainance Method Changed', '<strong>'.$value['backupName'].'</strong> schedule task method has been temporarily changed to old method because easyCron was not active.', $state='U');//FINALISE ERROR MESSAGE
				}
				else{
					continue;//easyCron is active, lets wait for it to trigger this multiCall Backup
				}
			}
			//----------------------------------------------------decide a task need to run now or not------------ENDS HERE-------------------------------
			
			$next = scheduleOptimizeScheduleNext($value['type'], $value['schedule']);
			$where = array(
			      		'query' =>  "scheduleID=':scheduleID' AND scheduleKey = ':scheduleKey'",
			      		'params' => array(
			               ':scheduleID' => $value['scheduleID'],
			               ':scheduleKey' => $value['scheduleKey']
						)
					);	
			DB::update("?:wp_optimize_schedules", array('nextSchedule' => $next), $where);
			
			$data = array(	'action' => 'wpOptimizeRunTask', 
							'args' => array(
								'params' => array('scheduleKey' => $value['scheduleKey'], 'timeScheduled' => $value['nextSchedule']),
								'siteIDs' => $sites
							)
						);
			panelRequestManager::handler($data);
		}
	}
}

function wpOptimizeDeleteSchedule($params){
	$where = array(
	      		'query' =>  "scheduleKey=':scheduleKey'",
	      		'params' => array(
	               ':scheduleKey' => $params['schedulekey']
				)
			);	
	$scheduleID = DB::getField("?:wp_optimize_schedules", "scheduleID", $where);
	$where1 = array(
	      		'query' =>  "scheduleID = ':scheduleID'",
	      		'params' => array(
	               ':scheduleID'=>$scheduleID
   				)
			);
	DB::delete("?:wp_optimize_schedules_link", $where1);
	DB::delete("?:wp_optimize_schedules", $where);
	DB::delete("?:wp_optimize_schedules_result", $where);
	return true;
}

function scheduleOptimizePause($params){ //panelRequestManager
	if(empty($params)){
			return false;
	}
	else{
		$where = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey' => $params['scheduleKey']
					)
				);	
		DB::update("?:wp_optimize_schedules", array('paused' => $params['value']), $where);
	}
}

function wpOptimizeRemoveSite($siteID){
	$where = array(
	      		'query' =>  "siteID=':siteID'",
	      		'params' => array(
	               ':siteID' => $siteID
				)
			);	
	$scheduleIDs = DB::getFields("?:wp_optimize_schedules_link", "scheduleID", $where);			
	DB::delete("?:wp_optimize_schedules_link", $where );
	if(!empty($scheduleIDs)){
		foreach($scheduleIDs as $scheduleID){
			//clearing schedule results
			$where = array(
			      		'query' =>  "scheduleID=':scheduleID'",
			      		'params' => array(
			               ':scheduleID' => $scheduleID
						)
					);	
			$thisScheduleKey = DB::getFields("?:wp_optimize_schedules", "scheduleKey", $where);
			
			if($thisScheduleKey && !empty($thisScheduleKey)){
				foreach($thisScheduleKey as $k => $thisKey){
					$where = array(
					      		'query' =>  "scheduleKey=':scheduleKey' AND siteID=':siteID' ",
					      		'params' => array(
					               ':scheduleKey' => $thisKey,
					               ':siteID' => $siteID
								)
							);
					DB::delete("?:wp_optimize_schedules_result", $where );
				}
			}
			$where = array(
			      		'query' =>  "scheduleID=':scheduleID'",
			      		'params' => array(
			               ':scheduleID' => $scheduleID
						)
					);
			$scheduleIDExists = DB::getExists("?:wp_optimize_schedules_link", "scheduleID", $where);
			if(!$scheduleIDExists){
				DB::delete("?:wp_optimize_schedules", $where );
			}
		}
	}
	
	//clearing schedule results
	
}

function wpOptimizeCronRequiredAlert($requiredFor){
	$requiredFor[] = 'Schedule Maintainance';
}

function wpOptimizeHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('wpOptimize');
	$addonDetails['files'] = array(
	    array('css' => array('href' => 'addons/wpOptimize/css/wpOptimize.css')),
	    array('js' => array('href' => 'addons/wpOptimize/js/functions.js')),
	    array('js' => array('href' => 'addons/wpOptimize/js/init.js')),
	    array('js' => array('href' => 'addons/wpOptimize/js/load.js')),
	);
	$headFiles['wpOptimize'] = $addonDetails;
}