<?php
class manageClientsWpOptimize{
	
	public static function wpOptimizeProcessor($siteIDs, $params){
		
		$type = "wp";
		$action = "optimize";
		$requestAction = "wp_optimize";
			  
		$requestParams = $params['type'];	
		
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => "optimize", 'detailedAction' => $type);
		  
		  foreach($siteIDs as $siteID){
			  $siteData = getSiteData($siteID);
			  $events=1;
			  
			  $PRP = array();
			  $PRP['requestAction'] 			= $requestAction;
			  $PRP['requestParams'] 			= $requestParams;
			  $PRP['siteData'] 					= $siteData;
			  $PRP['type'] 						= $type;
			  $PRP['action'] 					= $action;
			  $PRP['events'] 					= $events;
			  $PRP['sendAfterAllLoad'] 			= true;
			  $PRP['historyAdditionalData'] 	= $historyAdditionalData;
						
			  prepareRequestAndAddHistory($PRP);
		  }
		
	}
	
	public static function wpOptimizeResponseProcessor($historyID, $responseData){
		
		responseDirectErrorHandler($historyID, $responseData);
		  
		  if( empty($responseData['success'])  ){
			  return false;
		  }
	
		  $updateLink = array();
		  if(!empty($responseData['success'])){
		  	$where = array(
			      		'query' =>  "historyID=':historyID'",
			      		'params' => array(
			               ':historyID' => $historyID
						)
					);
			$historyData = DB::getRow("?:history", "type, actionID, siteID", $where);
			$actionID = $historyData['actionID'];
			$siteID = $historyData['siteID'];
			$response['_'.$siteID] = $responseData['success'];
			$result_response[$siteID] = $responseData['success'];
			
			//storing the result
			
			//getting current schedule key first
			$recentWPMScheduleKeys = unserialize(getOption('recentWPMScheduleKey'));
			$recentWPMScheduleKey = $recentWPMScheduleKeys[$actionID][$siteID];
			
			DB::insert("?:temp_storage", array('type' => 'wpOptimize', 'paramID' => $actionID, 'time' => time(), 'data' =>  serialize($response)));
			$where = array(
			      		'query' =>  "historyID=':historyID'",
			      		'params' => array(
			               ':historyID' => $historyID
						)
					);
			DB::update("?:history_additional_data", "status='success'", $where);
			if(!empty($recentWPMScheduleKey)){
				DB::insert("?:wp_optimize_schedules_result", array('scheduleKey' => $recentWPMScheduleKey, 'time' => time(), 'siteID' => $siteID, 'data' =>  serialize($result_response)));
			}
			DB::update("?:history_additional_data", array('status' => 'success', 'errorMsg' => serialize($responseData['success']) ), $where);
			
			unset($recentWPMScheduleKeys[$actionID][$siteID]);
			
			if(empty($recentWPMScheduleKeys[$actionID])){
				unset($recentWPMScheduleKeys[$actionID]);
			}
			if(empty($recentWPMScheduleKey)){
				$recentWPMScheduleKey = array();
			}
			updateOption('recentWPMScheduleKey', serialize($recentWPMScheduleKeys));
		}
	}
	
	public static function wpOptimizeRunTaskProcessor($siteIDs=array(), $params, $extras=array()){
		$type = "wp";
		$action = "optimize";
		$requestAction = "wp_optimize";
		
		$timeout = (20 * 60);
		$where = array(
		      		'query' =>  "BL.scheduleID=BS.scheduleID AND scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey' => $params['scheduleKey']
					)
				);
				
		$siteIDs = DB::getFields("?:wp_optimize_schedules as BS, ?:wp_optimize_schedules_link as BL", "BL.siteID", $where);
		$where = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey' => $params['scheduleKey']
					)
				);
		$optimizeActions = DB::getField("?:wp_optimize_schedules", "optimizeActions", $where);
		$requestParams = unserialize($optimizeActions);
		
		
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => $params['scheduleKey'], 'detailedAction' => $action);
		
		
		
		
		$incTime = 10 * 60;//10 mins		
		$i = 0;
		$lastHistoryID = '';
		if(empty($params['timeScheduled'])){ $params['timeScheduled'] = time(); }
		foreach($siteIDs as $siteID){
			
			//to store the response result in DB we need the schedule key
			$currentWPMScheduleKeys = array();
			if(!getOption('recentWPMScheduleKey')){
				$currentWPMScheduleKeys = array();
				$currentWPMScheduleKeys[Reg::get('currentRequest.actionID')][$siteID] = $params['scheduleKey'];
			}
			else{
				$currentWPMScheduleKeysTemp = unserialize(getOption('recentWPMScheduleKey'));
				if(empty($currentWPMScheduleKeysTemp)){
					$currentWPMScheduleKeysTemp = array();
				}
				$currentWPMScheduleKeys = $currentWPMScheduleKeysTemp;
				$currentWPMScheduleKeys[Reg::get('currentRequest.actionID')][$siteID] = $params['scheduleKey'];
			}
			updateOption('recentWPMScheduleKey', serialize($currentWPMScheduleKeys));
			
			$siteData = getSiteData($siteID);
			
			$events=1;
			
			$PRP = array();
			$PRP['requestAction'] 	= $requestAction;
			$PRP['requestParams'] 	= $requestParams;
			$PRP['siteData'] 		= $siteData;
			$PRP['type'] 			= $type;
			$PRP['action'] 			= $action;
			$PRP['events'] 			= $events;
			$PRP['historyAdditionalData'] 	= $historyAdditionalData;
			$PRP['timeout'] 		= $timeout;
			//$PRP['status'] 			= 'pending';
			

			$PRP['timeScheduled'] = $params['timeScheduled'];
			
			prepareRequestAndAddHistory($PRP);
			
		}
	}
	
	public static function wpOptimizeRunTaskResponseProcessor($historyID, $responseData){
		//this function never runs
		/* responseDirectErrorHandler($historyID, $responseData);
		
		if(empty($responseData['success'])){
			return false;
		}
		
		if(!empty($responseData['success'])){
			$historyData = DB::getRow("?:history", "type, actionID, siteID", "historyID=".$historyID);
			$actionID = $historyData['actionID'];
			$siteID = $historyData['siteID'];
			$response['_'.$siteID] = $responseData['success'];
			
			//storing the result
			$recentWPMScheduleKey = getOption('recentWPMScheduleKey');
			
			DB::insert("?:temp_storage", array('type' => 'wpOptimize', 'paramID' => $actionID, 'time' => time(), 'data' =>  serialize($response)));
			DB::insert("?:wp_optimize_schedules_result", array('scheduleKey' => $recentWPMScheduleKey, 'time' => time(), 'data' =>  serialize($response)));
			DB::update("?:history_additional_data", array('status' => 'success', 'errorMsg' => $responseData['success'] ), "historyID=".$historyID."");
		} */
	}
	
	public static function wpOptimizeDeleteTaskProcessor($siteIDs=array(), $params){
		
		$type = "wpOptimize";
		$action = "deleteTask";
		$requestAction = "delete_schedule_task";
		$timeout = (20 * 60);
		$where = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey' => $params['scheduleKey']
					)
				);		
		$schedule = DB::getRow("?:wp_optimize_schedules", "scheduleID,backupName", $where);
		$where = array(
		      		'query' =>  "scheduleID=':scheduleID'",
		      		'params' => array(
		               ':scheduleID' => $schedule['scheduleID']
					)
				);
		$sites = DB::getArray("?:wp_optimize_schedules_link", "siteID", $where);
		
		$requestParams = array('task_name' => $params['scheduleKey']);
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => $schedule['backupName'], 'detailedAction' => $action);
		
		//if(empty($sites)){
		$where = array(
		      		'query' =>  "scheduleKey=':scheduleKey'",
		      		'params' => array(
		               ':scheduleKey' => $params['scheduleKey']
					)
				);	
			$scheduleID = DB::getField("?:wp_optimize_schedules", "scheduleID", $where);
			$where1 = array(
		      		'query' =>  "scheduleID=':scheduleID'",
		      		'params' => array(
		               ':scheduleID' => $scheduleID
					)
				);
			DB::delete("?:wp_optimize_schedules_link", $where1);
			DB::delete("?:wp_optimize_schedules", $where);
			DB::delete("?:wp_optimize_schedules_result", $where);
		//}
		
		foreach($sites as $site){
			$sIDs[] = $site['siteID'];
		}
		
		foreach($sIDs as $siteID){
			$siteData = getSiteData($siteID);		
			
			$events=1;
			
			$PRP = array();
			$PRP['requestAction'] 	= $requestAction;
			$PRP['requestParams'] 	= $requestParams;
			$PRP['siteData'] 		= $siteData;
			$PRP['type'] 			= $type;
			$PRP['action'] 			= $action;
			$PRP['events'] 			= $events;
			$PRP['historyAdditionalData'] 	= $historyAdditionalData;
			$PRP['timeout'] 		= $timeout;
			
			if($params['scheduleType'] == 'cron'){
				$PRP['scheduleTime'] 		= $params['scheduleTime'];
			}
				
			prepareRequestAndAddHistory($PRP);
		}
	}
	
	public static function wpOptimizeDeleteTaskResponseProcessor($historyID, $responseData){
		
		if(!empty($responseData['error'])){
			$where = array(
			      		'query' =>  "historyID=':historyID'",
			      		'params' => array(
			               ':historyID' => $historyID
						)
					);	
			DB::update("?:history_additional_data", "status='error' ,errorMsg = '".$responseData['success']['error']."'", $where);	
		}
		
		if(!empty($responseData['success'])){
			$where = array(
			      		'query' =>  "historyID=':historyID'",
			      		'params' => array(
			               ':historyID' => $historyID
						)
					);	
			DB::update("?:history_additional_data", "status='success'", $where);
			$where = array(
			      		'query' =>  "scheduleKey=':scheduleKey'",
			      		'params' => array(
			               ':scheduleKey' => $responseData['success']
						)
					);	
			$scheduleID = DB::getField("?:wp_optimize_schedules", "scheduleID", $where);
			$where1 = array(
			      		'query' =>  "scheduleID=':scheduleID'",
			      		'params' => array(
			               ':scheduleID' => $scheduleID
						)
					);	
			DB::delete("?:wp_optimize_schedules_link", $where1);
			DB::delete("?:wp_optimize_schedules", $where);
		}
		//---------------------------post process------------------------>
		$where = array(
		      		'query' =>  "historyID=':historyID'",
		      		'params' => array(
		               ':historyID' => $historyID
					)
				);	
		$siteID = DB::getField("?:history", "siteID", $where);	
		$allParams = array('action' => 'getStats', 'args' => array('siteIDs' => array($siteID), 'extras' => array('sendAfterAllLoad' => false, 'doNotShowUser' => true)));		
		panelRequestManager::handler($allParams);
	}

	public static function wpClearCacheProcessor($siteIDs, $params){
		
		$type = "wp";
		$action = "wpClearCache";
		$requestAction = "wp_purge_cache";
			  
		$requestParams = $params;	
		
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => "wpClearCache", 'detailedAction' => $type);
		  
		  foreach($siteIDs as $siteID){
			  $siteData = getSiteData($siteID);
			  $events=1;
			  
			  $PRP = array();
			  $PRP['requestAction'] 			= $requestAction;
			  $PRP['requestParams'] 			= $requestParams;
			  $PRP['siteData'] 					= $siteData;
			  $PRP['type'] 						= $type;
			  $PRP['action'] 					= $action;
			  $PRP['events'] 					= $events;
			  $PRP['sendAfterAllLoad'] 			= true;
			  $PRP['historyAdditionalData'] 	= $historyAdditionalData;
						
			  prepareRequestAndAddHistory($PRP);
		  }
		
	}

	public static function wpClearCacheResponseProcessor($historyID, $responseData){
		
		responseDirectErrorHandler($historyID, $responseData);
		  
		  if( empty($responseData['success'])  ){
			  return false;
		  }
	
		  $updateLink = array();
		  if(!empty($responseData['success'])){
		  	$where = array(
			      		'query' =>  "historyID=':historyID'",
			      		'params' => array(
			               ':historyID' => $historyID
						)
					);
			$historyData = DB::getRow("?:history", "type, actionID, siteID", $where);
			$actionID = $historyData['actionID'];
			$siteID = $historyData['siteID'];
			$response['_'.$siteID] = $responseData['success'];
			$result_response[$siteID] = $responseData['success'];
			
			//storing the result
			
			DB::insert("?:temp_storage", array('type' => 'wpOptimize', 'paramID' => $actionID, 'time' => time(), 'data' =>  serialize($response)));
			$where = array(
			      		'query' =>  "historyID=':historyID'",
			      		'params' => array(
			               ':historyID' => $historyID
						)
					);
			DB::update("?:history_additional_data", "status='success'", $where);

			DB::update("?:history_additional_data", array('status' => 'success', 'errorMsg' => serialize($responseData['success']) ), $where);
			
		}
		
	}
}
manageClients::addClass('manageClientsWpOptimize');
?>