<?php 

function yoastWpSeoAddonMenus(&$menus){
	$menus['monitor']['subMenus'][] = array('page' => 'yoastWpSeo', 'displayName' => 'WP SEO by Yoast');
}

function yoastWpSeoResponseProcessors(&$responseProcessor){
	$responseProcessor['yoastWpSeo']['getSEOInfo'] = 'yoastSEOGetInfo';
	$responseProcessor['yoastWpSeo']['saveSEOInfo'] = 'yoastSEOSaveInfo';
}

function yoastWpSeoTaskTitleTemplate(&$template){
	$template['yoastWpSeo']['getSEOInfo']['']	= "Get WP SEO data from <#sitesCount#> site<#sitesCountPlural#>";
	$template['yoastWpSeo']['saveSEOInfo']['']	= "Save WP SEO data to <#sitesCount#> site<#sitesCountPlural#>";
}

function yoastSEOGetInfo(){
	$actionID = Reg::get('currentRequest.actionID');
	$linksData = DB::getFields("?:temp_storage", "data", "type = 'yoastWpSeo' AND paramID = '".$actionID."'");
	
	DB::delete("?:temp_storage", "type = 'yoastWpSeo' AND paramID = '".$actionID."'");
		
	if(empty($linksData)){
		return array();
	}
	$refinedData = array();

	foreach($linksData as $data){
		$refinedData = array_merge_recursive($refinedData, (array)unserialize($data));	
	}
	arrayMergeRecursiveNumericKeyHackFix($refinedData);
	foreach($refinedData as $siteID => $links){
		$siteData = DB::getRow("?:sites","URL","siteID=".$siteID."");
		$refinedData['siteURLs'][] = $siteData['URL'];
		$refinedData['siteIDs'][] = $siteID;
	}


	return $refinedData;
}

function yoastSEOSaveInfo(){
	$actionID = Reg::get('currentRequest.actionID');
	$linksData = DB::getFields("?:temp_storage", "data", "type = 'yoastWpSeo' AND paramID = '".$actionID."'");

	
	DB::delete("?:temp_storage", "type = 'yoastWpSeo' AND paramID = '".$actionID."'");
		
	if(empty($linksData)){
		return array();
	}
	$refinedData = array();

	foreach($linksData as $data){
		$refinedData = array_merge_recursive($refinedData, (array)unserialize($data));	
	}
	arrayMergeRecursiveNumericKeyHackFix($refinedData);
	foreach($refinedData as $siteID => $links){
		$siteData = DB::getRow("?:sites","URL","siteID=".$siteID."");
		$refinedData['siteURLs'][] = $siteData['URL'];
		$refinedData['siteIDs'][] = $siteID;
	}

	return $refinedData;
}
