<?php
/**
 * Created by PhpStorm.
 * User: michael
 * Date: 24/11/2015
 * Time: 1:20 PM
 */

require_once WPSG_INCLUDE_DIR . '/IDS/Log/Interface.php';

class WPSG_IDSEmailer implements IDS_Log_Interface {

	protected $wpsg = null;

	public function __construct($wpsg) {
		$this->wpsg = $wpsg;
	}

	public function execute(IDS_Report $report) {
		$name = get_bloginfo('name');
		$subject = "WP Site Guardian [$name]: Possible intrusion attack";
		$protocol = (isset($_SERVER["HTTPS"]) && "on" === $_SERVER["HTTPS"]) ? "https" : "http";
		$url = $protocol . '://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];

		$email = '';
		$email .= 'Time: ' . date('Y-m-d H:i:s', time()) . "\n";
		$email .= 'URL: ' . sanitize_text_field($url) . "\n";



		foreach( $report as $event ) {
			$email .= "\n";
			$email .= '**********************************************' . "\n";
			$email .= 'Parameter: ' . sanitize_text_field($event->getName()) . "\n";
			$email .= 'Data: ' . sanitize_text_field($event->getValue()) . "\n";
			$email .= 'Impact: ' . $event->getImpact() . '/' . $report->getImpact() . "\n";
			$email .= 'Potential Vectors: ' . $this->wpsg->format_tags($event->getTags(),', ') . "\n";
		}
		$to = get_option('admin_email');

		if (filter_var($this->wpsg->get_option('admin_email_address'), FILTER_VALIDATE_EMAIL)) {
			$to = $this->wpsg->get_option('admin_email_address');
		}

		wp_mail( $to, $subject, $email );

		return true;
	}
}
