<?php

/*
slug: malwareScanningSucuri
version: 2.2.0
*/

class addonMalwareScanningSucuri{
	
	private static $version = '2.2.0';

	public static function version(){
		return self::version;	
	}
	
	public static function init(){
		require_once(APP_ROOT."/addons/malwareScanningSucuri/controllers/func.php");
		require_once(APP_ROOT."/addons/malwareScanningSucuri/controllers/manageClientsMalwareScanningSucuri.php");
		panelRequestManager::addFunctions( 'malwareScanningSucuriGet','getMalwareData','malwareScanningSucuriLoadIWPUser');
		regHooks('addonMenus','responseProcessors', 'taskTitleTemplate', 'headHTMLFiles');
	}

	public static function install(){
		$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:malware_schedule_sites` (
		  `siteID` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  `scheduleID` int(10) unsigned NOT NULL ,
  		  `nextSchedule` bigint(20) unsigned DEFAULT NULL,
 		  `status` varchar(50) NOT NULL DEFAULT '',
  		  PRIMARY KEY (`siteID`)
		)".DB::getSQLTableEnv().";");

		$Q2 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:malware_schedule_result` (
		  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  `siteID` int(10) unsigned NOT NULL,
		  `historyID` int(10) unsigned NOT NULL,
		  `scheduleID` int(10) unsigned NOT NULL,
  		  `time` bigint(20) unsigned DEFAULT NULL,
 		  `result` enum('success', 'malware', 'scheduled', 'failure') DEFAULT NULL ,
  		  PRIMARY KEY (`ID`),
  		  UNIQUE KEY `historyID` (`historyID`)
		)".DB::getSQLTableEnv().";");

		if($Q1 && $Q2){
			return true;	
		}
		return false;
	}

	public static function update(){//1.0.1 => 1.0.2
		
		if((DB::getExists("SHOW TABLES LIKE '?:other_history'"))){
			$where = array(
						'query' =>  "type = ':type'",
						'params' => array(
							':type' => 'malwareScanningSucuri'
						)
					);
			$otherHistoryDatas = DB::getArray("?:other_history", "*", $where);

			
			$userID = (isset($GLOBALS['userID']) && !empty($GLOBALS['userID']))?$GLOBALS['userID']:$_SESSION['userID'];
			foreach($otherHistoryDatas as $key => $otherHistoryData){
				$historyAdditionalData = array();
				
				if($otherHistoryData['status'] == 'completed') $historyAdditionalDataStatus = 'success';
				if($otherHistoryData['status'] == 'initiated') $historyAdditionalDataStatus = 'pending';
				$historyAdditionalData[] = array('uniqueName' => $otherHistoryData['type'], 'detailedAction' => $otherHistoryData['action'], 'status' => $historyAdditionalDataStatus);
		
				$historyData = array('siteID' => $otherHistoryData['siteID'], 'actionID' => uniqid('', true), 'userID' => $userID, 'type' => $otherHistoryData['type'], 'action' => $otherHistoryData['action'], "status" => $otherHistoryData['status'], 'isPluginResponse' => '0', 'microtimeAdded' => $otherHistoryData['microtimeAdded'],  'microtimeInitiated' => $otherHistoryData['microtimeAdded'], 'microtimeStarted' => $otherHistoryData['microtimeStarted'], 'microtimeEnded' => $otherHistoryData['microtimeEnded'], 'showUser' => 'N', 'timeout' => 45);	
		
				$historyID = addHistory($historyData, $historyAdditionalData);
				
				//if(empty($historyID) && isset($historyID)){ return false; }
			}
			DB::doQuery("DROP TABLE `?:other_history`");
			return true;
		}
		$where = array(
					'query' =>  "type = ':type' AND status = ':status' AND microtimeInitiated IS NULL",
					'params' => array(
						':type' => 'malwareScanningSucuri',
						':status' => 'initiated'
					)
				);
		DB::update("?:history", "microtimeInitiated = microtimeAdded", $where);
		if(version_compare(getOldAddonVersion('malwareScanningSucuri'), '1.1.9beta1', '<')){
			$deleteFiles = array('/addons/malwareScanningSucuri/initHTMLHead.php' => array('type' => 'f') );
			fileSystemRemoveFiles($deleteFiles);
		}

		if (version_compare(getOldAddonVersion('malwareScanningSucuri'), '2.0.0beta1', '<')) {
			$Q1 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:malware_schedule_sites` (
			  `siteID` int(10) unsigned NOT NULL AUTO_INCREMENT,
			  `scheduleID` int(10) unsigned NOT NULL ,
	  		  `nextSchedule` bigint(20) unsigned DEFAULT NULL,
	 		  `status` varchar(50) NOT NULL DEFAULT '',
	  		  PRIMARY KEY (`siteID`)
			)".DB::getSQLTableEnv().";");

			$Q2 = DB::doQuery("CREATE TABLE IF NOT EXISTS `?:malware_schedule_result` (
			  `ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
			  `siteID` int(10) unsigned NOT NULL,
			  `historyID` int(10) unsigned NOT NULL,
			  `scheduleID` int(10) unsigned NOT NULL,
	  		  `time` bigint(20) unsigned DEFAULT NULL,
	 		  `result` enum('success', 'malware', 'scheduled', 'failure') DEFAULT NULL,
	  		  PRIMARY KEY (`ID`),
	  		  UNIQUE KEY `historyID` (`historyID`)
			)".DB::getSQLTableEnv().";");

			if(!$Q1 && !$Q2){
				return false;	
			}
			
		}
		return true;
	}
}

?>