<?php 
function malwareScanningSucuriAddonMenus(&$menus){
	//$menus[] = '<li><a class="navLinks optionSelect" page="malwareSecurity">Malware Scan</a></li>';
	$menus['protect']['subMenus'][] = array('page' => 'malwareSecurity', 'displayName' => 'Malware Scan');
}

function malwareScanningSucuriResponseProcessors(&$responseProcessor){
	$responseProcessor['malwareScanningSucuriFetch']['fetchResult'] = 'malwareScanningSucuriFetchResult';
	$responseProcessor['malwareScanningSucuri']['scan'] = 'malwareScanningSucuriScan';
	$responseProcessor['malwareScanningSucuri']['changeAlertMail'] = 'malwareScanningSucuriScan';
}

function malwareScanningSucuriTaskTitleTemplate(&$template){
	$template['malwareScanningSucuriFetch']['fetchResult']['']			= "Loading malware scan results from <#sitesCount#> site<#sitesCountPlural#>"; //Scan for malware in 11 sites	
	$template['malwareScanningSucuri']['scan']['']			= "Scan for malware in<#sitesCount#> site<#sitesCountPlural#>"; //Scan for malware in 11 sites	
	$template['malwareScanningSucuri']['changeAlertMail']['']			= "Changing alert mail for malware in<#sitesCount#> site<#sitesCountPlural#>"; //Scan for malware in 11 sites	
}

function malwareScanningSucuriGet(){
	
	$actionID = array("actionId" => Reg::get('currentRequest.actionID'));
	$scanDetails = getMalwareData($actionID);
	$malwareResult = malwareScanningSucuriFormatData($scanDetails);
	return $malwareResult;

}

function getMalwareData($args) {
	$recheck = false;
	$actionID = Reg::get('currentRequest.actionID');
	$where = array(
	      		'query' =>  "type = ':type' AND paramID = ':paramID'",
	      		'params' => array(
	               ':type'=>'malwareScanningSucuri',
	               ':paramID'=>$actionID
   				)
			);
	$linksData = DB::getFields("?:temp_storage", "data", $where);
	DB::delete("?:temp_storage", $where);
		
	if(empty($linksData)){
		return array();
	}
	$refinedData = array();

	foreach($linksData as $data){
		$refinedData = array_merge_recursive($refinedData, (array)unserialize($data));	
	}
	arrayMergeRecursiveNumericKeyHackFix($refinedData);

    return $refinedData;
	
}

function malwareScanningSucuriFormatData($data){
	$formatedResult = array();
	$siteIDs = array();
	$cleanedCounts = 0;
	$affectedCounts = 0;
	foreach ($data as $key => $value) {
		$scanDetails = $value['entries']['scan_results'];
		$time = $value['info']['updated_on'];
		if (isset($scanDetails['MALWARE']['WARN']) || isset($scanDetails['BLACKLIST']['WARN'])){
			$formatedResult['affected'][$key]['time']=@date(Reg::get('dateFormatLong'), $time);
			$formatedResult['siteIDs'][]=$key;
			$formatedResult['affectedCounts']=++$affectedCounts;
		}else{
			$formatedResult['clean'][$key]['time']=@date(Reg::get('dateFormatLong'), $time);
			$formatedResult['siteIDs'][]=$key;
			$formatedResult['cleanedCounts']=++$cleanedCounts;
		}
	}
	return $formatedResult;
}



function malwareScanningSucuriLoadIWPUser(){
	$where = "userID = ".$GLOBALS['userID']." AND status = '1' ORDER BY userID ASC LIMIT 1";
	return DB::getArray("?:users", "*", $where);
}

function malwareScanningSucuriHeadHTMLFiles(&$headFiles){
	$addonDetails['version'] = getAddonVersion('malwareScanningSucuri');
	$addonDetails['files'] = array(
		array('css' => array('href' => 'addons/malwareScanningSucuri/css/malwareScanningSucuri.css')),
		array('js' => array('href' => 'addons/malwareScanningSucuri/js/functions.js')),
		array('js' => array('href' => 'addons/malwareScanningSucuri/js/init.js')),
		array('js' => array('href' => 'addons/malwareScanningSucuri/js/load.js')),
	);
	$headFiles['malwareScanningSucuri'] = $addonDetails;
	$malwareScanAutoScanning =  panelRequestManager::requiredData(array("malwareScanAutoScanning"=>1));
	$isAdmin = userStatus()=="admin"?1:0;
	?>
	<script >
	var isAdmin =   "<?php echo $isAdmin; ?>";
	var malwareScanAutoScanning = <?php echo empty($malwareScanAutoScanning['malwareScanAutoScanning']) ? 0 : 1;?>
	</script>
	<?php
}
