<?php
class manageClientsMalwareScanningSucuri{
	
	public static function malwareScanningSucuriFetchResultProcessor($siteIDs, $params){
		
		$type = "malwareScanningSucuriFetch";
		$action = "fetchResult";
		$requestAction = "sucuri_fetch_result";
		
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => 'malwareScanningSucuri', 'detailedAction' => 'scanFetchResult');
		$events=1;
		foreach ($siteIDs as $siteID) {
			$siteData = getSiteData(intval($siteID));
			$PRP = array();
			$PRP['requestAction'] 	= $requestAction;
			$PRP['siteData'] 		= $siteData;
			$PRP['type'] 			= $type;
			$PRP['action'] 			= $action;
			$PRP['directExecute'] 	= false;
			$PRP['events'] 			= $events;
			$PRP['sendAfterAllLoad'] = true;
			$PRP['historyAdditionalData'] 	= $historyAdditionalData;
			prepareRequestAndAddHistory($PRP);
		}
	}
	
	public static function malwareScanningSucuriFetchResultResponseProcessor($historyID, $responseData){
		responseDirectErrorHandler($historyID, $responseData);
		$response = array();
		if(isset($responseData['success'])){
			$where = array(
			      		'query' =>  "historyID=:historyID",
			      		'params' => array(
			               ':historyID'=>$historyID
						)
					);
			$historyData = DB::getRow("?:history", "type, actionID, siteID", $where);
			$actionID = $historyData['actionID'];
			$siteID = $historyData['siteID'];
			$response['_'.$siteID] = $responseData['success'];
			
			DB::insert("?:temp_storage", array('type' => 'malwareScanningSucuri', 'paramID' => $actionID, 'time' => time(), 'data' =>  serialize($response)));
			DB::update("?:history_additional_data", "status='success'", $where);
			return;
		}
	}

	public static function malwareScanningSucuriScanProcessor($siteIDs=array(), $params, $extras=array()){
		$type = "malwareScanningSucuri";
		$action = "scan";
		$requestAction = "sucuri_scan";
		
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => 'malwareScanningSucuri', 'detailedAction' => 'runScan');
		$events=1;
		foreach ($siteIDs as $siteID) {
			$siteData = getSiteData(intval($siteID));
			$PRP = array();
			$PRP['requestAction'] 	= $requestAction;
			$PRP['siteData'] 		= $siteData;
			$PRP['type'] 			= $type;
			$PRP['action'] 			= $action;
			$PRP['directExecute'] 	= false;
			$PRP['events'] 			= $events;
			$PRP['sendAfterAllLoad'] = true;
			$PRP['historyAdditionalData'] 	= $historyAdditionalData;
			prepareRequestAndAddHistory($PRP);
		}
	}

	public static function malwareScanningSucuriScanResponseProcessor($historyID, $responseData){
		responseDirectErrorHandler($historyID, $responseData);
		$response = array();
		if(isset($responseData['success'])){
			$where = array(
			      		'query' =>  "historyID=:historyID",
			      		'params' => array(
			               ':historyID'=>$historyID
						)
					);
			$historyData = DB::getRow("?:history", "type, actionID, siteID", $where);
			$actionID = $historyData['actionID'];
			$siteID = $historyData['siteID'];
			$response['_'.$siteID] = $responseData['success'];
			
			DB::insert("?:temp_storage", array('type' => 'malwareScanningSucuri', 'paramID' => $actionID, 'time' => time(), 'data' =>  serialize($response)));
			DB::update("?:history_additional_data", "status='success'", $where);
			return;
		}
	}

	public static function malwareScanningSucuriChangeAlertMailProcessor($siteIDs, $params){
		$type = "malwareScanningSucuri";
		$action = "changeAlertMail";
		$requestAction = "sucuri_change_alert";
		
		$historyAdditionalData = array();
		$historyAdditionalData[] = array('uniqueName' => 'malwareScanningSucuri', 'detailedAction' => 'changeAlertMail');
		$events=1;
		foreach ($siteIDs as $siteID) {
			$siteData = getSiteData(intval($siteID));
			$PRP = array();
			$PRP['requestAction'] 	= $requestAction;
			$PRP['requestParams'] 	= $params;
			$PRP['siteData'] 		= $siteData;
			$PRP['type'] 			= $type;
			$PRP['action'] 			= $action;
			$PRP['directExecute'] 	= false;
			$PRP['events'] 			= $events;
			$PRP['sendAfterAllLoad'] = true;
			$PRP['historyAdditionalData'] 	= $historyAdditionalData;
			prepareRequestAndAddHistory($PRP);
		}
	}

	public static function malwareScanningSucuriChangeAlertMailResponseProcessor($historyID, $responseData){
		responseDirectErrorHandler($historyID, $responseData);
		$response = array();
		if(isset($responseData['success'])){
			$where = array(
			      		'query' =>  "historyID=:historyID",
			      		'params' => array(
			               ':historyID'=>$historyID
						)
					);
			$historyData = DB::getRow("?:history", "type, actionID, siteID", $where);
			$actionID = $historyData['actionID'];
			$siteID = $historyData['siteID'];
			$response['_'.$siteID] = $responseData['success'];
			
			DB::insert("?:temp_storage", array('type' => 'malwareScanningSucuri', 'paramID' => $actionID, 'time' => time(), 'data' =>  serialize($response)));
			DB::update("?:history_additional_data", "status='success'", $where);
			return;
		}
	}

}

manageClients::addClass('manageClientsMalwareScanningSucuri');
?>